* Prepare Pac Man Sample for the CoCo3
* save only the top six bits of each sample byte and join the six bits together to reduce the size of the sample data
* as we are getting close to filling an entire diskette image
		ORG		$FC00
Start
		ORCC	#$50
		LDX		#PicEnd
		BSR		Fix8to6bit
        BSR     DecompresssAudio
        LDU     EndofCompressedData
!
        BRA     <


* strip off lower two bits of audio
* X = memory location where the sample ends
* Return U with the end location of the
Fix8to6bit:
		LDU		#$8002
		STX		$8000       * Store the size of the sample in the first 2 bytes of the output stream
		LDX		#$0000
!		LDD		,X++
		LSRA
		LSRA
		ASLB
		ROLA
		ASLB
		ROLA			* A = A 6 bits and B top two bits - B top four bits are good bottom four can be over written
		STA		,U+		* Save Good A
		LSRB
		LSRB
		LSRB
		LSRB		
		LDA		,X+
		ROLA
		ROLB
		ROLA
		ROLB
		ROLA
		ROLB
		ROLA
		ROLB			* B now has end of 2nd byte and first four bits of byte 3, A top two bits are good
		STB		,U+
		ROLA
		ROLB
		ROLA
		ROLB			* B first two bits are lsb of byte 3
		LDA		,X+
		ROLA
		ROLB
		ROLA
		ROLB
		ROLA
		ROLB
		ROLA
		ROLB
		ROLA
		ROLB
		ROLA
		ROLB			* B now has byte 3 and 6 good bits of byte 4
		STB		,U+
		CMPX	EndofSample
		BLO		<
		LEAU	-1,U	* Last byte that was written
        LEAU    -$8000,U
        STU     EndofCompressedData
        RTS
* Decompress data back for a test
* Point compressed sample data at $8000 to $FBFF
* will decompress to $0000 to $7FFF
* will return with X = length of uncompressed sample
DecompresssAudio:
        LDX     #$8002
        LDU     #$0000
!       LDA     ,X
        ANDA    #$FC
        STA     ,U+     * A now has the first byte
        LDD     ,X++
        ROLB
        ROLA
        ROLB
        ROLA
        ROLB
        ROLA
        ROLB
        ROLA
        ASLA
        ASLA            * A now has the 2nd byte, B has good top 4 bits of byte 3
        STA     ,U+
        LSRB
        LSRB
        LSRB
        LSRB            * B now has the good data in the low 4 bits
        LDA     ,X+
        ASLA
        ROLB
        ASLA            * A now has the 4th byte
        ROLB
        ASLB
        ASLB            * B now has the 3rd byte
        STB     ,U+
        STA     ,U+
        CMPU    $8000
        BLO     <
		RTS
EndofSample:
		FDB		PicEnd
EndofCompressedData:
        FDB     $0000

* Include the Sample here from 0000 to $7FFF
* output will be stored in $8000 to $FD00
		ORG		$0000
PicStart:
		INCLUDEBIN ./Pacman_Samples/new_06_looped_4-Times.raw
PicEnd:
		END     Start
