; This is the first stage loader. It runs from a multi-segment LOADM or
; CLOADM binary file. The payload is loaded at physical address $0000 and then
; control is transferred to address $0000. Simply append the payload to the
; end of the assembled file. Everything after the postable is considered
; payload, all the way to the end of the file.
;
; Load at $2000 to avoid clobbering DECB system variables. This will be the
; case in most circumstances.
		org $2000
begin
		ldd     #$176		* put the close stuff back to rights
		std     $A42E		* in case something errors out
        LDX     #$400
        LDU     #ScreenMessage
!       LDD     ,U++
        STD     ,X++
        CMPX    #$600
        BNE     <
		clrb                * set first memory load block
		ldx     #$4000		* set start address for loading payload
begin1
		stb     $FFA2		* set destination memory block
begin0
		jsr     $A176		* get a byte from file
		tst     <$70		* was there a byte to read?
		bne     finished	* brif EOF reached
		sta     ,x+			* save byte in memory
        CMPX    #$5000
        BNE     >
        BSR     UpdateLoader
!		cmpx    #$6000		* end of current memory block?
		blo     begin0		* brif not - fetch another byte
		incb                * bump memory block number
        BSR     UpdateLoader
		ldx     #$4000		* reset load address to start of block
		bra     begin1		* go fetch another byte
finished
        BSR     DecompMess
        jsr     $A42D		* close the file (to be polite)
		clr     <$71		* force basic cold start on reset
		clr     <$72		*
		clr     <$73		*
		orcc    #$50		* kill interrupts
        LDA     #$3A
        STA     $FFA2       * Set BLK 2 to normal
		clr     $FFA0		* get block 0 to address 0
        CLR     $FFD9       * High Speed mode enabled
nomagic
        LDX     #0000
        LDY     #$AF1F
!       LDD     ,X++
        STD     ,Y++
        CMPY    #$B000
        BLO     <
        JMP     $AF1F   jump to stage two loader

UpdateLoader:
        PSHS    A,X
        LDA     #$AF
        LDX     LoadPoint
        STA     ,X+
        STX     LoadPoint
        PULS    A,X,PC
DecompMess:
        PSHS    A,X,U
        LDA     #$AF
        LDX     #$600-$17
        LDU     #DMess
!       LDA     ,U+
        BEQ     >
        STA     ,X+
        BRA     <
!       PULS    A,X,U,PC

* Pacman screen loader
ScreenMessage:
    FCB $80
;    FCC     'PACMAN Z80 TRANSCODE TO COCO 3'
    FCB 16,1,3,13,1,14,32
    FCB 26,56,48,32
    FCB 20,18,1,14,19,3,15,4,5,32
    FCB 20,15,32
    FCB 3,15,3,15,32,51
    FCB $80
	FCB	$80,$80,$80,$80,$80,$80,$80,$80,$80,$80,$80,$80,$80,$80,$80,$80,$80,$80,$80,$80,$80,$80,$80,$80,$80,$80,$80,$80,$80,$80,$80,$80
	FCB	$80,$80,$80,$80,$80,$80,$80,$80,$80,$80,$80,$FF,$FF,$FF,$FF,$FF,$FF,$FF,$80,$80,$80,$80,$80,$80,$80,$80,$80,$80,$80,$80,$80,$80
	FCB	$80,$80,$80,$80,$80,$80,$80,$80,$FF,$FF,$FF,$FF,$FF,$FF,$FF,$FF,$FF,$FF,$FF,$FF,$FF,$80,$80,$80,$80,$80,$80,$80,$80,$80,$80,$80
	FCB	$80,$80,$80,$80,$80,$80,$FF,$FF,$FF,$FF,$FF,$FF,$FF,$FF,$FF,$FF,$FF,$FF,$FF,$FF,$FF,$FF,$FF,$80,$80,$80,$80,$80,$80,$80,$80,$80
	FCB	$80,$80,$80,$80,$80,$80,$FF,$FF,$FF,$FF,$FF,$FF,$FF,$FF,$FF,$FF,$FF,$FF,$FF,$FF,$FF,$FF,$FF,$80,$80,$80,$80,$80,$80,$80,$80,$80
	FCB	$80,$80,$80,$80,$FF,$FF,$FF,$FF,$FF,$FF,$FF,$FF,$FF,$FF,$FF,$FF,$FF,$FF,$FF,$80,$80,$80,$80,$80,$80,$80,$80,$80,$80,$80,$80,$80
	FCB	$80,$80,$80,$80,$FF,$FF,$FF,$FF,$FF,$FF,$FF,$FF,$FF,$FF,$FF,$80,$80,$80,$80,$80,$80,$80,$80,$80,$80,$80,$80,$80,$80,$80,$80,$80
	FCB	$80,$80,$80,$80,$FF,$FF,$FF,$FF,$FF,$FF,$FF,$80,$80,$80,$80,$80,$80,$80,$cf,$cf,$80,$80,$80,$80,$cf,$cf,$80,$80,$80,$80,$cf,$cf
	FCB	$80,$80,$80,$80,$FF,$FF,$FF,$FF,$FF,$FF,$FF,$FF,$FF,$FF,$FF,$80,$80,$80,$80,$80,$80,$80,$80,$80,$80,$80,$80,$80,$80,$80,$80,$80
	FCB	$80,$80,$80,$80,$FF,$FF,$FF,$FF,$FF,$FF,$FF,$FF,$FF,$FF,$FF,$FF,$FF,$FF,$FF,$80,$80,$80,$80,$80,$80,$80,$80,$80,$80,$80,$80,$80
	FCB	$80,$80,$80,$80,$80,$80,$FF,$FF,$FF,$FF,$FF,$FF,$FF,$FF,$FF,$FF,$FF,$FF,$FF,$FF,$FF,$FF,$FF,$80,$80,$80,$80,$80,$80,$80,$80,$80
	FCB	$80,$80,$80,$80,$80,$80,$FF,$FF,$FF,$FF,$FF,$FF,$FF,$FF,$FF,$FF,$FF,$FF,$FF,$FF,$FF,$FF,$FF,$80,$80,$80,$80,$80,$80,$80,$80,$80
	FCB	$80,$80,$80,$80,$80,$80,$80,$80,$FF,$FF,$FF,$FF,$FF,$FF,$FF,$FF,$FF,$FF,$FF,$FF,$FF,$80,$80,$80,$80,$80,$80,$80,$80,$80,$80,$80
	FCB	22,$80,49,46,48,49,$80,$80,$80,$80,$80,$FF,$FF,$FF,$FF,$FF,$FF,$FF,$80,$80,$80,$80,$80,$80,$80,$80,$80,$80,$80,$80,$80,$80

    FCB $80,$80,$80,$80,$80,$80,$80,$80,$80,$80
;    FCC     'LOADING...'
    FCB 12,15,1,4,9,14,7,46,46,46
    FCB $80,$80,$80,$80,$80,$80,$80,$80,$80,$80,$80,$80
DMess:
;    FCN     'DECOMPRESSING...'
    FCB 4,5,3,15,13,16,18,5,19,19,9,14,7,46,46,46,0
LoadPoint:
        FDB     $0600-$1D
Pointer:
* the following traps the "close" that happens as soon as the postamble is
* read; remember, this is a coco3 so basic is in RAM
		org $A42E
		fdb begin
		end begin

; How it works:
;
; This loader exploits the way LOADM and CLOADM are implemented to allow the
; payload to be loaded from the same file as the stub loader. LOADM and
; CLOADM call the standard basic CLOSE at $A42D immediately after reading
; the postamble. Furthermore, all byte reads from the file are done via the
; standard CONSOLE IN routine at $A176 (or by short circuiting directly into
; the relevant implementation in the case of LOADM).
;
; The first segment of the file consists of the actual first stage loader
; which assumes the currently open file is the kernel file and that the next
; byte to read is the first byte of the kernel payload.
;
; The second secment replaces the JSR $176 at the start of the CLOSE routine
; with "JSR begin" which will cause the loader to be executed BEFORE the file
; is closed but AFTER the first stage loader has been loaded. That means the
; loader will be started automatically with the kernel file still open.
;
; The loader itself restores the JSR $176 instruction. Then it reads all of
; the remaining bytes from the file to physical RAM starting at $00000 and
; proceeding upward. There is no inherent size limit in the code.
;
; Once the kernel is loaded, the file is closed. This is unnecessary but
; it's polite to do so. Besides, maybe this is being loaded through another
; scheme that does benefit from the file being closed and which is also
; compatible woth LOADM/CLOADM.
;
; The remainder of the loader does some book keeping to pass control to the
; just loaded payload.
