* 02 - tweak to work with Compiled Sprite locations
*************************************************************
* Changes the palette pointer from value of F = white for characters to low nibble of A
* A = Colour code (for now only using the right nibble as the value for our pixel)
* U = Destination location in Palette RAM we -$400 to get Video RAM value (Pac man screen memory $4000-$43FF) - Screen is rotated left so we have to acount
* for that location and rotation of the characters
* Handling of Pac Man Video RAM
* We Have a screen 32x36 total in an 8 pixel x 8 pixel location Pac Man uses only 28x36 leaving the left two chracters blank and the right two characters blank

ColourChar:
        PSHS    D,X,Y,U
		LEAU    -$400,U
        ANDA    #$0F
        STA     CPalRight
        ASLA
        ASLA
        ASLA
        ASLA
        STA     CPalLeft
        ORA     CPalRight
        STA     CPalBoth
        CMPU    #$403F              * Let's see if it's in main screen area first since most data will be here
        BHI     CheckMain_CC
BotScreen_CC:
        CMPU    #$4002
        LBLO    NoShow_CC
        CMPU    #$401E
        BLO     Line3_CC
        CMPU    #$4022
        LBLO    NoShow_CC
        CMPU    #$403D
        LBHI    NoShow_CC
Line4_CC:
        STU     Char_Temp
        LDD     #$403D
        SUBD    Char_Temp
        ASLB
        ASLB                        * B * 4 (4 bytes per character offeset for X value)
        LDU     #Screen_Start+128*8*35  * Bottom Line Starting Point
        LEAU    B,U                 * Add the X value
        JMP     ShowCharacter_CC
Line3_CC:
        STU     Char_Temp
        LDD     #$401D
        SUBD    Char_Temp
        ASLB
        ASLB                        * B * 4 (4 bytes per character offeset for X value)
        LDU     #Screen_Start+128*8*34  * 2nd from bottom Line Starting Point
        LEAU    B,U                 * Add the X value
        BRA     ShowCharacter_CC
CheckMain_CC:
        CMPU    #$43C0
        BLO     ShowMain_CC
CheckTop_CC:
        CMPU    #$43C2
        LBLO     NoShow_CC
        CMPU    #$43DE
        BLO     Line1_CC
        CMPU    #$43E2
        LBLO     NoShow_CC
        CMPU    #$43FD
        LBHI     NoShow_CC
Line2_CC:
        STU     Char_Temp
        LDD     #$43FD
        SUBD    Char_Temp
        ASLB
        ASLB                        * B * 4 (4 bytes per character offeset for X value)
        LDU     #Screen_Start+128*8 * 2nd Line Starting Point
        LEAU    B,U                 * Add the X value
        BRA     ShowCharacter_CC
Line1_CC:
        STU     Char_Temp
        LDD     #$43DD
        SUBD    Char_Temp
        ASLB
        ASLB                        * B * 4 (4 bytes per character offeset for X value)
        LDU     #Screen_Start       * Top Line Starting Point
        LEAU    B,U                 * Add the X value
        BRA     ShowCharacter_CC
ShowMain_CC:
        TFR     U,D
        PSHS    B                   * Pacman Y will be 5 LSB of B
        ANDB    #$1F
        STB     PacmanY
        PULS    B
        RORA
        RORB
        RORA
        RORB
        RORA
        RORB
        RORA
        RORB
        RORA
        RORB
        ANDB    #$1F                * B-2 = X Value of Pacman Hardware where 0 is the right side and 27 is the left side
        STB     PacmanX
        LDA     #29
        SUBA    PacmanX            * A now has proper X value for our character screen
        ASLA
        ASLA                        * A * 4 (4 bytes per character offeset for X value)
        LDU     #Screen_Start+128*16    * 2 top rows must be skipped for the proper X and Y character location to start from
        LEAU    A,U                 * Now it points to the correct X location
        LDB     PacmanY
        LDA     #8
        MUL                         * D now has our proper Y Character pointer location
        LDA     #128                * 8 * 128 = 1024 * Y value is the real location for our screen
        MUL
        LEAU    D,U                 * Add it together and Now U points to the correct Screen location
ShowCharacter_CC:
        TFR     U,D
        CLRB                        * Clear the Carry flag
        ANDA    #$E0
        RORA                        * Shift A to the right 5 times to get the block that will hold our character
        RORA
        RORA
        RORA
        RORA
        PSHS    A
        STA     MMU_Reg_Bank0_5
        TFR     U,D
        ANDA    #$1F
        ADDD    #$A005
        TFR     D,U
        LDB     #$08                * Do this 8 times
        PSHS    B,U
        BSR     >
        PULS    B,U
        PULS    A
        ADDA    #VideoRam1_0
;        STA     MMU_Reg_Bank0_5
;        BSR     >
NoShow_CC:                     		* Jump's here to skip showing any character as it is pointing to one of the special not shown locations
        PULS    D,X,Y,U,PC
PalCC_Loop:
!       LDA     ,U
        CMPA    #$4F
        BEQ     RN0
        CMPA    #$F4
        BEQ     LN0
        CMPA    #$FF
        BNE     >
        LDA     CPalBoth
        BRA     >
RN0     LDA     CPalRight
        BRA     >
LN0     LDA     CPalLeft
!       STA     ,U+
        LDA     ,U
        CMPA    #$4F
        BEQ     RN1
        CMPA    #$F4
        BEQ     LN1
        CMPA    #$FF
        BNE     >
        LDA     CPalBoth
        BRA     >
RN1     LDA     CPalRight
        BRA     >
LN1     LDA     CPalLeft
!       STA     ,U+
        LDA     ,U
        CMPA    #$4F
        BEQ     RN2
        CMPA    #$F4
        BEQ     LN2
        CMPA    #$FF
        BNE     >
        LDA     CPalBoth
        BRA     >
RN2     LDA     CPalRight
        BRA     >
LN2     LDA     CPalLeft
!       STA     ,U+
        LDA     ,U
        CMPA    #$4F
        BEQ     RN3
        CMPA    #$F4
        BEQ     LN3
        CMPA    #$FF
        BNE     >
        LDA     CPalBoth
        BRA     >
RN3     LDA     CPalRight
        BRA     >
LN3     LDA     CPalLeft
!       STA     ,U
        LEAU    125,U
        DECB
        BNE     PalCC_Loop
        RTS
