* V05 - changed to have 2 seperate routines depending if we are on Vid Buffer 0 or 1
*       it will take twice the memory but it will Blueuce all the checking during the routine
*     - Takes Sprite palette for input now and uses that info to figure out what type of sprite to draw
* V04 using Double buffering
*************************************************************
* DrawBlueSprite:  Similar to DrawSpriteNew but we can erase whatever Blue Ghost runs over, no need to restore dots or pills behind...
* Draws a 16 x 16 bit 16 colour sprite on the screen
* Compiled sprites routine blocks will already be in page 0 & 1
* X = X & Y coordinates
* A = Sprite source #
* B = Sprite Palette #   ($00 = Invisible, $11 = Dark Blue Ghost, $12 = White/Red Ghost, $18 = Score, $19 = Eyes going home)
DrawBlueSprite:
        CMPB    #$05                * Normal Blue Ghost Colour (most of the time)
        BEQ     BlueNormal          * Jump ahead if so
        CMPB    #$11                * If Palette is $11 then Ghosts are Dark Blue
        BEQ     BlueNormal          * Setup sprite as Dark Blue Ghost show same table # as Normal Ghosts
        CMPB    #$12                * If Palette is $12 then Ghosts are White/Red changing back to normal after Power Pill eaten
        BEQ     BlueWhiteBlue       * Setup sprite as White/Red Ghost
        CMPB    #$19                * If Palette is $19 then just ghost eyes showing
        BEQ     BlueShowEyes        * Anything Else is the Score show same table # as Normal Ghosts
        CMPB    #$18                * If Palette is $18 then Score so then treat as normal
        BEQ     BlueNormal          * Setup sprite as Score, show same table # as Normal Ghosts
* If we get this far then it is an invisible sprite so
BlueInvisible:
        LDA     #24                 * Entry 25 in table is a skip or simply RTS (Do not draw anything)
        BRA     >
BlueShowEyes:
		SUBA    #16                 * Adjust Sprite pointer to the Blue Ghost Table position
        BRA     >
BlueWhiteBlue:
		SUBA    #26                 * Adjust Sprite pointer to the Blue Ghost Table position
        BRA     >
BlueNormal:
		SUBA    #28                 * Adjust Sprite pointer to the Blue Ghost Table position
!       PSHS    A,X                 * Save the new X & Y coordinates and the new sprite # to be drawn
        LDA     VidBuffPointer      * Pointer to Buffer that is currently not being shown - will be changed at the end of the IRQ
        LBEQ    EraseBlueBuff0      * If 0 go update Buff0
EraseBlueBuff1:                     * First erase old Blue Ghost
        LDX     OldBlueLocation1
        LDD     OldBlueMemBlk1      * A=OldBlueMemBlk1, B=OldBlueSprite1
        STA     MMU_Reg_Bank0_5     * Point to the old Mem Block where Blue Ghost was last written
        INCA
        STA     MMU_Reg_Bank0_6
        LDU     #BlueTableErase     * Point to the blank version of the Blue Ghost sprite
        JSR     [B,U]               * draw the blank Blue Ghost sprite
        LDA     OldBlueDirection1
        LDU     OldBlueLocation1
        LDY     OldBlueXYPos1
        JSR     RestoreBehindGhosts
        PULS    B,X                 * restore the registers
        LSLB
        PSHS    B                   * Save pointer to sprite table on the stack
        TFR     X,D
        CMPA    #$09                * If X or Y co-ordinates are less then 9 then don't draw the sprite - Real Pacman hardware sprites would be off screen
        BLO     >
        CMPB    #$09
        BLO     >
        CMPA    #$E5                * If X or Y co-ordinates are above $E5 then don't draw the sprite - Real Pacman hardware sprites would be off screen
        BHI     >
        CMPB    #$EE
        BHI     >
        BRA     DrawNewBlue1
!       PULS    B,PC
DrawNewBlue1:
        LDX     #Screen_Start-8-3+128*17  * X points to the top left corner of the playfield (skip over the score and top of the maze)
		LSRA                        * two pixels per byte so divide the pixel location by two
		PSHS	CC					* if the carry is now set then X position is odd
        LEAX    A,X                 * Move to the proper X coordinate (memory location)
        LDA     #128                * 128 bytes per row, move us down in the Y direction
        MUL                         * B = Y coordinate * 128 gives us the memory location to show our Sprite
        LEAX    D,X                 * X now has the place in Video RAM to draw the Sprite
        TFR     X,D                 * Calculate which two memory blocks to get for writing to the screen memory in the Real VideoRAM and store them in $A000-$DFFF
        BITA    #$10
        BNE     >                   * Go if value is not betwwen 0000-0FFF or 2000-2FFF or 4000-4FFF or 6000-6FFF - handle it as normal
        BITA    #$E0
        BEQ     >                   * Skip if it's the range 0000-0FFF as we wont have any in this section
        CLRB                        * otherwise move it a block ahead so the sprite can be erased above it in memory
        ANDA    #$E0
        RORA                        * Shift A to the right 5 times to get the block that will hold our sprite
        RORA
        RORA
        RORA
        RORA
        DECA
        ADDA    #VideoRam1_0
        PSHS    A
        STA     MMU_Reg_Bank0_5
        INCA
        STA     MMU_Reg_Bank0_6
        TFR     X,D
        ANDA    #$1F
        ADDD    #$C000+8
        BRA     Blue_1
!       CLRB                        * Clear the Carry flag
        ANDA    #$E0
        RORA                        * Shift A to the right 5 times to get the block that will hold our character
        RORA
        RORA
        RORA
        RORA
        ADDA    #VideoRam1_0
        PSHS    A
        STA     MMU_Reg_Bank0_5           * 0 to 3
        INCA
        STA     MMU_Reg_Bank0_6
        TFR     X,D
        ANDA    #$1F
        ADDD    #$A000+8
Blue_1:
        TFR     D,X                 * X now points to the top left corner of where the sprite is in RAM ($A000-$DFFF)
        TFR     D,Y                 * Save it in Y also to be used when we draw what was behind the ghost
        PULS    A                   * get the Mem BLK that the sprite is using
        STX     OldBlueLocation1    * Save the New Pacman Location over the old
        STA     OldBlueMemBlk1      * Save the Mem BLK where Pac Man will be shown
        LDU     BlueXPos            * Save the Blue X & Y positions
        STU     OldBlueXYPos1
        LDB     BlueDirection
        STB     OldBlueDirection1
        LDU     #BlueTableEven
		PULS	CC
		LBCS    BlueOddPos1
BlueEvenPos1:
        PULS    B                   * Get Sprite Number
        BRA     >
BlueOddPos1:
        PULS    B                   * Get Sprite Number
        ADDB    #50                 * 25 entries * 2 bytes each = 50 which points to the Odd sprite table entries
!       STB     OldBlueSprite1
        JMP     [B,U]

EraseBlueBuff0:
        LDX     OldBlueLocation0
        LDD     OldBlueMemBlk0      * A=OldBlueMemBlk0, B=OldBlueSprite0
        STA     MMU_Reg_Bank0_5     * Point to the old Mem Block where Blue Ghost was last written
        INCA
        STA     MMU_Reg_Bank0_6
        LDU     #BlueTableErase     * Point to the blank version of the Blue Ghost sprite
        JSR     [B,U]               * draw the blank Blue Ghost sprite

        LDA     OldBlueDirection0
        LDU     OldBlueLocation0
        LDY     OldBlueXYPos0
        JSR     RestoreBehindGhosts


        PULS    B,X                 * restore the registers
        LSLB
        PSHS    B                   * Save pointer to sprite table on the stack
        TFR     X,D
        CMPA    #$09
        BLO     >
        CMPB    #$09
        BLO     >
        CMPA    #$E5
        BHI     >
        CMPB    #$EE
        BHI     >
        BRA     DrawNewBlue0
!       PULS    B,PC
DrawNewBlue0:
        LDX     #Screen_Start-8-3+128*17  * X points to the top left corner of the playfield (skip over the score and top of the maze)
		LSRA                        * two pixels per byte so divide the pixel location by two
		PSHS	CC					* if the carry is now set then X position is odd
        LEAX    A,X                 * Move to the proper X coordinate (memory location)
        LDA     #128                * 128 bytes per row, move us down in the Y direction
        MUL                         * B = Y coordinate * 128 gives us the memory location to show our Sprite
        LEAX    D,X                 * X now has the place in Video RAM to draw the Sprite
        TFR     X,D                 * Calculate which two memory blocks to get for writing to the screen memory in the Real VideoRAM and store them in $A000-$DFFF
        BITA    #$10
        BNE     >                   * Go if value is not betwwen 0000-0FFF or 2000-2FFF or 4000-4FFF or 6000-6FFF - handle it as normal
        BITA    #$E0
        BEQ     >                   * Skip if it's the range 0000-0FFF as we wont have any in this section
        CLRB                        * otherwise move it a block ahead so the sprite can be erased above it in memory
        ANDA    #$E0
        RORA                        * Shift A to the right 5 times to get the block that will hold our sprite
        RORA
        RORA
        RORA
        RORA
        DECA
        PSHS    A
        STA     MMU_Reg_Bank0_5
        INCA
        STA     MMU_Reg_Bank0_6
        TFR     X,D
        ANDA    #$1F
        ADDD    #$C000+8
        BRA     Blue_0
!       CLRB                        * Clear the Carry flag
        ANDA    #$E0
        RORA                        * Shift A to the right 5 times to get the block that will hold our character
        RORA
        RORA
        RORA
        RORA
        PSHS    A
        STA     MMU_Reg_Bank0_5           * 0 to 3
        INCA
        STA     MMU_Reg_Bank0_6
        TFR     X,D
        ANDA    #$1F
        ADDD    #$A000+8
Blue_0:
        TFR     D,X                 * X now points to the top left corner of where the sprite is in RAM ($A000-$DFFF)
        TFR     D,Y                 * Save it in Y also to be used when we draw what was behind the ghost
        PULS    A                   * get the Mem BLK that the sprite is using
        STX     OldBlueLocation0    * Save the New Pacman Location over the old
        STA     OldBlueMemBlk0      * Save the Mem BLK where Pac Man will be shown
        LDU     BlueXPos            * Save the Blue X & Y positions
        STU     OldBlueXYPos0
        LDB     BlueDirection
        STB     OldBlueDirection0
        LDU     #BlueTableEven
		PULS	CC
		LBCS    BlueOddPos0
BlueEvenPos0:
        PULS    B                   * Get Sprite Number
        BRA     >
BlueOddPos0:
        PULS    B                   * Get Sprite Number
        ADDB    #50                 * 25 entries * 2 bytes each = 50 which points to the Odd sprite table entries
!       STB     OldBlueSprite0
        JMP     [B,U]

