* 02 - Now using double buffering
*    - All Pacman sprites have now been hand compiled/blasted
*
******************************************************************
* DrawPacSprite:
* Draws a 16 x 16 bit 16 colour sprite on the screen
* Compiled sprites routine blocks will already be in page 0 & 1
* X = X & Y coordinates
* B = Sprite source #
* 44 PacRightBig, 45 PacDownBig, 46 PacRightNormal, 47 PacDownNormal, 48 PacClosed
* 49 PacLeftBig,  50 PacUpBig,   51 PacLeftNormal,  52 PacUpNormal,   53 PacClosed
******************************************************************
DrawPacSprite:
		SUBB    #44                 * Adjust Sprite pointer to the Pacman Table position
        PSHS    B,X                 * Save the new X & Y coordinates and the new sprite # to be drawn
        LDB     VidBuffPointer      * Pointer to Buffer that is currently not being shown - will be changed at the end of the IRQ
        BEQ     ErasePacBuff0       * First erase old Pac Man
ErasePacBuff1:
        LDD     OldPacMemBlk1       * A=OldPacMemBlk1, B=OldPacSprite1
        LDX     OldPacLocation1
        BRA     >
ErasePacBuff0:
        LDD     OldPacMemBlk0       * A=OldPacMemBlk0, B=OldPacSprite0
        LDX     OldPacLocation0
!       STA     MMU_Reg_Bank0_5     * Point to the old Mem Block where Pacman was last written
        INCA
        STA     MMU_Reg_Bank0_6
        LDU     #PacTableErase      * Point to the blank version of the Pac Man sprite
        JSR     [B,U]               * draw the blank pacman sprite
        PULS    B,X                 * restore the registers
        LSLB
        PSHS    B                   * Save pointer to sprite table on the stack
        TFR     X,D
        CMPA    #$09
        BLO     >
        CMPB    #$09
        BLO     >
        CMPA    #$E5
        BHI     >
        CMPB    #$ED
        BHI     >
        BRA     DrawNewPac
!       PULS    B,PC
DrawNewPac:
        LDX     #Screen_Start-8-3+128*17  * X points to the top left corner of the playfield (skip over the score and top of the maze)
		LSRA                        * two pixels per byte so divide the pixel location by two
		PSHS	CC					* if the carry is now set then X position is odd
        LEAX    A,X                 * Move to the proper X coordinate (memory location)
        LDA     #128                * 128 bytes per row, move us down in the Y direction
        MUL                         * B = Y coordinate * 128 gives us the memory location to show our Sprite
        LEAX    D,X                 * X now has the place in Video RAM to draw the Sprite
        TFR     X,D                 * Calculate which two memory blocks to get for writing to the screen memory in the Real VideoRAM and store them in $A000-$DFFF
        BITA    #$10
        BNE     >                   * Go if value is not betwwen 0000-0FFF or 2000-2FFF or 4000-4FFF or 6000-6FFF - handle it as normal
        BITA    #$E0
        BEQ     >                   * Skip if it's the range 0000-0FFF as we wont have any in this section
        CLRB                        * otherwise move it a block ahead so the sprite can be erased above it in memory
        ANDA    #$E0
        RORA                        * Shift A to the right 5 times to get the block that will hold our sprite
        RORA
        RORA
        RORA
        RORA
        DECA
        LDB     VidBuffPointer      * Pointer to Buffer that is currently not being shown - will be changed at the end of the IRQ
        BEQ     PacBuff0a
        ADDA    #VideoRam1_0
PacBuff0a:
        PSHS    A
        STA     MMU_Reg_Bank0_5
        INCA
        STA     MMU_Reg_Bank0_6
        TFR     X,D
        ANDA    #$1F
        ADDD    #$C000+8
        BRA     C@
!       CLRB                        * Clear the Carry flag
        ANDA    #$E0
        RORA                        * Shift A to the right 5 times to get the block that will hold our character
        RORA
        RORA
        RORA
        RORA
        LDB     VidBuffPointer      * Pointer to Buffer that is currently not being shown - will be changed at the end of the IRQ
        BEQ     PacBuff0b
        ADDA    #VideoRam1_0
PacBuff0b:
        PSHS    A
        STA     MMU_Reg_Bank0_5           * 0 to 3
        INCA
        STA     MMU_Reg_Bank0_6
        TFR     X,D
        ANDA    #$1F
        ADDD    #$A000+8
C@:		TFR     D,X                 * X now has the pointer to the top left corner of where the sprite is in RAM ($A000-$DFFF)
        PULS    A                   * get the Mem BLK that the sprite is using
        TST     VidBuffPointer      * Pointer to Buffer that is currently not being shown - will be changed at the end of the IRQ
        BEQ     PacBuff0c
        STX     OldPacLocation1     * Save the New Pacman Location over the old
        STA     OldPacMemBlk1       * Save the Mem BLK where Pac Man will be shown
        BRA     >
PacBuff0c:
        STX     OldPacLocation0     * Save the New Pacman Location over the old
        STA     OldPacMemBlk0       * Save the Mem BLK where Pac Man will be shown
!       LDU     #PacTableEven
		PULS	CC
		LBCS    PacOddPos
PacEvenPos:
* 44 PacRightBig, 45 PacDownBig, 46 PacRightNormal, 47 PacDownNormal, 48 PacClosed
* 49 PacLeftBig,  50 PacUpBig,   51 PacLeftNormal,  52 PacUpNormal,   53 PacClosed
        PULS    B                   * Get Sprite Number
        BRA     >
PacOddPos:
        PULS    B                   * Get Sprite Number
        ADDB    #22                 * 11 entries * 2 bytes each = 22 which points to the Odd sprite table entries
!       TST     VidBuffPointer      * Pointer to Buffer that is currently not being shown - will be changed at the end of the IRQ
        BEQ     >
        STB     OldPacSprite1
        JMP     [B,U]
!       STB     OldPacSprite0
DrawPacMan:
        JMP     [B,U]
