* Pacman 6809 Startup and option Screen handler
* This code loads a BMP file and displays a user menu to allow the user to set the DIP switches built into Pac Man
* It also shows a little instruction on what buttons to use for the game
* 0.05  - Added in the option to Extend the disaplay of autoscroll to show the very top and the very bottom of the screen if enabled
*       - Made it version 1.01 with Palette changed (GIME) glitch fixed
* 0.04  - Added in the option to disable the Cheat mode where the 'Y' key can skip the current maze and jump to the next
* 0.03
*       - Moved code to start at address $A000 from $C000 since SLZ loader uses $AF00 to $DFFF
*       - Changed DrawPacSprite routine name to DrawPacSpriteOption
*       - Renamed MMU_Reg_0 and 5 to MMU_Reg_Bank0_0 and 5
* 0.02	- Moved code sections around so the data is at the end, and added a few more comments
* 0.01	- First working version
* Display 320x225x16 BMP file for our custom Option/setting screen
        LDD     #$0000
        STD     RowPointer
        LDB     #$00                    * Page 00 = $00000
        LDX     #MMU_Reg_Bank0_0        * Need $0000-$9FFF for the graphics screen (five pages)
!       STB     ,X+
        INCB
        CMPB    #$05
        BNE     <
        LDB     #BitmapScreen0          * Source BMP is stored
        STB     MMU_Reg_Bank0_6         * $C000-$DFFF will have our first block of the BMP
        LDX     #$C000
        LDD     ,X                      * BMP must be Windows format or header data will not match and file data will be corrupt
        CMPD    #$424D                  * If the BMP doesn't start with 'BM' then it is the wrong format
        LBNE     BadFormat
        LDD     $12,X                   * Get the Width of the picture
        EXG     A,B                     * Swap the Intel byte format
        CMPD    #320
        LBNE    BadFormat
        LDD     $16,X       			* Get the Height of the picture
        EXG     A,B          			* Swap the Intel byte format
        CMPD    #225
        LBNE    BadFormat
        LDD     $1C,X        			* Get the # of bits per pixel of the picture
        EXG     A,B        				* Swap the Intel byte format
        CMPD    #4
        BNE     BadFormat
        LDD     $2E,X        			* Get the # of colours used in this picture
        EXG     A,B        				* Swap the Intel byte format
        CMPD    #0000
        BNE     >
        LDB     #16
!       STB     PalCount
        CMPD    #16
        BHI     BadFormat
        LDX     #$C000+$36
        LDU     #BMPPalette
PalLoop:
        CLRB
        LDA     ,X+     				* Blue
        BITA    #%10000000
        BEQ     >
        ORB     #%00001000
!       BITA    #%01000000
        BEQ     >
        ORB     #%00000001
!       LDA     ,X+    					* Green
        BITA    #%10000000
        BEQ     >
        ORB     #%00010000
!       BITA    #%01000000
        BEQ     >
        ORB     #%00000010
!       LDA     ,X++       				* Red & Skip Alpha
        BITA    #%10000000
        BEQ     >
        ORB     #%00100000
!       BITA    #%01000000
        BEQ     >
        ORB     #%00000100
!       STB     ,U+
        DEC     PalCount
        BNE     PalLoop
CheckifCompressed:
        LDU     ScreenBottomLeft		* BMP are stored Bottom up, start of bottom line is 320/2*225 = 36,000  - start of bottom row= - 320/2 = 35,840 = $8C00
        STU     RowPointer
		LDD     $C01E        			* Get the Compression format of the picture
		CMPD	#$0000
        BEQ     NotCompressedPic		* 0 means no compression used for picture data go copy data to screen
        EXG     A,B       				* Swap the Intel byte format
        CMPD    #2         				* 2 means RLE 4-bit/pixel compression
        BEQ     CompPic  				* go handle compressed data
BadFormat:								* Format doesn't match loop here (for now)
!       *
        BRA     <
NotCompressedPic:						* Handle uncompressed BMP data
        LDY     #320
NotComploop:
        BSR		GetAFromX
        STA     ,U+
		LEAY	-2,Y					* twice because we just wrote two pixels
		CMPY	#$0000
        BNE     >
        LDY     #320
        LEAU    -320,U
!       CMPU    #$0000-160				* Check if we just finished writing the last pixel
        BNE     NotComploop
        LBRA    DoneBMP
GetAFromX:								* routine to get a byte from X, increment X and handle RAM pages for X data pointer, return value in A
        LDA     ,X+
        CMPX    #$E000
        BNE     >
        LDX     #$C000
        LDB     MMU_Reg_Bank0_6
        ANDB    #$3F
        INCB
        STB     MMU_Reg_Bank0_6
!		RTS
StoreLeftAinU:							* routine to write A to U which has the first new pixel only (left 4 bits)
        PSHS    A
		ANDA	#$F0
        STA     ,U
		LEAY	1,Y						* we just wrote one pixel
		PULS    A
        RTS
StoreRightAinU:							* routine to write A to U which is the second pixel only (right 4 bits) so OR it with existing byte
        PSHS    A
        ANDA	#$0F
		ORA		,U
		STA     ,U+
		LEAY	1,Y						* we just wrote one pixel
        PULS    A
		RTS
CompPic:								* Handle the compressed BMP data at the pixel level
        LDY     #0000                   * Start a new line Pixel position = 0
        CLR     RightNibble             * Pixel position starts with the left nibble
CompLoop:
		BSR		GetAFromX               * Get a counter or if A=0 then a command byte follows
		TSTA
		LBNE	CompSection             * if not 0 then it's a compressed chunk
NoCompSection:							* Handle section that is not compressed
		BSR		GetAFromX				* Load A with the count of repeated pixels or control byte
        TSTA
        LBEQ    EndOfLine               * A = 0 then End of line move to the start of the next line
        CMPA    #1
        LBEQ    DoneBMP                 * A = 1 then End of picture data, we are done :)
        CMPA    #2
        BEQ     HandleXY                * A = 2 then move postion to new location to decode from
		STA		RepeatCounter
!       BSR		GetAFromX
        TFR     A,B
        RORB
        RORB
        RORB
        RORB
        ANDB    #$0F
        BSR     WritePixel
        DEC     RepeatCounter
		BEQ		CheckWordAligned
        TFR     A,B
        ANDB    #$0F
        BSR     WritePixel
        DEC     RepeatCounter
		BEQ		CheckWordAligned
        BRA     <
* Data is in the right nibble in accumulator B
WritePixel:
        PSHS    B
        TST     RightNibble             * Rightnibble = 1 then write the pixel from the right nibble of B
        BNE     RightPixel              * if not 0 then = 1 so go do the right side
        INC     RightNibble             * make it 1 for next entry, so it will write the right nibble
        ASLB                            * Handle pixel pointer is on the left
        ASLB
        ASLB
        ASLB
        STB     ,U
		LEAY	1,Y						* we just wrote one pixel
        PULS    B,PC
RightPixel:
        CLR     RightNibble             * Make Rightnibble = 0 so next entry will write to the left nibble
        ANDB    #$0F
        ORB     ,U
        STB     ,U+                     * Increment our RAm location to the next byte
		LEAY	1,Y						* we just wrote one pixel
        PULS    B,PC
HandleXY:                               * Handle delta X and delta Y pointers in the BMP file
		JSR		GetAFromX				* Load A with the delta X value
        TSTA
        BEQ     DeltaY
        LEAY    A,Y                     * Move Y forward
        PSHS    D                       * check if new location is an even or odd pixel location
        TFR     Y,D
        BITB    #$01
        BEQ     EvenPixelPoint          * Jump ahead if Evenpixel location
        LDA     #$01
        STA     RightNibble             * Odd pixel location so next byte should write to the Rightnibble
        BRA     DoneCheck
EvenPixelPoint:
        CLR     RightNibble             * Even pixel location so clear right nibble flag so the nex tpixel is written on the left
DoneCheck:
        PULS    D
!       RORA                            * divide by 2 to get byte count
        ANDA    #$7F
        LEAU    A,U                     * Two pixels per byte
DeltaY:
		JSR		GetAFromX				* Load A with the delta Y value
        TSTA
        LBEQ    CompLoop
        PSHS    X
        LDX     RowPointer
!       LEAX    -160,X                  * Move Left edge pointer up one line
        LEAU    -160,U                  * Move current pointer up one line
        DECA
        BNE     <
        STX     RowPointer              * Update the current starting point
        PULS    X
        JMP     CompLoop
CheckWordAligned:
        TFR     X,D
        BITB    #$01
        LBEQ    CompLoop                * Already aligned so go handle next byte
		JSR		GetAFromX				* Load A with the align byte
        TSTA
        LBEQ    CompLoop                * should be a zero
        JMP     BadFormat               * otherwise there's something wrong with this file
CompSection:							* Handle Compressed section
		STA		RepeatCounter
		JSR		GetAFromX				* Load A with byte to be repeated
!       TFR     A,B
        RORB
        RORB
        RORB
        RORB
        ANDB    #$0F
        JSR     WritePixel
        DEC     RepeatCounter
		LBEQ	CompLoop
        TFR     A,B
        ANDB    #$0F
        JSR     WritePixel
        DEC     RepeatCounter
		LBEQ	CompLoop
        BRA     <
EndOfLine:                              * Handle End of line, move up a line and start again from the left
        LDU     RowPointer
        LEAU    -160,U
        STU     RowPointer
        JMP     CompPic
PickedRGB:
        LDA     #1
        STA     RGB_Flag
        LDX     #BMPPalette
        LDU     #Palette_Start
        LDB     #16
!       LDA     ,X+
        STA     ,U+
        DECB
        BNE     <
        RTS
PickedComposite:
        CLR     RGB_Flag
        LDX     #BMPPalette
        LDU     #Palette_Start
        LDY     #RGBToCompTable
        LDB     #16
!       LDA     ,X+
        LDA     A,Y        				* lookup the Composite value that matches the RGB
        STA     ,U+        				* save it in the Palette
        DECB
        BNE     <
        RTS
DoneBMP:                                * Done decoding BMP to the screen RAM so we can now display the screen
        LDD     #$0000                	* Point video screen veiwer to $00000 (Hi-Res page start)
        STD     VidStart              	* Pointer value is $00000 / 8 = $0000 = $0000 in our 512k of RAM
        LDA     #Border_Colour          * Border settings
        STA     Border_Register         * Black border
        LDA     #%01111110              * 320 x 225 x 16 Colours requires 36,000 bytes = $8CA0 RAM
		STA     Vid_Res_Reg
		TST		RGB_Flag
		BEQ		>						* If RGB_Flag is 0 then use composite mode
        BSR     PickedRGB   			* Default to RGB Colours
		BRA		DonePalette
!		BSR		PickedComposite
DonePalette:                            * Text for Menu options
        LDU     VidModeRGB
        LDX     #VidModeRGB+2
		JSR		ShowChars
		LDU     ControlsJoy
        LDX     #ControlsJoy+2
		JSR		ShowChars
		LDU     VidLivesPerGame
        LDX     #VidLivesPerGame+2
		JSR		ShowChars
		LDU     ExtraManAt
        LDX     #ExtraManAt+2
		JSR		ShowChars
		LDU     DifficultySet
        LDX     #DifficultySet+2
		JSR		ShowChars
		LDU     GhostNamesSet
        LDX     #GhostNamesSet+2
        JSR     ShowChars
        LDU     CheatMode
        LDX     #CheatMode+2
		JSR		ShowChars
        LDU     ExtendedViewOn
        LDX     #ExtendedViewOn+2
		JSR		ShowChars
* Explain how to use this menu
		LDU     MessageLine1
        LDX     #MessageLine1+2
		JSR		ShowChars
		LDU     MessageLine2
        LDX     #MessageLine2+2
		JSR		ShowChars
		LDU     MessageLine3
        LDX     #MessageLine3+2
		JSR		ShowChars
		LDU     MessageLine4
        LDX     #MessageLine4+2
		JSR		ShowChars
		LDU     MessageLine5
        LDX     #MessageLine5+2
		JSR		ShowChars
		LDU     MessageLine6
        LDX     #MessageLine6+2
		JSR		ShowChars
		LDU     MessageLine7
        LDX     #MessageLine7+2
		JSR		ShowChars
* My Name and Pac man Release Version #
		LDU     MessageLine8
        LDX     #MessageLine8+2
		JSR		ShowChars
		LDU     MessageLine9
        LDX     #MessageLine9+2
		JSR		ShowChars

* Setup and enable the IRQ For Options
!		LDA     #$7E                    			* Write the JMP instruction
        LDX     #IRQForOptions          			* Point to the IRQForOptions Screen
        STA     IRQ_Jump_position       			*
        STX     IRQ_Start_Address       			* Point the IRQ to IRQForOptions
        ANDCC   #$EF                                * Enable the IRQ #$EF IRQ Only

* Scan the keyboard to react on settings screen
* Read keyboard  CoCo Keyboard mapping
*Row	 	       Data
*bits   7	6	5	4	3	2	1	0
*0	 	G	F	E	D	C	B	A	@
*1	 	O	N	M	L	K	J	I	H
*2	 	W	V	U	T	S	R	Q	P
*3	 	SP	RGT	LFT	DN	UP	Z	Y	X
*4	 	'	&	%	$	#	"	!	0
*4      7	6	5	4	3	2	1
*5	 	?	>	=	<	+	*	)	(
*5      /	.	_	,	;	:	9	8
*6	 shifts	 	 	 	   BRK CLR ENT
***********************************************************
ScanKeys:
        LDX     #PIA0_Byte_0_KeyRow_Joy             * PIA0
; Up Arrow
        LDA     #%11110111                          * Bit 3
        STA     $02,X
        LDA     ,X
        BITA    #%00001000                          * and bit 3 = Up Arrow pushed
        BNE     >                                   * Scan for another key
		LDB     #1
        CMPB	LastKey								* See if we are repeating the same key
		BEQ		CheckedKeys                         * Skip if we are
        LDA     #1
        STA     MovePacPointer
        STA     LastKey                             * 1 Marks Up as last button pressed
        BRA     CheckedKeys
; Down Arrow
!       LDA     #%11101111                          * Bit 4
        STA     $02,X
        LDA     ,X
        BITA    #%00001000                          * and bit 3 = Down Arrow pushed
        BNE     >                                   * Scan for another key
        LDB     #2
		CMPB	LastKey								* See if we are repeating the same key
		BEQ		CheckedKeys                         * Skip if we are
        LDA     #2
        STA     MovePacPointer
        STA     LastKey                             * 2 Marks Down as last button pressed
        BRA     CheckedKeys
; Space Bar
!       LDA     #%01111111                          * Bit 7
        STA     $02,X
        LDA     ,X
        BITA    #%00001000                          * and bit 3 = Space Bar pushed
        BNE     >                                   * Scan for another key
        JMP     ExitSettings
; Right Arrow
!       LDA     #%10111111                          * Bit 6
        STA     $02,X
        LDA     ,X
        BITA    #%00001000                          * and bit 3 = Right Arrow pushed
        BNE     >                                   * Scan for another key
        LDB     #3
		CMPB	LastKey								* See if we are repeating the same key
		BEQ		CheckedKeys                         * Skip if we are
        LDB     #3
        STB     LastKey
        BRA     HandleRight
; Left Arrow
!       LDA     #%11011111                          * Bit 5
        STA     $02,X
        LDA     ,X
        BITA    #%00001000                          * and bit 3 = Left Arrow pushed
        BNE     >                                   * Scan for another key
        LDB     #4
		CMPB	LastKey								* See if we are repeating the same key
		BEQ		CheckedKeys                         * Skip if we are
        LDB     #4
		STB		LastKey								* Store the new Keycode
        JMP     HandleLeft
!       CLR     LastKey                             * Mark no keys as being pressed
CheckedKeys:
        BRA     ScanKeys
ShowChars:
		LDA     ,X+
        BEQ     >
        JSR     DrawCharSet
        LEAU    4,U                     * 8 pixels per character 8 pixels = 4 bytes
        BRA     ShowChars
!		RTS				
HandleRight:
        LDA     PacOption
        CMPA    #1
        LBEQ    VidModeToggle
        CMPA    #2
        LBEQ    ControllerToggle
        CMPA    #3
        LBEQ    LivesPerGameR
        CMPA    #4
        LBEQ    ExtraManR
        CMPA    #5
        LBEQ    DiffToggle
        CMPA    #6
        BEQ     GNamesToggle
        CMPA    #7
        BEQ     CheatToggle
ExtViewToggle:
        LDB     #$3A
        STB     MMU_Reg_Bank0_6         * Copy 6809 Pacman code from normal $4000-$5FFF to $C000-$DFFF
        LDA     RackTest+$8000          * If it is a BRA instruction = $20 then change it to a BNE $26  Add $8000 so we point to the new location
        LDA     ExtendedScroll
        BEQ     ExtScrollMode           * If = 0 then go make it extended scroll mode, otherwise set it back to normal just scroll to show the top and bottom of the maze
		DECA
        STA		ExtendedScroll
        LDX     #$0180
        STX     ScrollUpWord1+1+$8000   * Add $8000 so we point to the new location
        STX     ScrollUpWord2+1+$8000   * Add $8000 so we point to the new location
        LDX     #$0300
        STX     ScrollDownWord1+1+$8000   * Add $8000 so we point to the new location
        STX     ScrollDownWord2+1+$8000   * Add $8000 so we point to the new location
        LDU     ExtendedView
        LDX     #ExtendedView+2
		BRA		>
ExtScrollMode:
		INCA
        STA     ExtendedScroll
        LDX     #$0000
        STX     ScrollUpWord1+1+$8000   * Add $8000 so we point to the new location
        STX     ScrollUpWord2+1+$8000   * Add $8000 so we point to the new location
        LDX     #$03F0
        STX     ScrollDownWord1+1+$8000   * Add $8000 so we point to the new location
        STX     ScrollDownWord2+1+$8000   * Add $8000 so we point to the new location
        LDU     ExtendedViewOn
        LDX     #ExtendedViewOn+2
!       LDB     #$3E
        STB     MMU_Reg_Bank0_6         * Put it back to normal $C000-$DFFF
		BRA		ShowCharsScan
CheatToggle:
        LDB     #$3A
        STB     MMU_Reg_Bank0_6         * Copy 6809 Pacman code from normal $4000-$5FFF to $C000-$DFFF
        LDA     RackTest+$8000          * If it is a BRA instruction = $20 then change it to a BNE $26  Add $8000 so we point to the new location
        CMPA    #$20
        BEQ     MakeBNE
        LDA     #$20                    * Make it a BRA instruction so it ignore the 'Y' Key press
        LDU     CheatMode
        LDX     #CheatMode+2
        BRA     >
MakeBNE:
        LDA     #$26                    * Make it a BNE instruction which will react to the 'Y' Key press
        LDU     CheatModeOn
        LDX     #CheatModeOn+2
!       STA     RackTest+$8000
        LDB     #$3E
        STB     MMU_Reg_Bank0_6         * Put it back to normal $C000-$DFFF
		BRA		ShowCharsScan
GNamesToggle:
        LDA     DipSwitch
        BITA    #$80                    * Bit 7 = 0 Alternate Names Bit 7 = 1 then Normal names
        BNE     GNNormal                * If = 1 then it is currently set as Normal Ghost Name Mode
        ORA     #$80
        STA     DipSwitch
        LDU     GhostNamesSet
        LDX     #GhostNamesSet+2
ShowCharsScan
		LDA     ,X+
        LBEQ    ScanKeys
        JSR     DrawCharSet
        LEAU    4,U                     * 8 pixels per character 8 pixels = 4 bytes
        BRA     ShowCharsScan
GNNormal:
        ANDA    #$7F
        STA     DipSwitch
        LDU     GhostNamesSetAlt
        LDX     #GhostNamesSetAlt+2
		BRA		ShowCharsScan
VidModeToggle:
        LDA     RGB_Flag
        BEQ     >			            * If = 0 then it is currently Composite go change to RGB
		JSR		PickedComposite
        LDU     VidModeComp
        LDX     #VidModeComp+2
		BRA		ShowCharsScan
!		JSR		PickedRGB
        LDU     VidModeRGB
        LDX     #VidModeRGB+2
		BRA		ShowCharsScan
LivesPerGameR:
        LDA     DipSwitch
		TFR		A,B
		ANDA	#%11110011
		RORB
		RORB
		ANDB	#%00000011
		BEQ		LivesTo2
		CMPB	#1
		BEQ		LivesTo3
		CMPB	#2
		BEQ		LivesTo5
LivesTo1:
		STA		DipSwitch
ShowLives1:
        LDU     VidLivesPerGame1
        LDX     #VidLivesPerGame1+2
		BRA		ShowCharsScan
LivesTo2:
		ORA		#%00000100
		STA		DipSwitch
ShowLives2:
        LDU     VidLivesPerGame2
        LDX     #VidLivesPerGame2+2
		BRA		ShowCharsScan
LivesTo3:
		ORA		#%00001000
		STA		DipSwitch
ShowLives3:
        LDU     VidLivesPerGame3
        LDX     #VidLivesPerGame3+2
		BRA		ShowCharsScan
LivesTo5:
		ORA		#%00001100
		STA		DipSwitch
ShowLives5:
        LDU     VidLivesPerGame5
        LDX     #VidLivesPerGame5+2
		BRA		ShowCharsScan
LivesPerGameL:
        LDA     DipSwitch
		TFR		A,B
		ANDA	#%11110011
		RORB
		RORB
		ANDB	#%00000011
		BEQ		LivesTo5
		CMPB	#1
		BEQ		LivesTo1
		CMPB	#2
		BEQ		LivesTo2
		BRA		LivesTo3
ExtraManR:
        LDA     DipSwitch
		TFR		A,B
		ANDA	#%11001111
		RORB
		RORB
		RORB
		RORB
		ANDB	#%00000011
		BEQ		BonusTo15K
		CMPB	#1
		BEQ		BonusTo20K
		CMPB	#2
		BEQ		BonusToNone
BonusTo10K:
		STA		DipSwitch
Show10K:		
        LDU     ExtraManAt10K
        LDX     #ExtraManAt10K+2
		JMP		ShowCharsScan
BonusTo15K:
		ORA		#%00010000
		STA		DipSwitch
Show15K:		
        LDU     ExtraManAt15K
        LDX     #ExtraManAt15K+2
		JMP		ShowCharsScan
BonusTo20K:
		ORA		#%00100000
		STA		DipSwitch
Show20K:		
        LDU     ExtraManAt20K
        LDX     #ExtraManAt20K+2
		JMP		ShowCharsScan
BonusToNone:
		ORA		#%00110000
		STA		DipSwitch
ShowNone:		
        LDU     ExtraManNone
        LDX     #ExtraManNone+2
		JMP		ShowCharsScan
ExtraManL:
        LDA     DipSwitch
		TFR		A,B
		ANDA	#%11001111
		RORB
		RORB
		RORB
		RORB
		ANDB	#%00000011
		BEQ		BonusToNone
		CMPB	#1
		BEQ		BonusTo10K
		CMPB	#2
		BEQ		BonusTo15K
		BRA		BonusTo20K
DiffToggle:
        LDA     DipSwitch
        BITA    #$40                    * Bit 6 = 0 Hard Mode, Bit 6 = 1 then normal mode
        BNE     >		                * If = 1 then it is currently set as Normal Mode
        ORA     #$40
        STA     DipSwitch
        LDU     DifficultySet
        LDX     #DifficultySet+2
		JMP		ShowCharsScan
!       ANDA    #%10111111
        STA     DipSwitch
        LDU     DifficultySetH
        LDX     #DifficultySetH+2
		JMP		ShowCharsScan
ControllerToggle:
        LDA     Joystick                * Check if Joystick is Enabled (<> 0)
        BEQ     >                       * If it currently is = 0 then arrows are selected so go change it to Joystick
        DECA                            * Make Joystick = 0  which means use arrow keys
        STA     Joystick
        LDU     ControlsArrows
        LDX     #ControlsArrows+2
		JMP		ShowCharsScan
!       INCA                            * Make Joystick = 1
        STA     Joystick
        LDU     ControlsJoy
        LDX     #ControlsJoy+2
		JMP		ShowCharsScan
HandleLeft:
        LDA     PacOption
        CMPA    #1
        LBEQ    VidModeToggle
        CMPA    #2
        BEQ     ControllerToggle
        CMPA    #3
        LBEQ    LivesPerGameL
        CMPA    #4
        BEQ     ExtraManL
        CMPA    #5
        LBEQ    DiffToggle
        CMPA    #6
        LBEQ    GNamesToggle
        CMPA    #7
        LBEQ    CheatToggle
        JMP     ExtViewToggle
; Interrupt handler -
; Called every time VBLANK fires during the game
; which is 60 times per second move Pacman Sprite on Options screen
; =============== S U B R O U T I N E =======================================
PacStartOpt:    EQU     $23C2
IRQForOptions:
        LDA     MovePacPointer
        LBEQ    SkipDrawPac
        CMPA    #1
        LBEQ    PacPointUp
PacPointDown:
        LDA     PacOption
        CMPA    #8
        LBEQ    SkipDrawPac
        CMPA    #7
        LBEQ    SevenToEight
        CMPA    #6
        LBEQ    SixToSeven
        CMPA    #5
        LBEQ    FiveToSix
        CMPA    #4
        BEQ     FourToFive
        CMPA    #3
        BEQ     ThreeToFour
        CMPA    #2
        BEQ     TwotoThree
OneToTwo:
        LDU     PacPointer
        LEAU    160,U
        STU     PacPointer
        CMPU    #PacStartOpt+160*9
        LBNE    PacPointCont
        LDA     #2
        STA     PacOption
        CLR     MovePacPointer
        JMP     PacPointCont
TwotoThree:
        LDU     PacPointer
        LEAU    160,U
        STU     PacPointer
        CMPU    #PacStartOpt+160*18
        LBNE    PacPointCont
        LDA     #3
        STA     PacOption
        CLR     MovePacPointer
        JMP     PacPointCont
ThreeToFour:
        LDU     PacPointer
        LEAU    160,U
        STU     PacPointer
        CMPU    #PacStartOpt+160*27
        LBNE    PacPointCont
        LDA     #4
        STA     PacOption
        CLR     MovePacPointer
        JMP     PacPointCont
FourToFive:
        LDU     PacPointer
        LEAU    160,U
        STU     PacPointer
        CMPU    #PacStartOpt+160*36
        LBNE    PacPointCont
        LDA     #5
        STA     PacOption
        CLR     MovePacPointer
        JMP     PacPointCont
FiveToSix:
        LDU     PacPointer
        LEAU    160,U
        STU     PacPointer
        CMPU    #PacStartOpt+160*45
        LBNE    PacPointCont
        LDA     #6
        STA     PacOption
        CLR     MovePacPointer
        JMP     PacPointCont
SixToSeven:
        LDU     PacPointer
        LEAU    160,U
        STU     PacPointer
        CMPU    #PacStartOpt+160*54
        LBNE    PacPointCont
        LDA     #7
        STA     PacOption
        CLR     MovePacPointer
        JMP     PacPointCont
SevenToEight:
        LDU     PacPointer
        LEAU    160,U
        STU     PacPointer
        CMPU    #PacStartOpt+160*63
        LBNE    PacPointCont
        LDA     #8
        STA     PacOption
        CLR     MovePacPointer
        JMP     PacPointCont
PacPointUp:
        LDA     PacOption
        CMPA    #1
        LBEQ    SkipDrawPac
        CMPA    #8
        LBEQ    EightToSeven
        CMPA    #7
        LBEQ    SevenToSix
        CMPA    #6
        LBEQ    SixToFive
        CMPA    #5
        BEQ     FiveToFour
        CMPA    #4
        BEQ     FourToThree
        CMPA    #3
        BEQ     ThreeToTwo
TwoToOne:
        LDU     PacPointer
        LEAU    -160,U
        STU     PacPointer
        CMPU    #PacStartOpt
        LBNE    PacPointCont
        LDA     #1
        STA     PacOption
        CLR     MovePacPointer
        JMP     PacPointCont
ThreeToTwo:
        LDU     PacPointer
        LEAU    -160,U
        STU     PacPointer
        CMPU    #PacStartOpt+160*9
        LBNE    PacPointCont
        LDA     #2
        STA     PacOption
        CLR     MovePacPointer
        BRA     PacPointCont
FourToThree:
        LDU     PacPointer
        LEAU    -160,U
        STU     PacPointer
        CMPU    #PacStartOpt+160*18
        BNE     PacPointCont
        LDA     #3
        STA     PacOption
        CLR     MovePacPointer
        BRA     PacPointCont
FiveToFour:
        LDU     PacPointer
        LEAU    -160,U
        STU     PacPointer
        CMPU    #PacStartOpt+160*27
        BNE     PacPointCont
        LDA     #4
        STA     PacOption
        CLR     MovePacPointer
SixToFive:
        LDU     PacPointer
        LEAU    -160,U
        STU     PacPointer
        CMPU    #PacStartOpt+160*36
        BNE     PacPointCont
        LDA     #5
        STA     PacOption
        CLR     MovePacPointer
SevenToSix:
        LDU     PacPointer
        LEAU    -160,U
        STU     PacPointer
        CMPU    #PacStartOpt+160*45
        BNE     PacPointCont
        LDA     #6
        STA     PacOption
        CLR     MovePacPointer
EightToSeven:
        LDU     PacPointer
        LEAU    -160,U
        STU     PacPointer
        CMPU    #PacStartOpt+160*54
        BNE     PacPointCont
        LDA     #7
        STA     PacOption
        CLR     MovePacPointer
PacPointCont:
        LDX     #$C000+128*46               * Pacman sprite is sprite #46
        LDU     PacPointer
        JSR     DrawPacSpriteOption
SkipDrawPac:
		LDA     IRQENR                      * IRQENR - Interrupt request enable register - reading it makes the IRQ enabled again
		RTI                                 * Return from interrupt routine
; End of function IRQForOptions
;=========================
DrawCharSet:
		PSHS    D,X,Y,U
		LDB		#CharDataOption     * Set memory Page Blk $30 which is chacters to Characters
        STB     MMU_Reg_Bank0_6     * into Page 6 which is $C000-$DFFF
        LDX     #$C000
        CMPA    #$20                * ASCII code for space is $20 Pacman Charset uses $40
        BNE     >
        LDA     #$40                * Space for Pacman Charset
!       LDB     #32
        MUL
        LEAX    D,X                 * X now points to the characters location
        LDD     ,X++
        STD     ,U++
        LDD     ,X++
        STD     ,U
        LEAU    158,U
        LDD     ,X++
        STD     ,U++
        LDD     ,X++
        STD     ,U
        LEAU    158,U
        LDD     ,X++
        STD     ,U++
        LDD     ,X++
        STD     ,U
        LEAU    158,U
        LDD     ,X++
        STD     ,U++
        LDD     ,X++
        STD     ,U
        LEAU    158,U
        LDD     ,X++
        STD     ,U++
        LDD     ,X++
        STD     ,U
        LEAU    158,U
        LDD     ,X++
        STD     ,U++
        LDD     ,X++
        STD     ,U
        LEAU    158,U
        LDD     ,X++
        STD     ,U++
        LDD     ,X++
        STD     ,U
        LEAU    158,U
        LDD     ,X++
        STD     ,U++
        LDD     ,X++
        STD     ,U
		PULS    D,X,Y,U,PC
* X = Sprite data pointer
* U = location in RAM to show sprite
DrawPacSpriteOption:
		PSHS    D,X,Y,U
* PacRightNormalEven:
        LEAU    6+160*16,U
        LDD     #$4444
        LDX     #$4444
        LEAY    ,X
        PSHU    D,X,Y       *0
        LEAU    -160+6,U
        PSHU    D,X,Y       *1
        LEAU    -160+6,U
        LDY     #$9444
        LDX     #$9999
        PSHU    D,X,Y       *2
        LEAU    -160+6,U
        LDB     #$99
        LDY     #$9994
        PSHU    D,X,Y       *3
        LEAU    -160+6,U
        LDA     #$49
        LDY     #$9999
        PSHU    D,X,Y       *4
        LEAU    -160+6,U
        PSHU    D,X,Y       *5
        LEAU    -160+6,U
        LDA     #$99
        LDY     #$9944
        PSHU    D,X,Y       *6
        LEAU    -160+6,U
        LDX     #$9994
        LDY     #$4444
        PSHU    D,X,Y       *7
        LEAU    -160+6,U
        LDX     #$4444
        PSHU    D,X,Y       *8
        LEAU    -160+6,U
        LDX     #$9994
        PSHU    D,X,Y       *9
        LEAU    -160+6,U
        LDX     #$9999
        LDY     #$9944
        PSHU    D,X,Y       *10
        LEAU    -160+6,U
        LDA     #$49
        LDY     #$9999
        PSHU    D,X,Y       *11
        LEAU    -160+6,U
        PSHU    D,X,Y       *12
        LEAU    -160+6,U
        LDA     #$44
        LDY     #$9994
        PSHU    D,X,Y       *13
        LEAU    -160+6,U
        LDB     #$44
        LDY     #$9444
        PSHU    D,X,Y       *14
        LEAU    -160+6,U
        LDX     #$4444
        LEAY    ,X
        PSHU    D,X,Y       *15
        LEAU    -160+6,U
        PSHU    D,X,Y       *16
		PULS    D,X,Y,U,PC
**************************************
* Data and pointers below
PacPointer:
        FDB     $23C2
MovePacPointer:
        FCB     $02
PacOption:
        FCB     $01
StartGame:
        FCB     $00
RepeatCounter:
        FCB     $00
RowPointer:
        FDB     $0000
ScreenBottomLeft:
        FDB     $8C00                   * BMP are stored Bottom up start of bottom line is 320/2*225 = 36,000  - start of bottom row= - 320/2 = 35,840 = $8C00
TextStart:      EQU     $26EA           * Address on the Screen where the Text options start
VidModeRGB:
        FDB     TextStart
        FCN     'VIDEO MODE        RGB'
VidModeComp:
        FDB     TextStart
        FCN     'VIDEO MODE  COMPOSITE'
ControlsJoy:
        FDB     TextStart+160*9
        FCN     'CONTROLLER   JOYSTICK'
ControlsArrows:
        FDB     TextStart+160*9
        FCN     'CONTROLLER ARROW KEYS'
VidLivesPerGame:
        FDB     TextStart+160*18
        FCN     'LIVES PER GAME      3'
VidLivesPerGame1:
        FDB     (TextStart+160*18)+8/2*20
        FCN     '1'
VidLivesPerGame2:
        FDB     (TextStart+160*18)+8/2*20
        FCN     '2'
VidLivesPerGame3:
        FDB     (TextStart+160*18)+8/2*20
        FCN     '3'
VidLivesPerGame5:
        FDB     (TextStart+160*18)+8/2*20
        FCN     '5'
ExtraManAt:
        FDB     TextStart+160*27
        FCN     'EXTRA MAN AT    10000'
ExtraManAt10K:
        FDB     TextStart+160*27
        FCN     'EXTRA MAN AT    10000'
ExtraManAt15K:
        FDB     TextStart+160*27
        FCN     'EXTRA MAN AT    15000'
ExtraManAt20K:
        FDB     TextStart+160*27
        FCN     'EXTRA MAN AT    20000'
ExtraManNone:
        FDB     TextStart+160*27
        FCN     'EXTRA MAN AT     NONE'
DifficultySet:
        FDB     TextStart+160*36
        FCN     'DIFFICULTY     NORMAL'
DifficultySetH:
        FDB     TextStart+160*36
        FCN     'DIFFICULTY       HARD'
GhostNamesSet:
        FDB     TextStart+160*45
        FCN     'GHOST NAMES    NORMAL'
GhostNamesSetAlt:
        FDB     TextStart+160*45
        FCN     'GHOST NAMES       ALT'
CheatMode:
        FDB     TextStart+160*54
        FCN     'CHEAT MODE        OFF'
CheatModeOn:
        FDB     TextStart+160*54
        FCN     'CHEAT MODE         ON'
ExtendedView:
        FDB     TextStart+160*63
        FCN     'EXTENDED SCROLL   OFF'
ExtendedViewOn:
        FDB     TextStart+160*63
        FCN     'EXTENDED SCROLL    ON'
**************************************************
TextMessStart:  EQU     $5B62-160*2
MessageLine1:
        FDB     TextMessStart+1*160
        FCN     '  USE THE ARROW KEYS'
MessageLine2:
        FDB     TextMessStart+9*160
        FCN     ' TO CHANGE THE OPTIONS'
MessageLine3:
        FDB     TextMessStart+17*160
        FCN     'PRESS SPACE BAR TO PLAY'
MessageLine4:
        FDB     TextMessStart+32*160
        FCN     '  WHILE IN GAME MODE'
MessageLine5:
        FDB     TextMessStart+40*160
        FCN     '   5 INSERTS A COIN'
MessageLine6:
        FDB     TextMessStart+48*160
        FCN     ' 1 OR 2 STARTS A GAME'
MessageLine7:
        FDB     TextMessStart+56*160
        FCC     'A'
        FCB     $3A
        FCN     'Z SCROLLS UP AND DOWN'
MessageLine8:
        FDB     $85C3
        FCC     'COCO 3 VERSION 1'
        FCB     $25
        FCN     '01'
MessageLine9:
        FDB     $8621
        FCN     'BY GLEN HEWLETT'
LastKey:							* Remember the last key pressed, handling so key repeat doesn't happen.
		FCB		$00
ExtendedScroll:                         * Flag if we should scroll to the very top and very bottom of the screen automatically
        FCB     $01                     * 0 = no extended view so show maze only, <> 0 show very top and bottom
* Specific to BMP Decoding
PalCount:
        FCB     $00                 * Number of colours used in this picture
RightNibble:
        FCB     $00
BMPPalette:
        RMB     16

* RGB to Composite conversion chart (conversion used in OS-9 Level II)
RGBToCompTable:                                 * RGb Value
        FCB     00  * Black                     * 00
        FCB     12  * Low intensity blue        * 01
        FCB     02  * Low intensity green       * 02
        FCB     14  * Low intensity cyan        * 03
        FCB     07  * Low intensity red         * 04
        FCB     09  * Low intensity magenta     * 05
        FCB     05  * Low intensity brown       * 06
        FCB     16  * Low intensity white       * 07
        FCB     28  * Medium intensity blue     * 08
        FCB     44  * Full intensity blue       * 09
        FCB     13  * Green tint blue           * 0A
        FCB     29  * Cyan tint blue            * 0B
        FCB     11  * Red tint blue             * 0C
        FCB     27  * Magenta tint blue         * 0D
        FCB     10  * Brown tint blue           * 0E
        FCB     43  * Faded blue                * 0F
        FCB     34  * Medium intensity green    * 10
        FCB     17  * Blue tint green           * 11
        FCB     18  * Full intensity green      * 12
        FCB     33  * Cyan tint green           * 13
        FCB     03  * Red tint green            * 14
        FCB     01  * Magenta tint green        * 15
        FCB     19  * Brown tint green          * 16
        FCB     50  * Faded green               * 17
        FCB     30  * Medium intensity cyan     * 18
        FCB     45  * Blue tint cyan            * 19
        FCB     31  * Green tint cyan           * 1A
        FCB     46  * Full intensity cyan       * 1B
        FCB     15  * Red tint cyan             * 1C
        FCB     60  * Magenta tint cyan         * 1D
        FCB     47  * Brown tint cyan           * 1E
        FCB     61  * Faded cyan                * 1F
        FCB     23  * Medium intensity red      * 20
        FCB     08  * Blue tint red             * 21
        FCB     21  * Light Orange              * 22
        FCB     06  * Cyan tint red             * 23
        FCB     39  * Full intensity red        * 24
        FCB     24  * Magenta tint red          * 25
        FCB     38  * Brown tint red            * 26
        FCB     54  * Faded red                 * 27
        FCB     25  * Medium intensity magenta  * 28
        FCB     42  * Blue tint magenta         * 29
        FCB     26  * Green tint magenta        * 2A
        FCB     58  * Cyan tint magenta         * 2B
        FCB     24  * Red tint magenta          * 2C
        FCB     41  * Full intensity magenta    * 2D
        FCB     40  * Brown tint magenta        * 2E
        FCB     56  * Faded magenta             * 2F
        FCB     20  * Medium intensity yellow   * 30
        FCB     04  * Blue tint yellow          * 31
        FCB     35  * Green tint yellow         * 32
        FCB     51  * Cyan tint yellow          * 33
        FCB     37  * Red tint yellow           * 34
        FCB     53  * Magenta tint yellow       * 35
        FCB     36  * Full intensity yellow     * 36
        FCB     52  * Faded yellow              * 37
        FCB     32  * Medium intensity white    * 38
        FCB     59  * Light blue                * 39
        FCB     49  * Light green               * 3A
        FCB     62  * Light cyan                * 3B
        FCB     55  * Light red                 * 3C
        FCB     57  * Light magenta             * 3D
        FCB     63  * Light yellow              * 3E
        FCB     48  * White                     * 3F
ExitSettings:
        ORCC    #$50                    * Disable interrupts

* Setup and enable the IRQ For Options
!		LDA     #$7E                    			* Write the JMP instruction
        LDX     #IRQ_Interrupt0          			* Point the IRQ to IRQ_Interrupt0 for now this is our fake IRQ
        STA     IRQ_Jump_position       			*
        STX     IRQ_Start_Address       			* Point the IRQ to IRQForOptions

!       LDA     #$38                    * Put memory Blocks back to normal
        LDX     #MMU_Reg_Bank0_0
        LDB     #5
!       STA     ,X+
        INCA
        DECB
        BNE     <
        JMP     ClearVideoRAM					* Clear the screen and return
