* 03 - Drawing message to Vid Buff 0 & Vid Buff 1
* Version 02 - Use Compiled sprites to generate messages
*****
* Prerendered Messages:
* Table Format:
* 00        - Blk where Message is stored
* 01 & 02   - Address where Message is stored
* 03        - Mem block where to display the message
* 04 & 05   - Address where to display the message
* 06        - Length of the message
PreRendMessages:
        JSR     FixBonusScore                       * Go setup the BonusScore message so it shows the correct value when we prerender it
		LDA		#RendTextMess_0                     * Set memory Page Blk 0-2 to Prerendered Message area
        STA     Misc02
        STA     MMU_Reg_Bank0_0                     * into Page 0 which is $0000-$1FFF
        INCA
        STA     MMU_Reg_Bank0_1                     * into Page 1 which is $2000-$3FFF
        INCA
        STA     MMU_Reg_Bank0_2                     * into Page 2 which is $4000-$5FFF
        CLRB
        LDY     #PreMessLookup
        LDX     #$0000
PreRendLoop:
        STX     1,Y                                 * Store the Address of where the Message is in RAM
        PSHS    B,X
        LDX     #MessageTable                       * text string lookup table
        ASLB
        LDX     B,X                                 * X = Value stored at (X+2B)
        LDB     ,X+                                 * Message definition in HL,DE = offset - 390A
        LDA     ,X                                  * DE = offset to start  Y = 0304
        ANDA    #$7F                                * Strip off direction info
        ADDD    #$4000                              * D now points to location of message in Pac Man Hardware
        TFR     D,U
        JSR     RenderCharacter                     * Go and get the RAM location of the first byte of the message
        LDA     Misc01
        STA     3,Y                                 * Mem Blk where to display the message
        LDD     TempAddress                         * Get the Location in RAM where the real message will be shown
        ADDD    #1
        STD     4,Y                                 * Save it in the table
        PULS    B,X
        PSHS    B,X,Y
        CLR     count
        JSR     RenderMessage
        PULS    B,X,Y
        PSHS    B
        LDB     count                               * count has the length of the characters displayed in the message
        LDA     #$4                                 * 8 pixels per character/2 pixels per byte = 4
        MUL
        STB     count
        STB     6,Y                                 * Save the length of the message
        LDU     4,Y                                 * Get the location in RAM where the real message will be shown Video RAM
        LDA     1,Y                                 * MSB of where the current message is stored in RAM
        ANDA    #$1F                                * Test if it is near the end of the $2000 boundary
        CMPA    #$1C                                * If so add 3 to it
        BLS     >
        LDA     1,Y
        ADDA    #3
        ANDA    #$1F                                * make sure we don't cross the $2000 boundary
        STA     1,Y
        INC     Misc02
!       LDA     Misc02
        STA     MMU_Reg_Bank0_0                     * into Page 0 which is $0000-$1FFF
SaveBLK:
        STA     ,Y                                  * Save the BLK pointer where the message is stored in RAM, Blk 5 to 7
        LDX     1,Y                                 * Address of where the Message is in Stored RAM
!       LDA     ,U+
        STA     ,X+
        DECB
        BNE     <
        LDB     count
        LDU     4,Y                                 * Get the location in RAM where the real message will be shown
        LEAU    128,U                               * Row 2 of the Message
!       LDA     ,U+
        STA     ,X+
        DECB
        BNE     <
        LDB     count
        LDU     4,Y                                 * Get the location in RAM where the real message will be shown
        LEAU    128*2,U                             * Row 3 of the Message
!       LDA     ,U+
        STA     ,X+
        DECB
        BNE     <
        LDB     count
        LDU     4,Y                                 * Get the location in RAM where the real message will be shown
        LEAU    128*3,U                             * Row 4 of the Message
!       LDA     ,U+
        STA     ,X+
        DECB
        BNE     <
        LDB     count
        LDU     4,Y                                 * Get the location in RAM where the real message will be shown
        LEAU    128*4,U                             * Row 5 of the Message
!       LDA     ,U+
        STA     ,X+
        DECB
        BNE     <
        LDB     count
        LDU     4,Y                                 * Get the location in RAM where the real message will be shown
        LEAU    128*5,U                             * Row 6 of the Message
!       LDA     ,U+
        STA     ,X+
        DECB
        BNE     <
        LDB     count
        LDU     4,Y                                 * Get the location in RAM where the real message will be shown
        LEAU    128*6,U                             * Row 7 of the Message
!       LDA     ,U+
        STA     ,X+
        DECB
        BNE     <
        LDB     count
        LDU     4,Y                                 * Get the location in RAM where the real message will be shown
        LEAU    128*7,U                             * Row 8 of the Message
!       LDA     ,U+
        STA     ,X+
        DECB
        BNE     <
        PULS    B
        CMPB    #$05                                * Game OVer Message
        BEQ     RendMess1
        CMPB    #$1B                                * Fruit score message after it's eaten'
        BLO     >
        CMPB    #$1D                                * Fruit score message after it's eaten'
        BHI     >
RendMess1:
        LDU     4,Y
        LEAU    -1,U
        STU     4,Y
!       LEAY    7,Y
        INCB
        CMPB    #55
        LBNE    PreRendLoop
		LDA		#RegRAM0                            * Set memory Page Blk 0-2 to Normal Data & Tables/pointers
        STA     MMU_Reg_Bank0_0                     * into Page 0 which is $0000-$1FFF
        INCA
        STA     MMU_Reg_Bank0_1                     * into Page 1 which is $2000-$3FFF
        INCA
        STA     MMU_Reg_Bank0_2                     * into Page 2 which is $4000-$5FFF
        LDA     #RegRAM6
        STA     MMU_Reg_Bank0_6
        RTS
RenderMessage:
        LDX     #MessageTable                       ;2C5E 21A536      LD      HL,36A5h		; text string lookup table
        TFR     B,A
        ASLA
        LDX     A,X
PrintMessage1:										; X =
        PSHS    B
        LDB     ,X+                                 ;2C62 5E          LD      E,(HL)		; Message definition in HL,DE = offset - 390A
;        LEAX    1,X                                ;2C63 23          INC     HL
        LDA     ,X                                  ;2C64 56          LD      D,(HL)		; DE = offset to start  Y = 0304
        ANDA    #$7F
        LDU     #PaletteRAM                 		;2C65 DD210044    LD      IX,4400h   	; palette memory
        LEAU    D,U                                 ;2C69 DD19        ADD     IX,DE      	; offset to start of message = U=U+Y = $4704
		PSHS    U                                   ;2C6B DDE5        PUSH    IX			; save this
		LDD     #$0FC00                             ;2C6D 1100FC      LD      DE,0FC00h		; -1024 puts similar location into tile RAM Y=-$400
        LEAU    D,U                                 ;2C70 DD19        ADD     IX,DE			; IX now points into tile RAM               U=U+Y = $4304
        TFR     U,Y
;        LDY     #$0FFFF                            ;2C72 11FFFF      LD      DE,0FFFFh	; backup one character at a time = vert in main area
;        Test bit 7 of (HL) Use BITA or BITB        ;2C75 CB7E        BIT     7,(HL) 		; bit 7 tells horiz or vert
        LDA     ,X
        PULS    U
        PULS    B
        PSHS    U
        TFR     Y,U
        LDY     #$FFFF
        BITA    #$80
        BNE     DrawHorizMsg1                       ;2C77 2003        JR      NZ,DrawHorizMsg 	;if not set,Draw horizontal
        LDY     #$0FFE0                             ;2C79 11E0FF      LD      DE,0FFE0h      	; draw vertical (32 chars at a tile)
DrawHorizMsg1:                                		; next byte in table
        LEAX    1,X                                 ;2C7C 23          INC     HL            	; point to first ascii character
        TFR     B,A                                 ;2C7D 78          LD      A,B           	; save B,which is still message number  $23 = 35
        CLRB                                 		;2C7E 010000      LD      BC,0
        ASLA                                        ;2C81 87          ADD     A,A          	 	;A*2 = $46 = 70
        BCS     loc_2CAC.1                          ;2C82 3828        JR      C,loc_2CAC    		;
MsgTileLoop1:                                 													; tile to draw
        LDA     ,X+                                 ;2C84 7E          LD      A,(HL)         	; read ascii character
        CMPA    #$2F                                ;2C85 FE2F        CP      2Fh ; '/'       	; are we done?
        BEQ     MsgTilesDone1                       ;2C87 2809        JR      Z,MsgTilesDone 	; yes,jump
;        STA     ,U                                 ;2C89 DD7700      LD      (IX+0),A       	; no,store tile
        JSR     RenderCharacter
;        LEAX    1,X                                ;2C8C 23          INC     HL             	; next table entry
        LEAU    -32,U
        CMPY    #-32
        BEQ     >
        LEAU    31,U
!													;2C8D DD19        ADD     IX,DE          	; next tile,Horiz or vert
        INCB                                        ;2C8F 04          INC     B               	; count tiles written
        BRA     MsgTileLoop1                        ;2C90 18F2        JR      MsgTileLoop
; ---------------------------------------------------------------------------
MsgTilesDone1:
;        LEAX    1,X                                ;2C92 23          INC     HL				; next byte
loc_2C93.1:
		PULS    U                                   ;2C93 DDE1        POP     IX				; get start video tile address
		LDA     ,X                                  ;2C95 7E          LD      A,(HL)         	; next byte
;        TSTA                                       ;2C96 A7          AND     A               	; is a >= 128?
        BMI    Msg1Color1                           ;2C97 FAA42C      JP      M,Msg1Color    	; jump if so - all are same color
MsgColors1:
        LDA     ,X+                                 ;2C9A 7E          LD      A,(HL)			; get next color
;        STA     ,U                                 ;2C9B DD7700      LD      (IX+0),A   		; set color
        JSR     ColourChar
;        LEAX    1,X                                ;2C9E 23          INC     HL				; next table byte
        LEAU    -32,U
        CMPY    #-32
        BEQ     >
        LEAU    31,U
!													;2C9F DD19        ADD     IX,DE          	; next horiz or vert
        DECB
        BNE     MsgColors1                          ;2CA1 10F7        DJNZ    MsgColors       	; repeat until all drawn
        BRA     ExitDM.1                            ;2CA3 C9          RET                     	; return
; ---------------------------------------------------------------------------
Msg1Color1:                                   		; write Message with only one color
;        STA     ,U                                 ;2CA4 DD7700      LD      (IX+0),A
        JSR     ColourChar
        LEAU    -32,U
        CMPY    #-32
        BEQ     >
        LEAU    31,U
!													;2CA7 DD19        ADD     IX,DE				; next tile,Horiz or vert
        DECB
        BNE     Msg1Color1                          ;2CA9 10F9        DJNZ    Msg1Color       	; loop till done
        BRA     ExitDM.1                            ;2CAB C9          RET                     	; return
; ---------------------------------------------------------------------------
loc_2CAC.1:                                    		; get a data byte
        LDA     ,X+                                 ;2CAC 7E          LD      A,(HL)
        CMPA    #$2F                                ;2CAD FE2F        CP      2Fh ; '/'       	; are we done?
        BEQ     loc_2CBB.1                          ;2CAF 280A        JR      Z,loc_2CBB     	; if yes,jump
;        ST#$40     ,U                              ;2CB1 DD360040    LD      (IX+0),40h 		; '@'  store blank color
        LDA     #$40
        JSR     RenderCharacter
;        LEAX    1,X                                ;2CB5 23          INC     HL              	; next table byte
        LEAU    -32,U
        CMPY    #-32
        BEQ     >
        LEAU    31,U
!													;2CB6 DD19        ADD     IX,DE          	; next tile,Horiz or vertical
        INCB                                        ;2CB8 04          INC     B               	; count tiles written
        BRA     loc_2CAC.1                          ;2CB9 18F1        JR      loc_2CAC
; ---------------------------------------------------------------------------
loc_2CBB.1:                                    		; next table byte
;        LEAX    1,X                                ;2CBB 23          INC     HL
        INCB                                        ;2CBC 04          INC     B               	; count tiles
!       CMPA    ,X+
        BEQ     >
        DECB
        BNE     <
!       LEAX    -1,X        *** If A = (X) then X should not be incremented check the code to see if X is used next.
                            *** If X value is used then change above to CMPA  ,X next line BEQ  > next line LEAX  +1,X
                                                    ;2CBD EDB1        CPIR                     
        BRA     loc_2C93.1                          ;2CBF 18D2        JR      loc_2C93
ExitDM.1:
        RTS
; End of function DrawMessage
RenderCharacter:
		PSHS    D,X,Y,U
		LDB		#CharCompSprite0    * Set memory Blk $30 & $31 to Characters
        STB     MMU_Reg_Bank0_0     * into Page 0 & 1 which is $0000-$3FFF
        INCB
        STB     MMU_Reg_Bank0_1
        TFR     A,B
        CLRA
        LSLB
        ROLA                        * D now points to the offset for the Character table
        LDY     #Char_Table
        LEAY    D,Y                 * Y now points to the characters sprite code routine address
        LDY     ,Y                  * Y now has the routine address that will print the character
        CMPU    #$403F              * Let's see if it's in main screen area first since most data will be here
        BHI     CheckMain.1
BotScreen.1:
        CMPU    #$4002
        LBLO     NoShow.1
        CMPU    #$401E
        BLO     Line3.1
        CMPU    #$4022
        LBLO     NoShow.1
        CMPU    #$403D
        LBHI     NoShow.1
Line4.1:
        STU     Char_Temp
        LDD     #$403D
        SUBD    Char_Temp
        ASLB
        ASLB                        * B * 4 (4 bytes per character offeset for X value)
        LDU     #Screen_Start+128*8*35  * Bottom Line Starting Point
        LEAU    B,U                 * Add the X value
        LBRA    ShowCharacter.1
Line3.1:
        STU     Char_Temp
        LDD     #$401D
        SUBD    Char_Temp
        ASLB
        ASLB                        * B * 4 (4 bytes per character offeset for X value)
        LDU     #Screen_Start+128*8*34  * 2nd from bottom Line Starting Point
        LEAU    B,U                 * Add the X value
        BRA     ShowCharacter.1
CheckMain.1:
        CMPU    #$43C0
        BLO     ShowMain.1
CheckTop.1:
        CMPU    #$43C2
        LBLO     NoShow.1
        CMPU    #$43DE
        BLO     Line1.1
        CMPU    #$43E2
        LBLO     NoShow.1
        CMPU    #$43FD
        LBHI     NoShow.1
Line2.1:
        STU     Char_Temp
        LDD     #$43FD
        SUBD    Char_Temp
        ASLB
        ASLB                        * B * 4 (4 bytes per character offeset for X value)
        LDU     #Screen_Start+128*8 * 2nd Line Starting Point
        LEAU    B,U                 * Add the X value
        BRA     ShowCharacter.1
Line1.1:
        STU     Char_Temp
        LDD     #$43DD
        SUBD    Char_Temp
        ASLB
        ASLB                        * B * 4 (4 bytes per character offeset for X value)
        LDU     #Screen_Start       * Top Line Starting Point
        LEAU    B,U                 * Add the X value
        BRA     ShowCharacter.1
ShowMain.1:
        TFR     U,D
        PSHS    B                   * Pacman Y will be 5 LS bits of B
        ANDB    #$1F
        STB     PacmanY
        PULS    B
        RORA
        RORB
        RORA
        RORB
        RORA
        RORB
        RORA
        RORB
        RORA
        RORB
        ANDB    #$1F                    * B-2 = X Value of Pacman Hardware where 0 is the right side and 27 is the left side
        STB     PacmanX
        LDA     #29
        SUBA    PacmanX                 * A now has proper X value for our character screen
        ASLA
        ASLA                            * A * 4 (4 bytes per character offeset for X value)
        LDU     #Screen_Start+128*16    * 2 top rows must be skipped for the proper X and Y character location to start from
        LEAU    A,U                     * Now it points to the correct X location
        LDB     PacmanY
        LDA     #8
        MUL                             * D now has our proper Y Character pointer location
        LDA     #128                    * 8 * 128 = 1024 * Y value is the real location for our screen
        MUL
        LEAU    D,U                     * Add it together and Now U points to the correct Screen location
ShowCharacter.1:
        TFR     U,D
        CLRB                                * Clear the Carry flag
        ANDA    #$E0
        RORA                                * Shift A to the right 5 times to get the block that will hold our character
        RORA
        RORA
        RORA
        RORA
        STA     Misc01                      * MEM BLK where to Show Message
        STA     MMU_Reg_Bank0_5             * Setup block of real VideoRAM at $A000-$BFFF
        TFR     U,D
        ANDA    #$1F
        ADDD    #$A004
        STD     TempAddress                 * Address where to show Message
        INC     count
        TFR     D,X
        JSR     ,Y
NoShow.1:                                   * Jump's here to skip showing any character as it is pointing to one of the special not shown locations
		LDA		#RendTextMess_0				* Set memory Page Blk 0-2 to Prerendered Message area
        STA     MMU_Reg_Bank0_0  	   	 	* into Page 0 which is $0000-$1FFF
        INCA
        STA     MMU_Reg_Bank0_1  	   	 	* into Page 1 which is $2000-$3FFF
        INCA
        STA     MMU_Reg_Bank0_2  	   	 	* into Page 2 which is $4000-$5FFF
		PULS    D,X,Y,U,PC
*****************************************************
* Prerendered Messages:
* Table Format:
* 00        - Blk where Message is stored
* 01 & 02   - Address where Message is stored
* 03        - Mem block where to display the message
* 04 & 05   - Address where to display the message
* 06        - Length of the message
*****************************************************
* Buffer for messages to be drawn during B = Message #
MessTableBuff0:
        FCB     $00     * Message #0
        FCB     $00     * Message #1
        FCB     $00     * Message #2
        FCB     $00     * Message #3
        FCB     $00     * Message #4
        FCB     $00     * Message #5
        FCB     $00     * Message #6
        FCB     $00     * Message #7
        FCB     $00     * Message #8
        FCB     $00     * Message #9
        FCB     $00     * Message #10
        FCB     $00     * Message #11
        FCB     $00     * Message #12
        FCB     $00     * Message #13
        FCB     $00     * Message #14
        FCB     $00     * Message #15
MessTableBuff1:
        FCB     $00     * Message #0
        FCB     $00     * Message #1
        FCB     $00     * Message #2
        FCB     $00     * Message #3
        FCB     $00     * Message #4
        FCB     $00     * Message #5
        FCB     $00     * Message #6
        FCB     $00     * Message #7
        FCB     $00     * Message #8
        FCB     $00     * Message #9
        FCB     $00     * Message #10
        FCB     $00     * Message #11
        FCB     $00     * Message #12
        FCB     $00     * Message #13
        FCB     $00     * Message #14
        FCB     $00     * Message #15
MessBuffPointer0:
        FCB     $00
MessBuffPointer1:
        FCB     $00
DrawMessage:
        LDX     #MessTableBuff0
        LDA     MessBuffPointer0
        STB     A,X                 * Save it in the table to be shown during the IRQ
        INCA
        STA     MessBuffPointer0
        LDX     #MessTableBuff1
        LDA     MessBuffPointer1
        STB     A,X                 * Save it in the table to be shown during the IRQ
        INCA
        STA     MessBuffPointer1
        RTS
DrawMessageIRQBuff0:
        PSHS    A,X,U
        STB     Misc01
        ANDB    #$7F                * Ignore the Erase flag for now
        LDX     #PreMessLookup
        LDA     #7                  * 7 entries per message
        MUL
        LEAX    D,X                 * Now points to Table data for message in accumulator B
        LDB     MMU_Reg_Bank0_0
        ANDB    #$3F
        PSHS    B
        LDA     ,X                  * Set memory Page Blk 0 to Prerendered Message area 5 to 7
        STA     MMU_Reg_Bank0_0  	* into Page 0 which is $0000-$1FFF
        LDA     3,X                 * get the Mem BLk where to display the message in video RAM
ShowMessage:
        STA     MMU_Reg_Bank0_5     * Setup block of real VideoRAM at $A000-$BFFF
        LDU     4,X                 * U now points to the start of where the Text will be displayed in Video RAM
        LDA     6,X                 * Get the length in bytes of the message that needs to be copied per row
        NEGA                        * We need to subtract this amount from U to setup the pointer for each row
        LDB     Misc01
        ASLB                        * If original value of B for this routine has bit 7 set then it is the erase flag
        LBCS    EraseMessage    	* Go and erase the text (draw blanks)
        LDY     1,X                 * S points to the start of the source message pixel data

        TFR     A,B
        NEGB                        * Make it positve
        LSRB                        * 1/2 B gives the number of bytes as we read/write two bytes at a time
!       LDX     ,Y++
        STX     ,U++
        DECB
        BNE     <
        LEAU    A,U                 * Set pointer back to the start
        LEAU    128,U               * Move down to the next row
        TFR     A,B
        NEGB                        * Make it positve
        LSRB                        * 1/2 B gives the number of bytes as we read/write two bytes at a time
!       LDX     ,Y++
        STX     ,U++
        DECB
        BNE     <
        LEAU    A,U                 * Set pointer back to the start
        LEAU    128,U               * Move down to the next row

        TFR     A,B
        NEGB                        * Make it positve
        LSRB                        * 1/2 B gives the number of bytes as we read/write two bytes at a time
!       LDX     ,Y++
        STX     ,U++
        DECB
        BNE     <
        LEAU    A,U                 * Set pointer back to the start
        LEAU    128,U               * Move down to the next row
        TFR     A,B
        NEGB                        * Make it positve
        LSRB                        * 1/2 B gives the number of bytes as we read/write two bytes at a time
!       LDX     ,Y++
        STX     ,U++
        DECB
        BNE     <
        LEAU    A,U                 * Set pointer back to the start
        LEAU    128,U               * Move down to the next row

        TFR     A,B
        NEGB                        * Make it positve
        LSRB                        * 1/2 B gives the number of bytes as we read/write two bytes at a time
!       LDX     ,Y++
        STX     ,U++
        DECB
        BNE     <
        LEAU    A,U                 * Set pointer back to the start
        LEAU    128,U               * Move down to the next row
        TFR     A,B
        NEGB                        * Make it positve
        LSRB                        * 1/2 B gives the number of bytes as we read/write two bytes at a time
!       LDX     ,Y++
        STX     ,U++
        DECB
        BNE     <
        LEAU    A,U                 * Set pointer back to the start
        LEAU    128,U               * Move down to the next row
        TFR     A,B
        NEGB                        * Make it positve
        LSRB                        * 1/2 B gives the number of bytes as we read/write two bytes at a time
!       LDX     ,Y++
        STX     ,U++
        DECB
        BNE     <
        LEAU    A,U                 * Set pointer back to the start
        LEAU    128,U               * Move down to the next row

        TFR     A,B
        NEGB                        * Make it positve
        LSRB                        * 1/2 B gives the number of bytes as we read/write two bytes at a time
!       LDX     ,Y++
        STX     ,U++
        DECB
        BNE     <

        PULS    B
        STB     MMU_Reg_Bank0_0     * Restore Page 0 which is $0000-$1FFF
        PULS    A,X,U,PC
DrawMessageIRQBuff1:
        PSHS    A,X,U
        STB     Misc01
        ANDB    #$7F                * Ignore the Erase flag for now
        LDX     #PreMessLookup
        LDA     #7                  * 7 entries per message
        MUL
        LEAX    D,X                 * Now points to Table data for message in accumulator B
        LDB     MMU_Reg_Bank0_0
        ANDB    #$3F
        PSHS    B
        LDA     ,X                  * Set memory Page Blk 0 to Prerendered Message area 5 to 7
        STA     MMU_Reg_Bank0_0  	* into Page 0 which is $0000-$1FFF
        LDA     3,X                 * get the Mem BLk where to display the message in video RAM
        ADDA    #VideoRam1_0        * Add the pointer to the Vid Buff 1
        JMP     ShowMessage

EraseMessage:
        LDX     #$0000
        TFR     A,B
        NEGB                        * Make it positve
        LSRB                        * 1/2 B gives the number of bytes as we read/write two bytes at a time
!       STX     ,U++
        DECB
        BNE     <
        LEAU    A,U                 * Set pointer back to the start
        LEAU    128,U               * Move down to the next row
        TFR     A,B
        NEGB                        * Make it positve
        LSRB                        * 1/2 B gives the number of bytes as we read/write two bytes at a time
!       STX     ,U++
        DECB
        BNE     <
        LEAU    A,U                 * Set pointer back to the start
        LEAU    128,U               * Move down to the next row
        TFR     A,B
        NEGB                        * Make it positve
        LSRB                        * 1/2 B gives the number of bytes as we read/write two bytes at a time
!       STX     ,U++
        DECB
        BNE     <
        LEAU    A,U                 * Set pointer back to the start
        LEAU    128,U               * Move down to the next row

        TFR     A,B
        NEGB                        * Make it positve
        LSRB                        * 1/2 B gives the number of bytes as we read/write two bytes at a time
!       STX     ,U++
        DECB
        BNE     <
        LEAU    A,U                 * Set pointer back to the start
        LEAU    128,U               * Move down to the next row

        TFR     A,B
        NEGB                        * Make it positve
        LSRB                        * 1/2 B gives the number of bytes as we read/write two bytes at a time
!       STX     ,U++
        DECB
        BNE     <
        LEAU    A,U                 * Set pointer back to the start
        LEAU    128,U               * Move down to the next row
        TFR     A,B
        NEGB                        * Make it positve
        LSRB                        * 1/2 B gives the number of bytes as we read/write two bytes at a time
!       STX     ,U++
        DECB
        BNE     <
        LEAU    A,U                 * Set pointer back to the start
        LEAU    128,U               * Move down to the next row
        TFR     A,B
        NEGB                        * Make it positve
        LSRB                        * 1/2 B gives the number of bytes as we read/write two bytes at a time
!       STX     ,U++
        DECB
        BNE     <
        LEAU    A,U                 * Set pointer back to the start
        LEAU    128,U               * Move down to the next row
        TFR     A,B
        NEGB                        * Make it positve
        LSRB                        * 1/2 B gives the number of bytes as we read/write two bytes at a time
!       STX     ,U++
        DECB
        BNE     <
        PULS    B
        STB     MMU_Reg_Bank0_0     * Restore Page 0 which is $0000-$1FFF
        PULS    A,X,U,PC
Misc02  FCB     $00                 * Used in the routien above
