*****************************************************
** Used Labels                                      *
*****************************************************

TEXT_SCREEN_START       EQU $0400
TEXT_SCREEN_END         EQU $0600


FIRQENR                 EQU $FF93
FIRQ_Jump_position   	EQU $FEF4	* Store $7E which is the JMP opcode
FIRQ_Start_Address      EQU $FEF5	* Store the address you want the IRQ to jumpt to at this address
FIRQ_POINT              EQU $FEF4	* $FEF4 is the usual CoCo3 SuperBasic FIRQ value

IRQENR                  EQU $FF92
IRQ_Jump_position       EQU $FEF7	* Store $7E which is the JMP opcode
IRQ_Start_Address       EQU $FEF8	* Store the address you want the IRQ to jumpt to at this address
IRQ_POINT               EQU $FEF7	* $FEF7 is the usual CoCo3 SuperBasic IRQ value

PIA0_Byte_0_KeyRow_Joy   EQU $FF00
PIA0_Byte_1_HSYNC     	 EQU $FF01
PIA0_Byte_2_KeyColumn_Joy	EQU $FF02
PIA0_Byte_3_VSYNC       EQU $FF03

PIA1_Byte_0_IRQ         EQU $FF20
PIA1_Byte_1_IRQ         EQU $FF21
PIA1_Byte_2             EQU $FF22
PIA1_Byte_3_IRQ_Ct_Snd  EQU $FF23

Disk_Cont_Reg			EQU $FF40
Disk_Comnd_Stat_Reg		EQU $FF48
Disk_Track_Reg			EQU $FF49
Disk_Sector_Reg			EQU $FF4A
Disk_Data_Reg			EQU $FF4B

INIT0_Register0         EQU $FF90
INIT1_Register1         EQU $FF91

Timer_register_MSB      EQU $FF94
Timer_register_LSB      EQU $FF95

Video_Mode_Register     EQU $FF98
Vid_Res_Reg             EQU $FF99
Border_Register         EQU $FF9A
VidStart                EQU $FF9D   *
Hor_Offset_Reg          EQU $FF9F

*Screen Colour Settings
Palette_Start           EQU $FFB0
Palette_0               EQU $FFB0
Palette_1               EQU $FFB1
Palette_2               EQU $FFB2
Palette_3               EQU $FFB3
Palette_4               EQU $FFB4
Palette_5               EQU $FFB5
Palette_6               EQU $FFB6
Palette_7               EQU $FFB7
Palette_8               EQU $FFB8
Palette_9               EQU $FFB9
Palette_10              EQU $FFBA
Palette_11              EQU $FFBB
Palette_12              EQU $FFBC
Palette_13              EQU $FFBD
Palette_14              EQU $FFBE
Palette_15              EQU $FFBF

CoCo1_Regular_Speed     EQU $FFD6
CoCo1_High_Speed        EQU $FFD7
Regular_Speed           EQU $FFD8
High_Speed_Mode         EQU $FFD9
ROM_Mode_Enable         EQU $FFDE
RAM_Mode_Enable         EQU $FFDF

* Screen_Start       	EQU $7000
Border_Colour           EQU $00     * 00 - Black

* MMU Related
MMU_Reg_Bank0_0         EQU $FFA0   * Page $0000-$1FFF  Block #0
MMU_Reg_Bank0_1			EQU $FFA1   * Page $2000-$3FFF  Block #1
MMU_Reg_Bank0_2			EQU $FFA2   * Page $4000-$5FFF  Block #2
MMU_Reg_Bank0_3			EQU $FFA3   * Page $6000-$7FFF  Block #3
MMU_Reg_Bank0_4			EQU $FFA4   * Page $8000-$9FFF  Block #4
MMU_Reg_Bank0_5			EQU $FFA5   * Page $A000-$BFFF  Block #5
MMU_Reg_Bank0_6			EQU $FFA6   * Page $C000-$DFFF  Block #6
MMU_Reg_Bank0_7			EQU $FFA7   * Page $E000-$FFFF  Block #7
MMU_Reg_Bank1_0         EQU $FFA8   * Page $0000-$1FFF  Block #0
MMU_Reg_Bank1_1			EQU $FFA9   * Page $2000-$3FFF  Block #1
MMU_Reg_Bank1_2			EQU $FFAA   * Page $4000-$5FFF  Block #2
MMU_Reg_Bank1_3			EQU $FFAB   * Page $6000-$7FFF  Block #3
MMU_Reg_Bank1_4			EQU $FFAC   * Page $8000-$9FFF  Block #4
MMU_Reg_Bank1_5			EQU $FFAD   * Page $A000-$BFFF  Block #5
MMU_Reg_Bank1_6			EQU $FFAE   * Page $C000-$DFFF  Block #6
MMU_Reg_Bank1_7			EQU $FFAF   * Page $E000-$FFFF  Block #7


*                      PAGE BLK       GIME Address      Used for
VideoRam0_0             EQU $00     * 00000-01FFF       Graphics Memory Buffer 0 VideoRAM
VideoRam0_1             EQU $01     * 02000-03FFF       Graphics Memory
VideoRam0_2             EQU $02     * 04000-05FFF       Graphics Memory
VideoRam0_3             EQU $03     * 06000-07FFF       Graphics Memory
VideoRam0_4             EQU $04     * 08000-09FFF       Graphics Memory
RendTextMess_0          EQU $05     * 0A000-0BFFF       Pre Rendered Text Messages
RendTextMess_1          EQU $06     * 0C000-0DFFF       Pre Rendered Text Messages
RendTextMess_2          EQU $07     * 0E000-0FFFF       Pre Rendered Text Messages
Audio00                 EQU $08     * 10000-11FFF       00_Cutscenes_6khz_8bit_Mono_rev
Audio00a                EQU $09		* 12000-13FFF               ""
Audio00b                EQU $0A		* 14000-15FFF               ""
Audio00c                EQU $0B		* 16000-17FFF               ""
Audio01                 EQU $0C		* 18000-19FFF       01_Eat_Fruit_6khz_8bit_Mono_rev
Audio02                 EQU $0D		* 1A000-1BFFF       02_Eat_Ghost_6khz_8bit_Mono_rev
Audio03                 EQU $0E		* 1C000-1DFFF       03_Eat_Pill_1_6khz_8bit_Mono_rev
Audio04                 EQU $0F		* 1E000-1FFFF       04_Eat_Pill_2_6khz_8bit_Mono_rev
Audio05                 EQU $10     * 20000-21FFF       05_Free_Man_6khz_8bit_Mono_rev
Audio05a                EQU $11     * 22000-23FFF               ""
Audio06                 EQU $12     * 24000-25FFF       06_Ghost_Going_Home_6khz_8bit_Mono_rev
Audio07                 EQU $13     * 26000-27FFF       07_Insert_Coin_6khz_8bit_Mono_rev   ****  When loading program it temporarily loads data from $00000-$26400  (one DSK image max size is 156,672 bytes)
PacmanROM               EQU $14     * 28000-29FFF       Real Pacman ROM located in Pacman from 0000-$1FFF (needed to match random number lookup)
BitmapScreen0           EQU $15     * 2A000-2BFFF       Bitmap Graphic picture Pacman Startup - Option Screen at Page $015-$19 (320x225x16)  = 160 bytes x 225 = 36,000 bytes = $8CA0 bytes
BitmapScreen1           EQU $16     * 2C000-2DFFF       Bitmap Graphic picture Pacman Startup - Option Screen at Page $015-$19 (320x225x16)
BitmapScreen2           EQU $17     * 2E000-2FFFF       Bitmap Graphic picture Pacman Startup - Option Screen at Page $015-$19 (320x225x16)
BitmapScreen3           EQU $18     * 30000-31FFF       Bitmap Graphic picture Pacman Startup - Option Screen at Page $015-$19 (320x225x16)
BitmapScreen4           EQU $19     * 32000-33FFF       Bitmap Graphic picture Pacman Startup - Option Screen at Page $015-$19 (320x225x16) - Can use this for the blank - no sound block
Audio08                 EQU $1A     * 34000-35FFF       08_Intro_Music_6khz_8bit_Mono_rev       - Memory where compressed audio samples will be loaded, samples 00-04,07
Audio08a                EQU $1B     * 36000-37FFF               ""                              - Memory where compressed audio samples will be loaded, samples 00-04,07
Audio08b                EQU $1C     * 38000-39FFF               ""                              - Memory where compressed audio samples will be loaded, samples 00-04,07
Audio08c                EQU $1D     * 3A000-3BFFF               ""                              - Memory where compressed audio samples will be loaded, samples 00-04,07
BigPacMan1              EQU $1E     * 3C000-3DFFF       Big Pacman Comp Sprites - part1 where Big Pacman is coming on the screen
OptionScreenCode        EQU $1F     * 3E000-3FFFF       Code to show BMP and get game options
VideoRam1_0             EQU $20     * 40000-41FFF       Graphics Memory Buffer 1 VideoRAM
VideoRam1_1             EQU $21     * 42000-43FFF       Graphics Memory
VideoRam1_2             EQU $22     * 44000-45FFF       Graphics Memory
VideoRam1_3             EQU $23     * 46000-47FFF       Graphics Memory
VideoRam1_4             EQU $24     * 48000-49FFF       Graphics Memory
PacmanCompSprite        EQU $25     * 4A000-4BFFF       16x16 pixel CoCo 3 HSCREEN 2, 16 Colour, PACMAN compiled sprites code - moved to page 38 most of the time
RedGhostCompSprite      EQU $26     * 4C000-4DFFF       16x16 pixel CoCo 3 HSCREEN 2, 16 Colour, Red Ghost Compiled sprites moved to page 38
PinkGhostCompSprite     EQU $27     * 4E000-4FFFF       16x16 pixel CoCo 3 HSCREEN 2, 16 Colour, Pink Ghost Compiled sprites moved to page 38
BlueGhostCompSprite     EQU $28     * 50000-51FFF       16x16 pixel CoCo 3 HSCREEN 2, 16 Colour, Blue Ghost Compiled sprites moved to page 38
OrangeGhostCompSprite   EQU $29     * 52000-53FFF       16x16 pixel CoCo 3 HSCREEN 2, 16 Colour, Orange Ghost Compiled sprites moved to page 38
CharCompSprite0         EQU $2A     * 54000-55FFF       8x8 pixel CoCo 3 HSCREEN 2,16 Colour graphics/character compiled sprite code - Swapped to page 38 & 39 when needed
CharCompSprite1         EQU $2B     * 56000-57FFF       8x8 pixel CoCo 3 HSCREEN 2,16 Colour graphics/character compiled sprite code - Swapped to page 38 & 39 when needed
FruitCutSceneCompSprite EQU $2C     * 58000-59FFF       16x16 pixel CoCo 3 HSCREEN 2, 16 Colour, compiled sprite code - Fruit and Cutscenes moved to page $38 when needed
CutSceneCode            EQU $2D     * 5A000-5BFFF       Cutscene display code this code will be loaded into Mem BLK 1 - $39 = $2000-$3FFF and run during Cutscenes
Audio09                 EQU $2E     * 5C000-5DFFF       09_Pacman_Death_6khz_8bit_Mono_rev		- Memory where compressed audio samples will be loaded, samples 05,06,08
Audio09a                EQU $2F     * 5E000-5FFFF               ""								- Memory where compressed audio samples will be loaded, samples 05,06,08
Audio10                 EQU $30     * 60000-61FFF       10_Power_Pill_Eaten_6khz_8bit_Mono_rev	- Memory where compressed audio samples will be loaded, samples 05,06,08
Audio11                 EQU $31     * 62000-63FFF       11_Siren_6khz_8bit_Mono_rev             - Memory where compressed audio samples will be loaded, samples 05,06,08
Audio12                 EQU $32     * 64000-65FFF       12_Siren_Faster_6khz_8bit_Mono_rev      		- Memory where compressed audio samples will be loaded, samples 09-12
Audio13                 EQU $33     * 66000-67FFF       - Used as a blank no sound (blank) afterwards 	- Memory where compressed audio samples will be loaded, samples 09-12
CharDataOption          EQU $34     * 68000-69FFF       Character data for Option screen can't use the Pacman compiled text characters as they are for a 256 width screen, Option screen is 320 pixels wide
Spare0                  EQU $35     * 6A000-6BFFF       SPARE
Spare1                  EQU $36     * 6C000-6DFFF       SPARE
Spare2                  EQU $37     * 6E000-6FFFF       SPARE
RegRAM0                 EQU $38     * 70000-71FFF       0000-1FFF       16x16 pixel CoCo 3 HSCREEN 2, 16 Colour sprite data - Also temporarily swapped in character data when needed
RegRAM1                 EQU $39     * 72000-73FFF       2000-3FFF
RegRAM2                 EQU $3A     * 74000-75FFF       4000-5FFF       at $4800 - 6809 Pacman
RegRAM3                 EQU $3B     * 76000-76DFF       6000-7FFF       6809 Pacman
RegRAM4                 EQU $3C     * 78000-79FFF       8000-9FFF       6809 Pacman
RegRAM5                 EQU $3D     * 7A000-7BFFF       A000-BFFF       Graphics Memory swap area - SLZ loader code goes here... can be used by program after loaded
RegRAM6                 EQU $3E     * 7C000-7DFFF       C000-DFFF       Graphics Memory swap area
RegRAM7                 EQU $3F     * 7E000-7FDFF       E000-FDFF       Other maybe used for table data and the stack pointers


