* Test Compiled sprites

Screen_St_hardware      EQU $0000
Screen_Start            EQU $0008   	* Pacman screen start
End_Screen              EQU $8FFF

TileRAM                 EQU $4000		* Still need this space to record which pills have been eaten...
PaletteRAM              EQU $4400		* Still need this space to as ghost directions are effected by the values


*************************************************************
* Include CoCo 3 standard hardware pointers
        INCLUDE pacman_6809_Start.asm
* Load the RAM pages with data

* Include PacMan Character set Data in Page $30
;        ORG     $FFA0
;        FCB     $30
;        ORG     $0000
;        INCLUDE  ./pacman_6809_ROM_Loader_Char_Data_002.asm             * $0000-$1FFF

* Include Main Sprites in Page $32
;        ORG     $FFA0
;        FCB     $32
;        ORG     $0000
;        INCLUDE  ./pacman_6809_ROM_Loader_Sprites_002_Main.asm          * $0000-$1FFF

* Include Original Pacman Sprites in Page $33
;        ORG     $FFA0
;        FCB     $33
;        ORG     $0000
;        INCLUDE  ./pacman_6809_ROM_Loader_Sprites_003_Original.asm      * $0000-$1FFF
;        ORG     $FFA0
;        FCB     $38                 * put it back to the default


;        ORG     $FFA0
;        FCB     $38                 * put it back to the default
;        FCB     $39                 * put it back to the default
;        FCB     $3A                 * put it back to the default
;        FCB     $3B                 * put it back to the default


        ORG     $8000					* Moved above the PacMan Tile and Palette RAM
*************************************************************
* CLS - Clear Main Video Screen
*************************************************************		
ClearVideoRAM:
        PSHS    D,X,Y,U
        CLRA                        * Clear main Video RAM
        BSR     >
        LDA     #$10                * Clear backup video RAM
        BSR     >
		PULS	D,X,Y,U,PC
!       LDU     #$1C1C
        LDB     #5
ClearBankLoop:
        STA		MMU_Reg_Bank0_5     * Set the source pointer to the Main VideoRAM
		LDX		#$A000
!		STU		,X++
		STU		,X++
		STU		,X++
		STU		,X++
		STU		,X++
		STU		,X++
		STU		,X++
		STU		,X++
		STU		,X++
		STU		,X++
		STU		,X++
		STU		,X++
		STU		,X++
		STU		,X++
		STU		,X++
		STU		,X++
		CMPX	#$C000
		BNE		<
        INCA
        DECB
		BNE     ClearBankLoop
        LDA     #$3D                * Put Bank 5 back to normal
        STA		MMU_Reg_Bank0_5
        RTS


MakeGrid:
        LDX     #$0000              * Start of Video RAM
        LDY     #$CCCC
        LDA     #112                * 1/2 screen height
ScreenLoop:
        LDB     #64                 * 1/2 width of the screen
!       STY     ,X++
        DECB
        BNE     <
        LEAX    128,X               * Skip a row
        DECA
        BNE     ScreenLoop
        RTS

***********************************************************
* Pacman palette decoded from the Pacman Colour PROM
* Original Pacman colour PROM has the following values
*
* Weighted values based on internal resister values that affected the direct RGB values from the PROM:
*
* Since the CoCo 3 doesn't have the fidelity of colour range I hand tweaked the third colour value from $35 which is the same
* Orange colour as the 8th colour.  This needed to be a little more brown in colour so I changed it to $22, this way the Orange fruit looks more like it
* should in the game.  The rest of the values are a direct copy of the weighted colours from the Pac Man colour PROM

RGB_Flag:
		FCB		$1                  * 1 = RGB
RGB_Palette:
        FCB     $00     ; Colour 0  - Black
        FCB     $24     ; Colour 1  - Red
        FCB     $22     ; Colour 2  - Orange/Brown   * hand tweaked this value to $22 to get a little more brown, original value is $35 same as palette 7
        FCB     $3D     ; Colour 3  - Pink
        FCB     $00     ; Colour 4  - Black
        FCB     $1B     ; Colour 5  - Light Blue
        FCB     $1D     ; Colour 6  - Medium Blue
        FCB     $35     ; Colour 7  - Orange
        FCB     $09     ; Colour 8  - Dark Blue for maze, changed from 11 since we will use this to flash the maze from blue to white after a level is complete
        FCB     $36     ; Colour 9  - Yellow
        FCB     $3C     ; Colour 10 - Dullish Pink - used to flash Power Pills
        FCB     $09     ; Colour 11 - Dark Blue
        FCB     $12     ; Colour 12 - Green
        FCB     $18     ; Colour 13 - Dullish Green
        FCB     $3C     ; Colour 14 - Dullish Pink
        FCB     $3F     ; Colour 15 - White

* Composite colours are from a lookup chart from RGB to CMP I found on the internet
* some values aren't compatible with RGB so I guessed...  Might need tweaking if someone can
* figure out better values, they looks like crap using MAME
CMP_Palette:
        FCB     00
        FCB     39
        FCB     21
        FCB     57
        FCB     00
        FCB     46
        FCB     60
        FCB     53
        FCB     44
        FCB     36
        FCB     55
        FCB     44
        FCB     18
        FCB     30
        FCB     55
        FCB     48

* My own values looking at my TV
*        FCB     $00,$07,$24,$39
*        FCB     $00,$3D,$0D,$14
*        FCB     $0B,$34,$36,$0B
*        FCB     $0F,$1B,$36,$3F
************************************************************************

START
***********************************************************
System_EnableGraphics
        ORCC    #$50                    * Disable interrupts
        CLR     High_Speed_Mode       	* High Speed mode enabled
        LDU     #Palette_Start          * Make all colours black so screen updates aren't visible
        LDB     #16
!       CLR     ,U+
        DECB
        BNE     <

*        LDS     #Stack_Pointer         * Bypass setting up the stack since the bigloader sets it to $FE00


        LDA     #%00110100              * Setup the CoCo 3's hardware
        STA     PIA0_Byte_1_HSYNC       * HSYNC IRQ Disabled, IRQ Polarity Flag falling Edge, Data Direction Normal, Select Line LSB = 0, HSYNC Flag = 0
        STA     PIA0_Byte_3_VSYNC       * VSYNC IRQ Disabled, IRQ Polarity Flag falling Edge, Data Direction Normal, Select Line MSB = 0, VSYNC Flag = 0
        STA     PIA1_Byte_1_IRQ         * CONTROL OF CD FIRQ* TO CPU DISABLED, IRQ Polarity Falling Edge of CD, CD Flag off
        STA     PIA1_Byte_3_IRQ_Ct_Snd  * CONTROL OF Cart FIRQ* TO CPU DISABLED, IRQ Polarity Falling Edge of Cart, Cart Flag off

        LDA     #%01001100              * Diasble the Interrupts for now until the characters and sprites have been pre-rendered
        STA     INIT0_Register0         * CoCo 3 Mode, MMU Enabled, GIME IRQ Disabled, GIME FIRQ Disabled, Vector RAM at FEXX enabled, Standard SCS Normal, ROM Map 16k Int, 16k Ext
        LDA     #%00100000              *
        STA     INIT1_Register1         * Mem Type 64k chips, 279.365 nsec timer, MMU Task 0 - $FFA0-$FFA7
        LDA     #%10000000              *
        STA     Video_Mode_Register     * Graphics mode, Colour output, 60 hz, max vertical res

        LDA     #%00000000              * $00
        STA     IRQENR                  * Disable IRQ
        LDA     #%00000000              * $00
        STA     FIRQENR                 * Disable FIRQ

        JSR     ClearVideoRAM           * Clear the graphics RAM area - 28 (viewable Horiz) x 36 (Vert) Characters which are 8x8, Total screen RAM is 256x288
                                        * Each Line is 128 Bytes long
                                        * Our closest viewable screen size available is 256 x 225
                                        * Total screen size including the scrolling area is 256 x 288
                                        * with 16 Colours requires 36,864 bytes = $9000 bytes of RAM
        JSR     MakeGrid

BacktoStart:

***********************************************************
* Set Hires Screen Resolution and the number of Colours
*
* Bit Pattern   Rows Displayed
*    x00xxxxx   192
*    x01xxxxx   200
*    x10xxxxx   *zero/infinite lines on screen (undefined)
*    x11xxxxx   225
* Bit Pattern   Bytes/Row (Graphics)
*    xxx000xx   16
*    xxx001xx   20
*    xxx010xx   32
*    xxx011xx   40
*    xxx100xx   64
*    xxx101xx   80   320 4 Colours 01
*    xxx110xx   128
*    xxx111xx   160
* Bit Pattern   Colours     Pixels/Byte
*    xxxxxx00   2           8
*    xxxxxx01   4           4
*    xxxxxxl0   16          2
*    xxxxxx11   Undefined   Undefined
***********************************************************
* Most Common used settings (Uncomment the one you want to use)
*       LDA     #%00001000            	* 256 x 192 x 2 Colours  requires 6,144  bytes = $1800 RAM
*       LDA     #%00101000            	* 256 x 200 x 2 Colours  requires 6,400  bytes = $1900 RAM
*       LDA     #%01101000            	* 256 x 225 x 2 Colours  requires 7,200  bytes = $1C20 RAM
*       LDA     #%00010001            	* 256 x 192 x 4 Colours  requires 12,288 bytes = $3000 RAM
*       LDA     #%00110001            	* 256 x 200 x 4 Colours  requires 12,800 bytes = $3200 RAM
*       LDA     #%01110001            	* 256 x 225 x 4 Colours  requires 14,400 bytes = $3840 RAM
*       LDA     #%00011010            	* 256 x 192 x 16 Colours requires 24,576 bytes = $6000 RAM
*       LDA     #%00111010            	* 256 x 200 x 16 Colours requires 25,600 bytes = $6400 RAM
        LDA     #%01111010            	* 256 x 225 x 16 Colours requires 28,800 bytes = $7080 RAM
*       LDA     #%00001100            	* 320 x 192 x 2 Colours  requires 7,680  bytes = $1E00 RAM
*       LDA     #%00101100            	* 320 x 200 x 2 Colours  requires 8,000  bytes = $1F40 RAM
*       LDA     #%01101100            	* 320 x 225 x 2 Colours  requires 10,240 bytes = $2800 RAM
*       LDA     #%00010101            	* 320 x 192 x 4 Colours  requires 15,360 bytes = $3C00 RAM
*       LDA     #%00110101            	* 320 x 200 x 4 Colours  requires 16,000 bytes = $3E80 RAM
*       LDA     #%01110101            	* 320 x 225 x 4 Colours  requires 18,000 bytes = $4650 RAM
*       LDA     #%00011110            	* 320 x 192 x 16 Colours requires 30,720 bytes = $7800 RAM
*       LDA     #%00111110            	* 320 x 200 x 16 Colours requires 32,000 bytes = $7D00 RAM
*       LDA     #%01111110            	* 320 x 225 x 16 Colours requires 36,000 bytes = $8CA0 RAM
*       LDA     #%00010100            	* 640 x 192 x 2 Colours  requires 15,360 bytes = $3C00 RAM
*       LDA     #%00110100            	* 640 x 200 x 2 Colours  requires 16,000 bytes = $3E80 RAM
*       LDA     #%01110100            	* 640 x 225 x 2 Colours  requires 18,000 bytes = $4650 RAM
*       LDA     #%00011101            	* 640 x 192 x 4 Colours  requires 30,720 bytes = $7800 RAM
*       LDA     #%00111101            	* 640 x 200 x 4 Colours  requires 32,000 bytes = $7D00 RAM
*       LDA     #%01111101            	* 640 x 225 x 4 Colours  requires 36,000 bytes = $8CA0 RAM

        STA     Vid_Res_Reg

* Pacman will require a screen size of 256x288 so we will have to scroll through extra RAM
* A screen size of 256x288x16 Colours is 36864 bytes or $9000
***********************************************************
        LDD     #$0000                	* Point video screen veiwer to $00000 (Hi-Res page start)
        STD     VidStart              	* Pointer value is $00000 / 8 = $0000 = $0000 in our 512k of RAM

        CLR     Hor_Offset_Reg        	* Don't use a Horizontal offset

        LDX     #RGB_Palette			* Setup the Palette for either RGB or Composite
		TST		RGB_Flag
        BNE		>
		LDX		#CMP_Palette
Load_Palette:
!       LDY     #Palette_Start
        LDB     #16
!       LDA     ,X+
        STA     ,Y+
        DECB
        BNE     <

        LDA     #$00
        STA     MMU_Reg_Bank0_0         * Set Page 0 - $0000 - $1FFF to mem BLK 0 where the video RAM is setup
        INCA
        STA     MMU_Reg_Bank0_1
        INCA
        STA     MMU_Reg_Bank0_2

        BRA     TestOther
T1:
        LDD     #$00AB
        LDX		#$2001-128*12
        LSRB
        LEAX	B,X					* Add the current location of Big Pac Man to the memory location, X now = where in Memory Big Pac Man will be displayed on screen
        BCC     >                   * If Carry is clear then it's an even number position so draw an even sprite
        INCA                        * If the Carry is set Add two to A so that the table pointer points to an odd sprite
		INCA
!       LDU     #TestOther
		LEAX	-20,X				* Adjust the X location for the Big Pacman
        JSR     [A,U]
!
        BRA     <


        LDD     #$00AE
		LDX		#$2001-128*12
        LSRB
        LEAX	B,X					* Add the current location of Big Pac Man to the memory location, X now = where in Memory Big Pac Man will be displayed on screen
        BCC     >                   * If Carry is clear then it's an even number position so draw an even sprite
        INCA                        * If the Carry is set Add two to A so that the table pointer points to an odd sprite
		INCA
!       LDU     #TestOther
		LEAX	-20,X				* Adjust the X location for the Big Pacman
        JSR     [A,U]
!
        BRA     <



        LDD     #$04B0
		LDX		#$2001-128*12
        LSRB
        LEAX	B,X					* Add the current location of Big Pac Man to the memory location, X now = where in Memory Big Pac Man will be displayed on screen
        BCC     >                   * If Carry is clear then it's an even number position so draw an even sprite
        INCA                        * If the Carry is set Add two to A so that the table pointer points to an odd sprite
		INCA
!       LDU     #TestOther
		LEAX	-20,X				* Adjust the X location for the Big Pacman
        JSR     [A,U]
!
        BRA     <
















Test:
        LDX     #$2000-128*12
;        LDY     #BigPacParts
        CLRB
!       PSHS    B,X,Y
        CLRA
        LSLB
        ROLA
        LEAU    [D,Y]
;        CMPU    #NoBigPacMan
        BNE     Show
        DEC     TempByte
        BRA     NoShow
Show:
        JSR     [D,Y]

NoShow:
        PULS    B,X,Y
        INCB
        INC     TempByte
        LDA     TempByte
        BITA    #1
        BNE     NoDecX
        LDX     #$4000-128*12
        BRA     Skip1
NoDecX:
        LDX     #$2000-128*12
Skip1:
        CMPB    #$25                * Current Last Sprite
        BLS     <
!
        BRA     <
TempByte:
        FCB     $00


TestOther:
        LDX     #$1000
        PSHS    X
        JSR     PacLeftBigOdd
        PULS    X
        LEAX    $8,X
        PSHS    X
        JSR     PacLeftBigOdd
        PULS    X
        LDX		#$1000+128*64
        PSHS    X
        JSR     PacLeftBigOdd
        PULS    X
        LDX		#$1000+8+128*64
        PSHS    X
        JSR     PacLeftBigOdd
        PULS    X

!
        BRA     <


*		ORG		$8000
        opt     c
        opt     ct

        opt     cd
        opt     cc
PacLeftBigEven:
        LEAU    5+128*12,X
        LDD     #$4999
        LDX     #$9999
        LDY     #$9994
        PSHU    B,Y         *1
        LEAU    -128+4,U
        PSHU    X,Y         *2
        LEAU    -128+4,U
        PSHU    D,X         *3
        LEAU    -128+4,U
        PSHU    B,X         *4
        LEAU    -128+4,U
        PSHU    D,Y         *5
        LEAU    -128+4,U
        PSHU    B,Y         *6
        LEAU    -128+3,U
        PSHU    A,Y         *7
        LEAU    -128+3,U
        PSHU    B,Y         *8
        LEAU    -128+3,U
        PSHU    D,Y         *9
        LEAU    -128+3,U
        PSHU    B,X         *10
        LEAU    -128+3,U
        PSHU    D,X         *11
        LEAU    -128+4,U
        PSHU    X,Y         *12
        LEAU    -128+3,U
        PSHU    B,Y
        RTS
PacLeftBigOdd:
        LEAU    5+128*12,X
        LDD     #$4999
        LDX     #$9999
        LDY     #$9994
        PSHU    A,X         *1
        LEAU    -128+4,U
        PSHU    D,X         *2
        LEAU    -128+5,U
        PSHU    X,Y         *3
        LEAU    -128+4,U
        PSHU    D,Y         *4
        LEAU    -128+4,U
        PSHU    B,X         *5
        LEAU    -128+3,U
        PSHU    A,X         *6
        LEAU    -256+3,U
        LDA     #$99
        STD     126,U       *7
        LDA     #$49
        PSHU    A,X         *8
        LEAU    -128+3,U
        PSHU    B,X         *9
        LEAU    -128+3,U
        PSHU    D,Y         *10
        LEAU    -128+4,U
        PSHU    X,Y         *11
        LEAU    -128+3,U
        PSHU    D,X         *12
        LEAU    -128+3,U
        PSHU    A,X         *13
        RTS




*
Final	END     START                   * set exec address







