;===============================
; Difficulty tables,value per level
; until top value
;===============================
NormalDiff:     
        FCB        $00,$01,$02,$03				;0068                DB 0,1,2,3,4,5,6,7,8,9
        FCB        $04,$05,$06,$07
        FCB        $08,$09,$0A,$0B
        FCB        $0C,$0D,$0E,$0F
        FCB        $10                          
        FCB        $11,$12,$13,$14              ;0068 00             DB 11h,12h,13h,14h
HardDiff:     
        FCB        $01,$03,$04,$06				;007D                DB 1,3,4,6,7,8,9,0Ah,0
        FCB        $07,$08,$09,$0A
        FCB        $0B,$0C,$0D,$0E
        FCB        $0F,$10,$11                  
        FCB        $14                          ;007D 01 03 04       DB 14h
;=========================
; TimerTable used in UpdateTimer routine
; each value tells when a nibble
; overflows to the next value
;=========================
TimerTable:     
        FCB        $06                          ;0219                DB 6      when we count six 60ths of a second,roll over next nibble
        FCB        $A0                          ;021A 0              DB 0A0h   when we count 10 in the high nibble,increment a second counter
        FCB        $0A                          ;021B A              DB 0Ah
        FCB        $60                          ;021C 0              DB 60h                
        FCB        $0A                          ;021D A              DB 0Ah                
        FCB        $60                          ;021E 0              DB 60h                
        FCB        $0A                          ;021F A              DB 0Ah                
        FCB        $A0                          ;0220 0              DB 0A0h

; ---------------------------------------------------------------------------
* These values have been swapped, they are read in while doing the ROM Checks

;        ORG     $0796
; ---------------------------------------------------------------------------
;       -- difficulty related table
;    each entry is 6 bytes
;       Byte 0: (0..6) movement bit patterns and orientation changes (table at 330F)
;       Byte 1: (00,01,02) stored at 4DB0 - seems to be unused
;       Byte 2: (0..3) ghost counter table to exit home (table at 0843)
;       Byte 3: (0..7) remaining number of pills to set difficulty flags (table at 084F)
;       Byte 4: (0..8) ghost time to stay blue when pacman eats the big pill (table at 0861)
;       Byte 5: (0..2) number of units before a ghost goes out of home (table at 0873)
DifficultyTable:     
        FCB     $03,$01,$01,$00
        FCB     $02,$00                             ;0796             DB 3,1,1,0,2,0     ; Referenced from 716
        FCB     $04,$01,$02,$01
        FCB     $03,$00                             ;0796 03          DB 4,1,2,1,3,0                     
        FCB     $04,$01,$03,$02
        FCB     $04,$01                             ;0796 03          DB 4,1,3,2,4,1                     
        FCB     $04,$02,$03,$02
        FCB     $05,$01                             ;0796 03          DB 4,2,3,2,5,1                     
        FCB     $05,$00,$03,$02
        FCB     $06,$02                             ;0796 03          DB 5,0,3,2,6,2                     
        FCB     $05,$01,$03,$03
        FCB     $03,$02                             ;0796 03          DB 5,1,3,3,3,2                     
        FCB     $05,$02,$03,$03
        FCB     $06,$02                             ;0796 03          DB 5,2,3,3,6,2                     
        FCB     $05,$02,$03,$03
        FCB     $06,$02                             ;0796 03          DB 5,2,3,3,6,2                     
        FCB     $05,$00,$03,$04
        FCB     $07,$02                             ;0796 03          DB 5,0,3,4,7,2                     
        FCB     $05,$01,$03,$04
        FCB     $03,$02                             ;0796 03          DB 5,1,3,4,3,2                     
        FCB     $05,$02,$03,$04
        FCB     $06,$02                             ;0796 03          DB 5,2,3,4,6,2                     
        FCB     $05,$02,$03,$05
        FCB     $07,$02                             ;0796 03          DB 5,2,3,5,7,2                     
        FCB     $05,$00,$03,$05
        FCB     $07,$02                             ;0796 03          DB 5,0,3,5,7,2                     
        FCB     $05,$02,$03,$05
        FCB     $05,$02                             ;0796 03          DB 5,2,3,5,5,2                     
        FCB     $05,$01,$03,$06
        FCB     $07,$02                             ;0796 03          DB 5,1,3,6,7,2                     
        FCB     $05,$02,$03,$06
        FCB     $07,$02                             ;0796 03          DB 5,2,3,6,7,2                     
        FCB     $05,$02,$03,$06
        FCB     $08,$02                             ;0796 03          DB 5,2,3,6,8,2                     
        FCB     $05,$02,$03,$06
        FCB     $07,$02                             ;0796 03          DB 5,2,3,6,7,2                     
        FCB     $05,$02,$03,$07
        FCB     $08,$02                             ;0796 03          DB 5,2,3,7,8,2                     
        FCB     $05,$02,$03,$07
        FCB     $08,$02                             ;0796 03          DB 5,2,3,7,8,2                     
        FCB     $06,$02,$03,$07
        FCB     $08,$02                             ;0796 03          DB 6,2,3,7,8,2                     

;        ORG     $0843
; ---------------------------------------------------------------------------
;-- table related to difficulty - each entry is 3 bytes
; b0: when counter at 4E0F reaches this value,pink ghost goes out of home
; b1: when counter at 4E10 reaches this value,Blue ghost goes out of home
; b2: when counter at 4E11 reaches this value,orange ghost goes out of home
DifficultyTable2:     
        FCB     $14,$1E,$46                         ;0843             DB 14h,1Eh,46h
        FCB     $00,$1E,$3C                         ;0843 14          DB 0,1Eh,3Ch                     
        FCB     $00,$00,$32                         ;0843 14          DB 0,0,32h                     
        FCB     $00,$00,$00                         ;0843 14          DB 0,0,0                     
; remaining number of pills to set difficulty flags (table at 084F)
DifficultyTable2b:
;        FCB     $14,$0A,$1E                         ;084F 14          DB 14h,0Ah,1Eh
;        FCB     $0F,$28,$14                         ;084F 14          DB 0Fh,28h,14h
;        FCB     $32,$19,$3C                         ;084F 14          DB 32h,19h,3Ch
;        FCB     $1E,$50,$28                         ;084F 14          DB 1Eh,50h,28h
;        FCB     $64,$32,$78                         ;084F 14          DB 64h,32h,78h
;        FCB     $3C,$8C,$46                         ;084F 14          DB 3Ch,8Ch,46h
;These get loaded and flipped then saved as 16 bits numbers which will flipp them again
; This way we can load it just like this and save them just like this for future use
        FCB     $0A,$14
        FCB     $0F,$1E
        FCB     $14,$28
        FCB     $19,$32
        FCB     $1E,$3C
        FCB     $28,$50
        FCB     $32,$64
        FCB     $3C,$78
        FCB     $46,$8C
; time ghosts stay blue when energizer eaten
GhostTime:     
        FDB     $03C0                               ;0861             DW 3C0h                 ; 960
        FDB     $0348                               ;0863 48          DW 348h                 ; 840
        FDB     $02D0                               ;0865 D0          DW 2D0h                 ; 720
        FDB     $0258                               ;0867 58          DW 258h                 ; 600
        FDB     $01E0                               ;0869 E0          DW 1E0h                 ; 480
        FDB     $0168                               ;086B             DW 168h                 ; 360
        FDB     $00F0                               ;086D F0          DW 0F0h                 ; 240
        FDB     $0078                               ;086F 78          DW 78h                  ; 120
        FDB     $0001                               ;0871 0100F0      DW 1                    ; 1 
; number of units before ghosts leave home
HomeDiffTable:     
        FDB     $00F0                               ;0873             DW 0F0h                 ; 240
        FDB     $00F0                               ;0875 F0          DW 0F0h                 ; 240
        FDB     $00B4                               ;0877 B4          DW 0B4h                 ; 180

; ==============================
; efd-f3b : table for fruit shapes,Colors,point value
; bytes in that order
; ==============================
LevelDataTbl:     
        FCB     $00,$14,$06                         ;0EFD 00          DB 0,14h,6            ; shape,ref from EDB
        FCB     $01,$0F,$07                         ;0EFD 00          DB 1,0Fh,7                     
        FCB     $02,$15,$08                         ;0EFD 00          DB 2,15h,8                     
        FCB     $02,$15,$08                         ;0EFD 00          DB 2,15h,8                     
        FCB     $04,$14,$09                         ;0EFD 00          DB 4,14h,9                     
        FCB     $04,$14,$09                         ;0EFD 00          DB 4,14h,9                     
        FCB     $05,$17,$0A                         ;0EFD 00          DB 5,17h,0Ah                     
        FCB     $05,$17,$0A                         ;0EFD 00          DB 5,17h,0Ah                     
        FCB     $06,$09,$0B                         ;0EFD 00          DB 6,9,0Bh                     
        FCB     $06,$09,$0B                         ;0EFD 00          DB 6,9,0Bh                     
        FCB     $03,$16,$0C                         ;0EFD 00          DB 3,16h,0Ch                     
        FCB     $03,$16,$0C                         ;0EFD 00          DB 3,16h,0Ch                     
        FCB     $07,$16,$0D                         ;0EFD 00          DB 7,16h,0Dh                     
        FCB     $07,$16,$0D                         ;0EFD 00          DB 7,16h,0Dh                     
        FCB     $07,$16,$0D                         ;0EFD 00          DB 7,16h,0Dh                     
        FCB     $07,$16,$0D                         ;0EFD 00          DB 7,16h,0Dh                     
        FCB     $07,$16,$0D                         ;0EFD 00          DB 7,16h,0Dh                     
        FCB     $07,$16,$0D                         ;0EFD 00          DB 7,16h,0Dh                     
        FCB     $07,$16,$0D                         ;0EFD 00          DB 7,16h,0Dh                     
        FCB     $07,$16,$0D                         ;0EFD 00          DB 7,16h,0Dh                     
        FCB     $07,$16,$0D                         ;0EFD 00          DB 7,16h,0Dh


;        ORG     $272C
; ---------------------------------------------------------------------------
; scores needed for bonus men: 10K,15K,20K,none
BonusLife:     
        FCB     $10                                 ;2728             DB 10h                  ; ref from 2700
        FCB     $15                                 ;2729             DB 15h                     
        FCB     $20                                 ;272A 20FF        DB 20h                     
        FCB     $FF                                 ;272B             DB 0FFh                     
;addresses of normal/hard tables
HardnessPtr:     
        FDB     NormalDiff                          ;272C             DW 68h
        FDB     HardDiff                            ;272E 7D          DW 7Dh

;        ORG     $2B17
; ---------------------------------------------------------------------------
; score for various items
ScoringTable:     
        FDB     $0010                               ;2B17             			DW 10h                  ; dot
        FDB     $0050                               ;2B19 0500				    DW 50h                  ; pellet
        FDB     $0200                               ;2B1B 2000				    DW 200h                 ; ghost 1
        FDB     $0400                               ;2B1D 4000				    DW 400h                 ; ghost 2
        FDB     $0800                               ;2B1F 8000				    DW 800h                 ; ghost 3
        FDB     $1600                               ;2B21 6001				    DW 1600h                ; ghost 4
        FDB     $0100                               ;2B23 1000				    DW 100h                 ; cherry
        FDB     $0300                               ;2B25 3000				    DW 300h                 ; strawberry
        FDB     $0500                               ;2B27 5000				    DW 500h                 ; orange
        FDB     $0700                               ;2B29 7000				    DW 700h                 ; ...todo
        FDB     $1000                               ;2B2B 0001				    DW 1000h
        FDB     $2000                               ;2B2D 0002				    DW 2000h
        FDB     $3000                               ;2B2F 0003				    DW 3000h
        FDB     $5000                               ;2B31 0005				    DW 5000h                ; fruit

;        ORG     $3154
RAMTestTable:
        FDB     $4C00                               ;3154             DW 4C00h                ; work RAM low nibble,ref from 3042
        FDB     $040F                               ;3156 0F04        DW 40Fh
        FDB     $4C00                               ;3158 004C        DW 4C00h                ; work RAM high nibble
        FDB     $04F0                               ;315A F004        DW 4F0h
        FDB     $4000                               ;315C 0040        DW 4000h                ; video RAM low nibble
        FDB     $0F04                               ;315E 0F04        DW 40Fh
        FDB     $4000                               ;3160 0040        DW 4000h                ; video RAM high nibble
        FDB     $04F0                               ;3162 F004        DW 4F0h
        FDB     $4400                               ;3164 0044        DW 4400h                ; color RAM low nibble
        FDB     $040F                               ;3166 0F04        DW 40Fh
        FDB     $4400                               ;3168 0044        DW 4400h                ; color RAM high nibble
        FDB     $04F0                               ;316A F004        DW 4F0h
BonusTextTable:     
        FDB     $3031                  				;32F9      			DW 3130h               "10"
        FDB     $3531                  				;32FB 35      		DW 3135h               "15"
        FDB     $3032                  				;32FD       		DW 3230h               "20"
;        ORG     $32FF
;tile movement deltas,with second copy for speed
DeltaRight:     
        FDB     $FF00                               ;32FF             DW 0FF00h
DeltaDown:     
        FDB     $0001                               ;3301             DW 1
DeltaLeft:     
        FDB     $0100                               ;3303             DW 100h
DeltaUp:     
        FDB     $00FF                               ;3305             DW 0FFh
DeltaRight2:     
        FDB     $FF00                               ;3307             DW 0FF00h
DeltaDown2:     
        FDB     $0001                               ;3309             DW 1
DeltaLeft2:     
        FDB     $0100                               ;330B             DW 100h
DeltaUp2:     
        FDB     $00FF                               ;330D             DW 0FFh

; data - table for difficulty
;       each entry has 3 sections
;       0: 0x10 bytes - movement bit patterns
;       1: 0x0c bytes - ghost data movement bit patterns
;       2: 0x0e bytes - ghost counters for orientation changes
;                       4dc1-4dc3 related
Difficulty1:                                        * Values will be swapped when copied to $4D46... Pac Man Ram location
        FCB     $55,$2A                             * 4D46 = $2A55  will be doubled and if the Carry is set Increment $4D48 & 9
        FCB     $55,$2A                             * 4D48 = $2A55 value is doubled then above line is done
        FCB     $55,$55A                            * 4D4A = $5555  will be doubled and if the Carry is set Increment $4D4C & D
        FCB     $55,$55                             * 4D4C = $5555 value is doubled then above line is done
        FCB     $55,$2A,$55,$2A
        FCB     $52,$4A,$A5,$94             		;330F             DB 55h,2Ah,55h,2Ah,55h,55h,55h,55h,55h,2Ah,55h,2Ah,52h,4Ah,0A5h,94h

        FCB     $25,$25,$25,$25
        FCB     $22,$22,$22,$22
        FCB     $01,$01,$01,$01             		;331F 25          DB 25h,25h,25h,25h,22h,22h,22h,22h,1,1,1,1

        FCB     $58,$02,$08,$07
        FCB     $60,$09,$10,$0E
        FCB     $68,$10,$70,$17
        FCB     $14,$19                             ;332B             DB 58h,2,8,7,60h,9,10h,0Eh,68h,10h,70h,17h,14h,19h
Difficulty2:     
        FCB     $52,$4A,$A5,$94
        FCB     $AA,$2A,$55,$55
        FCB     $55,$2A,$55,$2A
        FCB     $52,$4A,$A5,$94             		;3339             DB 52h,4Ah,0A5h,94h,0AAh,2Ah,55h,55h,55h,2Ah,55h,2Ah,52h,4Ah,0A5h,94h

        FCB     $92,$24,$25,$49
        FCB     $48,$24,$22,$91
        FCB     $01,$01,$01,$01            			;3349 92          DB 92h,24h,25h,49h,48h,24h,22h,91h,1,1,1,1

        FCB     $00,$00,$00,$00
        FCB     $00,$00,$00,$00
        FCB     $00,$00,$00,$00
        FCB     $00,$00                     		;3355 00          DB 0,0,0,0,0,0,0,0,0,0,0,0,0,0
Difficulty3:     
        FCB     $55,$2A,$55,$2A
        FCB     $55,$55,$55,$55
        FCB     $AA,$2A,$55,$55
        FCB     $55,$2A,$55,$2A               		;3363             DB 55h,2Ah,55h,2Ah,55h,55h,55h,55h,0AAh,2Ah,55h,55h,55h,2Ah,55h,2Ah

        FCB     $52,$4A,$A5,$94
        FCB     $48,$24,$22,$91
        FCB     $21,$44,$44,$08          			;3373 52          DB 52h,4Ah,0A5h,94h,48h,24h,22h,91h,21h,44h,44h,8

        FCB     $58,$02,$34,$08
        FCB     $D8,$09,$B4,$0F
        FCB     $58,$11,$08,$16
        FCB     $34,$17                             ;337F 58          DB 58h,2,34h,8,0D8h,9,0B4h,0Fh,58h,11h,8,16h,34h,17h
SpeedControlTable:     
        FQB     $55555555                           ;338D             DL 55555555h          ; Pac-Man normal speed board 1
        FQB     $D56AD56A                           ;3391 D5          DL 6AD56AD5h            ; Pac-Man Blue speed board 1
        FQB     $AA6A55D5                           ;3395 AA          DL 0D5556AAAh           ; 2nd alternate speed for Red
        FQB     $55555555                           ;3399 55          DL 55555555h            ; 1st alternate speed for Red

        FQB     $AA2A5555                           ;339D AA          DL 55552AAAh            ; ghost normal speed board 1
        FQB     $92249224                           ;33A1 92          DL 24922492h            ; ghost blue speed board 1
        FQB     $22222222                           ;33A5 222222      DL 22222222h            ; ghost tunnel speed board 1

        FQB     $A4015406
        FQB     $F807A80C
        FQB     $D40D8412
        FDB     $B013                               ;33A9             DB 0A4h,1,54h,6,0F8h,7,0A8h,0Ch,0D4h,0Dh,84h,12h,0B0h,13h ; TODO - this part unknown?
Known?:     
        FQB     $D56AD56A                           ;33B7             DL 6AD56AD5h            ; Pac-Man normal speed boards 2-4
        FQB     $D65AADB5                           ;33BB D65A        DL 0B5AD5AD6h           ; Pac-Man blue speed boards 2-4
        FQB     $D65AADB5                           ;33BF D65A        DL 0B5AD5AD6h                     
        FQB     $D56AD56A                           ;33C3 D5          DL 6AD56AD5h                     

        FQB     $AA6A55D5                           ;33C7 AA          DL 0D5556AAAh           ; ghost regular speed boards 2-4
        FQB     $92242549
        FQB     $48242291                           ;33D3             DB 0A4h ; ñ

        FQB     $A4015406                           ;33D7 F8          DB 0F8h ; °
        FQB     $F807A80C                           ;33DB D40DFE      DB 0D4h ; +
        FQB     $D40DFEFF
        FDB     $FFFF                               ;33E1 6D          DB 6Dh ; m
Known1?:
        FQB     $6D6D6D6D                           ;33E5 6D          DB 6Dh ; m
        FQB     $6D6D6D6D                           ;33E9 B6          DB 0B6h ; ¦
        FQB     $B66D6DDB                           ;33ED             DB 6Dh ; m
        FQB     $6D6D6D6D                           ;33F1 D65A        DB 0D6h ; +

        FQB     $D65AADB5                           ;33F5 25          DB 25h ; %
        FQB     $25252525                           ;33F9 92          DB 92h ; Æ
        FQB     $92249224                           ;33FD 2C          DB 2Ch ; ,

        FQB     $2C01DC05                           ;3401 08          DB 8
        FQB     $0807B80B                           ;3405 E40CFE      DB 0E4h ; S
        FQB     $E40CFEFF                           ;3409 FF          DB 0FFh
        FDB     $FFFF                               ;340B D5          DB 0D5h ; +
Known2?:
        FQB     $D56AD56A                           ;340F D5          DB 0D5h ; +
        FQB     $D56AD56A                           ;3413 B6          DB 0B6h ; ¦
        FQB     $B66D6DDB                           ;3417             DB 6Dh ; m
        FQB     $6D6D6D6D                           ;341B D65A        DB 0D6h ; +

        FQB     $D65AADB5                           ;341F 48          DB 48h ; H
        FQB     $48242291                           ;3423             DB 92h ; Æ
        FQB     $92249224                           ;3427 2C          DB 2Ch ; ,

        FQB     $2C01DC05                           ;342B 08          DB 8
        FQB     $0807B80B                           ;342F E40CFE      DB 0E4h ; S
        FQB     $E40CFEFF                           ;3433 FF          DB 0FFh
        FCB     $FFFF                               ;3434 FF          DB 0FFh

;======================
; Compressed map information
; TODO - decode
;
;======================
MapTable:     
        FCB     $40,$FC,$D0,$D2
        FCB     $D2,$D2,$D2,$D2
        FCB     $D2,$D2,$D2                         ;3435             DB 40h,0FCh,0D0h,0D2h,0D2h,0D2h,0D2h,0D2h,0D2h,0D2h,0D2h ; MapTable
        FCB     $D4,$FC,$FC,$FC
        FCB     $DA,$02,$DC,$FC
        FCB     $FC,$FC,$D0                         ;3435 40          DB 0D4h,0FCh,0FCh,0FCh,0DAh,2,0DCh,0FCh,0FCh,0FCh,0D0h
        FCB     $D2,$D2,$D2,$D2
        FCB     $D6,$D8,$D2,$D2
        FCB     $D2,$D2,$D4                         ;3435 40          DB 0D2h,0D2h,0D2h,0D2h,0D6h,0D8h,0D2h,0D2h,0D2h,0D2h,0D4h
        FCB     $FC,$DA,$09,$DC
        FCB     $FC,$FC,$FC,$DA
        FCB     $02,$DC,$FC,$FC            			;3435 40          DB 0FCh,0DAh,9,0DCh,0FCh,0FCh,0FCh,0DAh,2,0DCh,0FCh,0FCh
        FCB     $FC,$DA,$05,$DE
        FCB     $E4,$05,$DC,$FC
        FCB     $DA,$02,$E6,$E8          			;3435 40          DB 0FCh,0DAh,5,0DEh,0E4h,5,0DCh,0FCh,0DAh,2,0E6h,0E8h
        FCB     $EA,$02,$E6,$EA
        FCB     $02,$DC,$FC,$FC
        FCB     $FC,$DA,$02,$DC        				;3435 40          DB 0EAh,2,0E6h,0EAh,2,0DCh,0FCh,0FCh,0FCh,0DAh,2,0DCh
        FCB     $FC,$FC,$FC,$DA
        FCB     $02,$E6,$EA,$02
        FCB     $E7,$EB,$02,$E6               		;3435 40          DB 0FCh,0FCh,0FCh,0DAh,2,0E6h,0EAh,2,0E7h,0EBh,2,0E6h
        FCB     $EA,$02,$DC,$FC
        FCB     $DA,$02,$DE,$FC
        FCB     $E4,$02,$DE,$E4               		;3435 40          DB 0EAh,2,0DCh,0FCh,0DAh,2,0DEh,0FCh,0E4h,2,0DEh,0E4h
        FCB     $02,$DC,$FC,$FC
        FCB     $FC,$DA,$02,$DC
        FCB     $FC,$FC,$FC,$DA               		;3435 40          DB 2,0DCh,0FCh,0FCh,0FCh,0DAh,2,0DCh,0FCh,0FCh,0FCh,0DAh
        FCB     $02,$DE,$E4,$05
        FCB     $DE,$E4,$02,$DC
        FCB     $FC,$DA,$02,$DE
        FCB     $FC                                 ;3435 40          DB 2,0DEh,0E4h,5,0DEh,0E4h,2,0DCh,0FCh,0DAh,2,0DEh,0FCh
        FCB     $E4,$02,$DE,$E4
        FCB     $02,$DC,$FC,$FC
        FCB     $FC,$DA,$02,$DC           			;3435 40          DB 0E4h,2,0DEh,0E4h,2,0DCh,0FCh,0FCh,0FCh,0DAh,2,0DCh
        FCB     $FC,$FC,$FC,$DA
        FCB     $02,$DE,$F2,$E8
        FCB     $E8,$EA,$02,$DE         			;3435 40          DB 0FCh,0FCh,0FCh,0DAh,2,0DEh,0F2h,0E8h,0E8h,0EAh,2,0DEh
        FCB     $E4,$02,$DC,$FC
        FCB     $DA,$02,$E7,$E9
        FCB     $EB,$02,$E7,$EB             		;3435 40          DB 0E4h,2,0DCh,0FCh,0DAh,2,0E7h,0E9h,0EBh,2,0E7h,0EBh
        FCB     $02,$E7,$D2,$D2
        FCB     $D2,$EB,$02,$E7
        FCB     $D2,$D2,$D2,$EB            			;3435 40          DB 2,0E7h,0D2h,0D2h,0D2h,0EBh,2,0E7h,0D2h,0D2h,0D2h,0EBh
        FCB     $02,$E7,$E9,$E9
        FCB     $E9,$EB,$02,$DE
        FCB     $E4,$02,$DC,$FC             		;3435 40          DB 2,0E7h,0E9h,0E9h,0E9h,0EBh,2,0DEh,0E4h,2,0DCh,0FCh
        FCB     $DA,$1B,$DE,$E4
        FCB     $02,$DC,$FC,$DA
        FCB     $02,$E6,$E8,$F8         			;3435 40          DB 0DAh,1Bh,0DEh,0E4h,2,0DCh,0FCh,0DAh,2,0E6h,0E8h,0F8h
        FCB     $02,$F6,$E8,$E8
        FCB     $E8,$E8,$E8,$E8
        FCB     $F8,$02,$F6,$E8              		;3435 40          DB 2,0F6h,0E8h,0E8h,0E8h,0E8h,0E8h,0E8h,0F8h,2,0F6h,0E8h
        FCB     $E8,$E8,$EA,$02
        FCB     $E6,$F8,$02,$F6
        FCB     $E8,$E8,$F4,$E4               		;3435 40          DB 0E8h,0E8h,0EAh,2,0E6h,0F8h,2,0F6h,0E8h,0E8h,0F4h,0E4h
        FCB     $02,$DC,$FC,$DA
        FCB     $02,$DE,$FC,$E4
        FCB     $02,$F7,$E9,$E9               		;3435 40          DB 2,0DCh,0FCh,0DAh,2,0DEh,0FCh,0E4h,2,0F7h,0E9h,0E9h
        FCB     $F5,$F3,$E9,$E9
        FCB     $F9,$02,$F7,$E9
        FCB     $E9,$E9,$EB                         ;3435 40          DB 0F5h,0F3h,0E9h,0E9h,0F9h,2,0F7h,0E9h,0E9h,0E9h,0EBh
        FCB     $02,$DE,$E4,$02
        FCB     $F7,$E9,$E9,$F5
        FCB     $E4,$02,$DC,$FC              		;3435 40          DB 2,0DEh,0E4h,2,0F7h,0E9h,0E9h,0F5h,0E4h,2,0DCh,0FCh
        FCB     $DA,$02,$DE,$FC
        FCB     $E4,$05,$DE,$E4
        FCB     $0B,$DE,$E4,$05            			;3435 40          DB 0DAh,2,0DEh,0FCh,0E4h,5,0DEh,0E4h,0Bh,0DEh,0E4h,5
        FCB     $DE,$E4,$02,$DC
        FCB     $FC,$DA,$02,$DE
        FCB     $FC,$E4,$02,$E6            			;3435 40          DB 0DEh,0E4h,2,0DCh,0FCh,0DAh,2,0DEh,0FCh,0E4h,2,0E6h
        FCB     $EA,$02,$DE,$E4
        FCB     $02,$EC,$D3,$D3
        FCB     $D3,$EE,$02,$E6               		;3435 40          DB 0EAh,2,0DEh,0E4h,2,0ECh,0D3h,0D3h,0D3h,0EEh,2,0E6h
        FCB     $EA,$02,$DE,$E4
        FCB     $02,$E6,$EA,$02
        FCB     $DE,$E4,$02,$DC
        FCB     $FC                                 ;3435 40          DB 0EAh,2,0DEh,0E4h,2,0E6h,0EAh,2,0DEh,0E4h,2,0DCh,0FCh
        FCB     $DA,$02,$E7,$E9
        FCB     $EB,$02,$DE,$E4
        FCB     $02,$E7,$EB,$02
        FCB     $DC                                 ;3435 40          DB 0DAh,2,0E7h,0E9h,0EBh,2,0DEh,0E4h,2,0E7h,0EBh,2,0DCh
        FCB     $FC,$FC,$FC,$DA
        FCB     $02,$DE,$E4,$02
        FCB     $E7,$EB,$02,$DE             		;3435 40          DB 0FCh,0FCh,0FCh,0DAh,2,0DEh,0E4h,2,0E7h,0EBh,2,0DEh
        FCB     $E4,$02,$E7,$EB
        FCB     $02,$DC,$FC,$DA
        FCB     $06,$DE,$E4,$05
        FCB     $F0                                 ;3435 40          DB 0E4h,2,0E7h,0EBh,2,0DCh,0FCh,0DAh,6,0DEh,0E4h,5,0F0h
        FCB     $FC,$FC,$FC,$DA
        FCB     $02,$DE,$E4,$05
        FCB     $DE,$E4,$05,$DC            			;3435 40          DB 0FCh,0FCh,0FCh,0DAh,2,0DEh,0E4h,5,0DEh,0E4h,5,0DCh
        FCB     $FC,$FA,$E8,$E8
        FCB     $E8,$EA,$02,$DE
        FCB     $F2,$E8,$E8                         ;3435 40          DB 0FCh,0FAh,0E8h,0E8h,0E8h,0EAh,2,0DEh,0F2h,0E8h,0E8h
        FCB     $EA,$02,$CE,$FC
        FCB     $FC,$FC,$DA,$02
        FCB     $DE,$F2,$E8,$E8         			;3435 40          DB 0EAh,2,0CEh,0FCh,0FCh,0FCh,0DAh,2,0DEh,0F2h,0E8h,0E8h
        FCB     $EA,$02,$DE,$F2
        FCB     $E8,$E8,$EA,$02              		;3435 40          DB 0EAh,2,0DEh,0F2h,0E8h,0E8h,0EAh,2
        FCB     $DC,$00,$00,$00
        FCB     $00
;======================
; Pill layout data
;======================
PillTable: 
		FCB		$62,$01,$02
        FCB     $01,$01,$01,$01
        FCB     $0C,$01,$01,$04
        FCB     $01,$01                             ;35B0             DB 0DCh,0,0,0,0,62h,1,2,1,1,1,1,0Ch,1,1,4,1,1
        FCB     $01,$04,$04,$03
        FCB     $0C,$03,$03,$03
        FCB     $04,$04,$03,$0C
        FCB     $03,$01,$01,$01
        FCB     $03,$04,$04                         ;35B0             DB 1,4,4,3,0Ch,3,3,3,4,4,3,0Ch,3,1,1,1,3,4,4
        FCB     $03,$0C,$06,$03
        FCB     $04,$04,$03,$0C
        FCB     $06,$03,$04,$01
        FCB     $01,$01,$01,$01
        FCB     $01,$01,$01                         ;35B0             DB 3,0Ch,6,3,4,4,3,0Ch,6,3,4,1,1,1,1,1,1,1,1
        FCB     $01,$01,$01,$01
        FCB     $01,$01,$01,$01
        FCB     $01,$01,$01,$01
        FCB     $01,$01,$01,$01
        FCB     $01,$03,$04,$04
        FCB     $0F                                 ;35B0             DB 1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,3,4,4,0Fh
        FCB     $03,$06,$04,$04
        FCB     $0F,$03,$06,$04
        FCB     $04,$01,$01,$01
        FCB     $0C,$03,$01,$01
        FCB     $01,$03,$04                         ;35B0             DB 3,6,4,4,0Fh,3,6,4,4,1,1,1,0Ch,3,1,1,1,3,4
        FCB     $04,$03,$0C,$03
        FCB     $03,$03,$04,$04
        FCB     $03,$0C,$03,$03
        FCB     $03,$04,$01,$01
        FCB     $01,$01,$03                         ;35B0             DB 4,3,0Ch,3,3,3,4,4,3,0Ch,3,3,3,4,1,1,1,1,3
        FCB     $0C,$01,$01,$01
        FCB     $03,$01,$01,$01
        FCB     $08,$18,$08,$18
        FCB     $04,$01,$01,$01
        FCB     $01,$03,$0C                         ;35B0             DB 0Ch,1,1,1,3,1,1,1,8,18h,8,18h,4,1,1,1,1,3,0Ch
        FCB     $01,$01,$01,$03
        FCB     $01,$01,$01,$04
        FCB     $04,$03,$0C,$03
        FCB     $03,$03,$04,$04
        FCB     $03,$0C,$03                         ;35B0             DB 1,1,1,3,1,1,1,4,4,3,0Ch,3,3,3,4,4,3,0Ch,3
        FCB     $03,$03,$04,$04
        FCB     $01,$01,$01,$0C
        FCB     $03,$01,$01,$01
        FCB     $03,$04,$04,$0F
        FCB     $03,$06,$04                         ;35B0             DB 3,3,4,4,1,1,1,0Ch,3,1,1,1,3,4,4,0Fh,3,6,4
        FCB     $04,$0F,$03,$06
        FCB     $04,$01,$01,$01
        FCB     $01,$01,$01,$01
        FCB     $01,$01,$01,$01
        FCB     $01,$01,$01,$01           			;35B0             DB 4,0Fh,3,6,4,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1
        FCB     $01,$01,$01,$01
        FCB     $01,$01,$01,$01
        FCB     $01,$01,$03,$04
        FCB     $04,$03,$0C,$06
        FCB     $03,$04,$04,$03            			;35B0             DB 1,1,1,1,1,1,1,1,1,1,3,4,4,3,0Ch,6,3,4,4,3
        FCB     $0C,$06,$03,$04
        FCB     $04,$03,$0C,$03
        FCB     $01,$01,$01,$03
        FCB     $04,$04,$03,$0C
        FCB     $03,$03,$03                         ;35B0             DB 0Ch,6,3,4,4,3,0Ch,3,1,1,1,3,4,4,3,0Ch,3,3,3
        FCB     $04,$01,$02,$01
        FCB     $01,$01,$01,$0C
        FCB     $01,$01,$04,$01
        FCB     $01,$01                             ;35B0             DB 4,1,2,1,1,1,1,0Ch,1,1,4,1,1,1
        
*****
* Prerendered Messages:
* Table Format:
* 00        - Blk where Message is stored
* 01 & 02   - Address where Message is stored
* 03        - Mem blok where to display the message
* 04 & 05   - Address where to display the message
* 06        - Length of the message
PreMessLookup:
        RMB     7*55                    * 55 Messages

;        ORG     $36A5
; Encode pointers to message
; Used from 2C5E DrawMessage
MessageTable:
        FDB     Message_00              ;36A5             		 DW 3713h                ; 00h = "HIGH SCORE" message
        FDB     Message_01              ;36A7 2337			;    DW 3723h                ; 01h = "CREDIT"
        FDB     Message_02              ;36A9 3237			;    DW 3732h                ; 02h = "FREE PLAY"
        FDB     Message_03              ;36AB 4137			;    DW 3741h                ; 03h = "PLAYER ONE"
        FDB     Message_04              ;36AD 5A37			;    DW 375Ah                ; 04h = "PLAYER TWO"
        FDB     Message_05              ;36AF 6A37			;    DW 376Ah                ; 05h = "GAME OVER"
        FDB     Message_06              ;36B1 7A37			;    DW 377Ah                ; 06h = "READY"
        FDB     Message_07              ;36B3 8637			;    DW 3786h                ; 07h = "PUSH START BUTTON"
        FDB     Message_08              ;36B5 9D37			;    DW 379Dh                ; 08h = "1 PLAYER ONLY"
        FDB     Message_09              ;36B7 B137			;    DW 37B1h                ; 09h = "1 OR 2 PLAYERS"
        FDB     Message_10              ;36B9 003D			;    DW 3D00h                ; 0Ah = "BONUS PAC MAN FOR   000"
        FDB     Message_11              ;36BB 213D			;    DW 3D21h                ; 0Bh = "1980 MIDWAY MFG CO"
        FDB     Message_12              ;36BD FD37			;    DW 37FDh                ; 0Ch = "CHARACTER"
        FDB     Message_13              ;36BF 673D			;    DW 3D67h                ; 0Dh = "BLINKY"
        FDB     Message_14              ;36C1 E33D			;    DW 3DE3h                ; 0Eh = "BBBBBBBB"
        FDB     Message_15              ;36C3 863D			;    DW 3D86h                ; 0Fh = "PINKY"
        FDB     Message_16              ;36C5 023E			;    DW 3E02h                ; 10h = "DDDDDDDD"
        FDB     Message_17              ;36C7 4C38			;    DW 384Ch                ; 11h = "10"
        FDB     Message_18              ;36C9 5A38			;    DW 385Ah                ; 12h = "50"
        FDB     Message_19              ;36CB 3C3D			;    DW 3D3Ch                ; 13h = "1980 MIDWAY MFG CO"
        FDB     Message_20              ;36CD 573D			;    DW 3D57h                ; 14h = "SHADOW"
        FDB     Message_21              ;36CF D33D			;    DW 3DD3h                ; 15h = "AAAAAAAA"
        FDB     Message_22              ;36D1 763D			;    DW 3D76h                ; 16h = "SPEEDY"
        FDB     Message_23              ;36D3 F23D			;    DW 3DF2h                ; 17h = "CCCCCCCC" - alternate name of a ghost
        FDB     Message_18              ;36D5 0100			;    DW 1                    ; 18h = unused? TODO
        FDB     Message_18              ;36D7 0200			;    DW 2                    ; 19h = unused? TODO
        FDB     Message_18              ;36D9 0300			;    DW 3                    ; 1Ah = unused? TODO
        FDB     Message_27              ;36DB BC38			;    DW 38BCh                ; 1Bh = small "100"
        FDB     Message_28              ;36DD C438			;    DW 38C4h                ; 1Ch = small " 300"
        FDB     Message_29              ;36DF CE38			;    DW 38CEh                ; 1Dh = small " 500"
        FDB     Message_30              ;36E1 D838			;    DW 38D8h                ; 1Eh = small " 700"
        FDB     Message_31              ;36E3 E238			;    DW 38E2h                ; 1Fh = small " 1000"
        FDB     Message_32              ;36E5 EC38			;    DW 38ECh                ; 20h = small "2000"
        FDB     Message_33              ;36E7 F638			;    DW 38F6h                ; 21h = small "3000"
        FDB     Message_34              ;36E9 0039			;    DW 3900h                ; 22h = small "5000"
        FDB     Message_35              ;36EB 0A39       		 DW 390Ah                ; 23h = "MEMORY  OK"
        FDB     Message_36              ;36ED 1A39			;    DW 391Ah                ; 24h = "BAD    R M" ; $24
        FDB     Message_37              ;36EF 6F39			;    DW 396Fh                ; 25h = "FREE  PLAY       "
        FDB     Message_38              ;36F1 2A39       		 DW 392Ah                ; 26h = "1 COIN  1 CREDIT "
        FDB     Message_39              ;36F3 5839			;    DW 3958h                ; 27h = "1 COINS 2 CREDITS"
        FDB     Message_40              ;36F5 4139			;    DW 3941h                ; 28h = "2 COINS 1 CREDIT "
        FDB     Message_41              ;36F7 4F3E			;    DW 3E4Fh                ; 29h = PAC MAN
        FDB     Message_42              ;36F9             		 DW 3986h                ; 2Ah = "BONUS  NONE"
        FDB     Message_43              ;36FB 9739			;    DW 3997h                ; 2Bh = "BONUS"
        FDB     Message_44              ;36FD B039			;    DW 39B0h                ; 2Ch = "TABLE  "
        FDB     Message_45              ;36FF BD39			;    DW 39BDh                ; 2Dh = "UPRIGHT"
        FDB     Message_46              ;3701 CA39			;    DW 39CAh                ; 2Eh = "000"
        FDB     Message_47              ;3703 A53D			;    DW 3DA5h                ; 2Fh = "INKY"
        FDB     Message_48              ;3705 213E			;    DW 3E21h                ; 30h = "FFFFFFFF"
        FDB     Message_49              ;3707 C43D			;    DW 3DC4h                ; 31h = "CLYDE"
        FDB     Message_50              ;3709 403E			;    DW 3E40h                ; 32h = "HHHHHHHH"
        FDB     Message_51              ;370B 953D			;    DW 3D95h                ; 33h = "BASHFUL"
        FDB     Message_52              ;370D 113E			;    DW 3E11h                ; 34h = "EEEEEEEE"
        FDB     Message_53              ;370F            		 DW 3DB4h                ; 35h = "POKEY"
        FDB     Message_54              ;3711 B43D			;    DW 3E30h                ; 36h = "GGGGGGGG"
;=======================
; Text messages
; TODO - format?
;=======================
        FCB        $3E                  ;3712
Message_00:
        FCB        $D4                  ;3713               ;     DW 83D4h               offset,vertical
        FCB        $83
        FCB        $48                  ;3715               ;     DB 48h,49h,47h,48h,40h "HIGH SCORE"
        FCB        $49
        FCB        $47
        FCB        $48
        FCB        $40
        FCB        $53
        FCB        $43
        FCB        $4F
        FCB        $52
        FCB        $45
        FCB        $2F
        FCB        $8F                  ;3720 8F             DB 8Fh,2Fh,80h         color,TODO?
        FCB        $2F
        FCB        $80
Message_01:     
        FCB        $3B                  ;3723                DB 3Bh ; ;             Message 01
        FCB        $80                  ;3724 80             DB 80h ; Ç            Ç                     
        FCB        $43                  ;3725 43             DB 43h ; C             C                     
        FCB        $52                  ;3726 52             DB 52h ; R             R                     
        FCB        $45                  ;3727 45             DB 45h ; E             E                     
        FCB        $44                  ;3728 44             DB 44h ; D             D                     
        FCB        $49                  ;3729 49             DB 49h ; I             I                     
        FCB        $54                  ;372A 54             DB 54h ; T             T
;        FCB        $40                  ;372B 40             DB 40h ; @             @
;        FCB        $40                  ;372C 40             DB 40h ; @             @
;        FCB        $40                  ;372D 40             DB 40h ; @             @
        FCB        $2F                  ;372E 2F             DB 2Fh ; /             /                     
        FCB        $8F                  ;372F 8F             DB 8Fh ; Å            Å                     
        FCB        $2F                  ;3730 2F             DB 2Fh ; /             /                     
        FCB        $80                  ;3731 80             DB 80h ; Ç            Ç                     
Message_02:     
        FCB        $3B                  ;3732                DB 3Bh ; ;
        FCB        $80                  ;3733 80             DB 80h ; Ç            Ç                     
        FCB        $46                  ;3734 46             DB 46h ; F             F                     
        FCB        $52                  ;3735 52             DB 52h ; R             R                     
        FCB        $45                  ;3736 45             DB 45h ; E             E                     
        FCB        $45                  ;3737 45             DB 45h ; E             E                     
        FCB        $40                  ;3738 40             DB 40h ; @             @                     
        FCB        $50                  ;3739 50             DB 50h ; P             P                     
        FCB        $4C                  ;373A 4C             DB 4Ch ; L             L                     
        FCB        $41                  ;373B 41             DB 41h ; A             A                     
        FCB        $59                  ;373C 59             DB 59h ; Y             Y                     
        FCB        $2F                  ;373D 2F             DB 2Fh ; /             /                     
        FCB        $8F                  ;373E 8F             DB 8Fh ; Å            Å                     
        FCB        $2F                  ;373F 2F             DB 2Fh ; /             /                     
        FCB        $80                  ;3740 80             DB 80h ; Ç            Ç                     
Message_03:     
        FCB        $8C                  ;3741                DB 8Ch ; î î
        FCB        $02                  ;3742 02             DB 2                  
        FCB        $50                  ;3743 50             DB 50h ; P             P                     
        FCB        $4C                  ;3744 4C             DB 4Ch ; L             L                     
        FCB        $41                  ;3745 41             DB 41h ; A             A                     
        FCB        $59                  ;3746 59             DB 59h ; Y             Y                     
        FCB        $45                  ;3747 45             DB 45h ; E             E                     
        FCB        $52                  ;3748 52             DB 52h ; R             R                     
        FCB        $40                  ;3749 40             DB 40h ; @             @                     
        FCB        $4F                  ;374A 4F             DB 4Fh ; O             O                     
        FCB        $4E                  ;374B 4E             DB 4Eh ; N             N                     
        FCB        $45                  ;374C 45             DB 45h ; E             E                     
        FCB        $2F                  ;374D 2F             DB 2Fh ; /             /                     
        FCB        $85                  ;374E 85             DB 85h ; à            à                     
        FCB        $2F                  ;374F 2F             DB 2Fh ; /             /                     
        FCB        $10                  ;3750 10 10          DB 10h                
        FCB        $10                  ;3751                DB 10h                
        FCB        $1A                  ;3752 1A             DB 1Ah                
        FCB        $1A                  ;3753 1A             DB 1Ah                
        FCB        $1A                  ;3754 1A             DB 1Ah                
        FCB        $1A                  ;3755 1A             DB 1Ah                
        FCB        $1A                  ;3756 1A             DB 1Ah                
        FCB        $1A                  ;3757 1A             DB 1Ah                
        FCB        $10                  ;3758 10 10          DB 10h                
        FCB        $10                  ;3759                DB 10h                
Message_04:     
        FCB        $8C                  ;375A                DB 8Ch ; î î
        FCB        $02                  ;375B 02             DB 2                  
        FCB        $50                  ;375C 50             DB 50h ; P             P                     
        FCB        $4C                  ;375D 4C             DB 4Ch ; L             L                     
        FCB        $41                  ;375E 41             DB 41h ; A             A                     
        FCB        $59                  ;375F 59             DB 59h ; Y             Y                     
        FCB        $45                  ;3760 45             DB 45h ; E             E                     
        FCB        $52                  ;3761 52             DB 52h ; R             R                     
        FCB        $40                  ;3762 40             DB 40h ; @             @                     
        FCB        $54                  ;3763 54             DB 54h ; T             T                     
        FCB        $57                  ;3764 57             DB 57h ; W             W                     
        FCB        $4F                  ;3765 4F             DB 4Fh ; O             O                     
        FCB        $2F                  ;3766 2F             DB 2Fh ; /             /                     
        FCB        $85                  ;3767 85             DB 85h ; à            à                     
        FCB        $2F                  ;3768 2F             DB 2Fh ; /             /                     
        FCB        $80                  ;3769 80             DB 80h ; Ç            Ç                     
Message_05:     
        FCB        $92                  ;376A                DB 92h ; Æ Æ
        FCB        $02                  ;376B 02             DB 2                  
        FCB        $47                  ;376C 47             DB 47h ; G             G                     
        FCB        $41                  ;376D 41             DB 41h ; A             A                     
        FCB        $4D                  ;376E 4D             DB 4Dh ; M             M                     
        FCB        $45                  ;376F 45             DB 45h ; E             E                     
        FCB        $40                  ;3770 40             DB 40h ; @             @                     
        FCB        $40                  ;3771 40             DB 40h ; @             @                     
        FCB        $4F                  ;3772 4F             DB 4Fh ; O             O                     
        FCB        $56                  ;3773 56             DB 56h ; V             V                     
        FCB        $45                  ;3774 45             DB 45h ; E             E                     
        FCB        $52                  ;3775 52             DB 52h ; R             R                     
        FCB        $2F                  ;3776 2F             DB 2Fh ; /             /                     
        FCB        $81                  ;3777 81             DB 81h ; ü            ü                     
        FCB        $2F                  ;3778 2F             DB 2Fh ; /             /                     
        FCB        $80                  ;3779 80             DB 80h ; Ç            Ç   
Message_06:		
        FCB        $52                  ;377A 52             DB 52h ; R             R                     
        FCB        $02                  ;377B 02             DB 2                  
        FCB        $52                  ;377C 52             DB 52h ; R             R                     
        FCB        $45                  ;377D 45             DB 45h ; E             E                     
        FCB        $41                  ;377E 41             DB 41h ; A             A                     
        FCB        $44                  ;377F 44             DB 44h ; D             D                     
        FCB        $59                  ;3780 59             DB 59h ; Y             Y                     
        FCB        $5B                  ;3781 5B             DB 5Bh ; [             [                     
        FCB        $2F                  ;3782 2F             DB 2Fh ; /             /                     
        FCB        $89                  ;3783 89             DB 89h ; ë            ë                     
        FCB        $2F                  ;3784 2F             DB 2Fh ; /             /                     
        FCB        $90                  ;3785 90             DB 90h ; É            É                     
Message_07:
        FCB        $EE                  ;3786 EE 02          DB 0EEh ; e            e                     
        FCB        $02                  ;3787                DB 2                  
        FCB        $50                  ;3788 50             DB 50h ; P             P                     
        FCB        $55                  ;3789 55             DB 55h ; U             U                     
        FCB        $53                  ;378A 53             DB 53h ; S             S                     
        FCB        $48                  ;378B 48             DB 48h ; H             H                     
        FCB        $40                  ;378C 40             DB 40h ; @             @                     
        FCB        $53                  ;378D 53             DB 53h ; S             S                     
        FCB        $54                  ;378E 54             DB 54h ; T             T                     
        FCB        $41                  ;378F 41             DB 41h ; A             A                     
        FCB        $52                  ;3790 52             DB 52h ; R             R                     
        FCB        $54                  ;3791 54             DB 54h ; T             T                     
        FCB        $40                  ;3792 40             DB 40h ; @             @                     
        FCB        $42                  ;3793 42             DB 42h ; B             B                     
        FCB        $55                  ;3794 55             DB 55h ; U             U                     
        FCB        $54                  ;3795 54             DB 54h ; T             T                     
        FCB        $54                  ;3796 54             DB 54h ; T             T                     
        FCB        $4F                  ;3797 4F             DB 4Fh ; O             O                     
        FCB        $4E                  ;3798 4E             DB 4Eh ; N             N                     
        FCB        $2F                  ;3799 2F             DB 2Fh ; /             /                     
        FCB        $87                  ;379A 87             DB 87h ; ç            ç                     
        FCB        $2F                  ;379B 2F             DB 2Fh ; /             /                     
        FCB        $80                  ;379C 80             DB 80h ; Ç            Ç                     
Message_08:
        FCB        $B2                  ;379D B2             DB 0B2h ; ¦           ¦                     
        FCB        $02                  ;379E 02             DB 2                  
        FCB        $31                  ;379F 31 40 50       DB 31h ; 1             1                     
        FCB        $40                  ;37A0                DB 40h ; @             @                     
        FCB        $50                  ;37A1                DB 50h ; P             P                     
        FCB        $4C                  ;37A2 4C             DB 4Ch ; L             L                     
        FCB        $41                  ;37A3 41             DB 41h ; A             A                     
        FCB        $59                  ;37A4 59             DB 59h ; Y             Y                     
        FCB        $45                  ;37A5 45             DB 45h ; E             E                     
        FCB        $52                  ;37A6 52             DB 52h ; R             R                     
        FCB        $40                  ;37A7 40             DB 40h ; @             @                     
        FCB        $4F                  ;37A8 4F             DB 4Fh ; O             O                     
        FCB        $4E                  ;37A9 4E             DB 4Eh ; N             N                     
        FCB        $4C                  ;37AA 4C             DB 4Ch ; L             L                     
        FCB        $59                  ;37AB 59             DB 59h ; Y             Y                     
        FCB        $40                  ;37AC 40             DB 40h ; @             @                     
        FCB        $2F                  ;37AD 2F             DB 2Fh ; /             /                     
        FCB        $85                  ;37AE 85             DB 85h ; à            à                     
        FCB        $2F                  ;37AF 2F             DB 2Fh ; /             /                     
        FCB        $80                  ;37B0 80             DB 80h ; Ç            Ç                     
Message_09:
        FCB        $B2                  ;37B1 B2             DB 0B2h ; ¦           ¦                     
        FCB        $02                  ;37B2 02             DB 2                  
        FCB        $31                  ;37B3 31 40 4F       DB 31h ; 1             1                     
        FCB        $40                  ;37B4                DB 40h ; @             @                     
        FCB        $4F                  ;37B5                DB 4Fh ; O             O                     
        FCB        $52                  ;37B6 52             DB 52h ; R             R                     
        FCB        $40                  ;37B7 40             DB 40h ; @             @                     
        FCB        $32                  ;37B8 32 40 50       DB 32h ; 2             2                     
        FCB        $40                  ;37B9                DB 40h ; @             @                     
        FCB        $50                  ;37BA                DB 50h ; P             P                     
        FCB        $4C                  ;37BB 4C             DB 4Ch ; L             L                     
        FCB        $41                  ;37BC 41             DB 41h ; A             A                     
        FCB        $59                  ;37BD 59             DB 59h ; Y             Y                     
        FCB        $45                  ;37BE 45             DB 45h ; E             E                     
        FCB        $52                  ;37BF 52             DB 52h ; R             R                     
        FCB        $53                  ;37C0 53             DB 53h ; S             S                     
        FCB        $2F                  ;37C1 2F             DB 2Fh ; /             /                     
        FCB        $85                  ;37C2 85             DB 85h ; à            à                     
        FCB        $00                  ;37C3 00             DB 0                  
        FCB        $2F                  ;37C4 2F             DB 2Fh ; /             /                     
        FCB        $00                  ;37C5 00             DB 0                  
        FCB        $80                  ;37C6 80             DB 80h ; Ç            Ç                     
        FCB        $00                  ;37C7 00             DB 0                  
        FCB        $96                  ;37C8 96             DB 96h ; û            û                     
        FCB        $03                  ;37C9 03             DB 3                  
        FCB        $42                  ;37CA 42             DB 42h ; B             B                     
        FCB        $4F                  ;37CB 4F             DB 4Fh ; O             O                     
        FCB        $4E                  ;37CC 4E             DB 4Eh ; N             N                     
        FCB        $55                  ;37CD 55             DB 55h ; U             U                     
        FCB        $53                  ;37CE 53             DB 53h ; S             S                     
        FCB        $40                  ;37CF 40             DB 40h ; @             @                     
        FCB        $50                  ;37D0 50             DB 50h ; P             P                     
        FCB        $55                  ;37D1 55             DB 55h ; U             U                     
        FCB        $43                  ;37D2 43             DB 43h ; C             C                     
        FCB        $4B                  ;37D3 4B             DB 4Bh ; K             K                     
        FCB        $4D                  ;37D4 4D             DB 4Dh ; M             M                     
        FCB        $41                  ;37D5 41             DB 41h ; A             A                     
        FCB        $4E                  ;37D6 4E             DB 4Eh ; N             N                     
        FCB        $40                  ;37D7 40             DB 40h ; @             @                     
        FCB        $46                  ;37D8 46             DB 46h ; F             F                     
        FCB        $4F                  ;37D9 4F             DB 4Fh ; O             O                     
        FCB        $52                  ;37DA 52             DB 52h ; R             R                     
        FCB        $40                  ;37DB 40             DB 40h ; @             @                     
        FCB        $40                  ;37DC 40             DB 40h ; @             @                     
        FCB        $40                  ;37DD 40             DB 40h ; @             @                     
        FCB        $30                  ;37DE 30 30          DB 30h ; 0             0                     
        FCB        $30                  ;37DF                DB 30h ; 0             0                     
        FCB        $30                  ;37E0 30 40          DB 30h ; 0             0                     
        FCB        $40                  ;37E1                DB 40h ; @             @                     
        FCB        $5D                  ;37E2 5D             DB 5Dh ; ]             ]                     
        FCB        $5E                  ;37E3 5E             DB 5Eh ; ^             ^                     
        FCB        $5F                  ;37E4 5F             DB 5Fh ; _             _                     
        FCB        $2F                  ;37E5 2F             DB 2Fh ; /             /                     
        FCB        $8E                  ;37E6 8E             DB 8Eh ; Ä            Ä                     
        FCB        $2F                  ;37E7 2F             DB 2Fh ; /             /                     
        FCB        $80                  ;37E8 80             DB 80h ; Ç            Ç                     
        FCB        $BA                  ;37E9 BA             DB 0BAh ; ¦           ¦                     
        FCB        $02                  ;37EA 02             DB 2                  
        FCB        $5C                  ;37EB 5C             DB 5Ch ; \             \                     
        FCB        $40                  ;37EC 40             DB 40h ; @             @                     
        FCB        $28                  ;37ED 28 R2 9        DB 28h ; (             (                     
        FCB        $29                  ;37EE                DB 29h ; )             )                     
        FCB        $2A                  ;37EF 2A 2B 2C       DB 2Ah ; *             *                     
        FCB        $2B                  ;37F0                DB 2Bh ; +             +                     
        FCB        $2C                  ;37F1                DB 2Ch ; ,             ,                     
        FCB        $2D                  ;37F2 2D             DB 2Dh ; -             -                     
        FCB        $2E                  ;37F3 2E 40          DB 2Eh ; .             .                     
        FCB        $40                  ;37F4                DB 40h ; @             @                     
        FCB        $31                  ;37F5 31 39 38       DB 31h ; 1             1                     
        FCB        $39                  ;37F6                DB 39h ; 9             9                     
        FCB        $38                  ;37F7                DB 38h ; 8             8                     
        FCB        $30                  ;37F8 30 2F          DB 30h ; 0             0                     
        FCB        $2F                  ;37F9                DB 2Fh ; /             /                     
        FCB        $83                  ;37FA 83             DB 83h ; â            â                     
        FCB        $2F                  ;37FB 2F             DB 2Fh ; /             /                     
        FCB        $80                  ;37FC 80             DB 80h ; Ç            Ç                     
Message_12:
        FCB        $C3                  ;37FD C3 02 43       DB 0C3h ; +            +                     
        FCB        $02                  ;37FE                DB 2                  
        FCB        $43                  ;37FF                DB 43h ; C             C                     
        FCB        $48                  ;3800 48             DB 48h ; H             H                     
        FCB        $41                  ;3801 41             DB 41h ; A             A                     
        FCB        $52                  ;3802 52             DB 52h ; R             R                     
        FCB        $41                  ;3803 41             DB 41h ; A             A                     
        FCB        $43                  ;3804 43             DB 43h ; C             C                     
        FCB        $54                  ;3805 54             DB 54h ; T             T                     
        FCB        $45                  ;3806 45             DB 45h ; E             E                     
        FCB        $52                  ;3807 52             DB 52h ; R             R                     
        FCB        $40                  ;3808 40             DB 40h ; @             @                     
        FCB        $3A                  ;3809 3A 40 4E       DB 3Ah ; :             :                     
        FCB        $40                  ;380A                DB 40h ; @             @                     
        FCB        $4E                  ;380B                DB 4Eh ; N             N                     
        FCB        $49                  ;380C 49             DB 49h ; I             I                     
        FCB        $43                  ;380D 43             DB 43h ; C             C                     
        FCB        $4B                  ;380E 4B             DB 4Bh ; K             K                     
        FCB        $4E                  ;380F 4E             DB 4Eh ; N             N                     
        FCB        $41                  ;3810 41             DB 41h ; A             A                     
        FCB        $4D                  ;3811 4D             DB 4Dh ; M             M                     
        FCB        $45                  ;3812 45             DB 45h ; E             E                     
        FCB        $2F                  ;3813 2F             DB 2Fh ; /             /                     
        FCB        $8F                  ;3814 8F             DB 8Fh ; Å            Å                     
        FCB        $2F                  ;3815 2F             DB 2Fh ; /             /                     
        FCB        $80                  ;3816 80             DB 80h ; Ç            Ç                     
        FCB        $65                  ;3817 65             DB 65h ; e             e                     
        FCB        $01                  ;3818 01 26 41       DB 1                  
        FCB        $26                  ;3819                DB 26h ; &             &                     
        FCB        $41                  ;381A                DB 41h ; A             A                     
        FCB        $4B                  ;381B 4B             DB 4Bh ; K             K                     
        FCB        $41                  ;381C 41             DB 41h ; A             A                     
        FCB        $42                  ;381D 42             DB 42h ; B             B                     
        FCB        $45                  ;381E 45             DB 45h ; E             E                     
        FCB        $49                  ;381F 49             DB 49h ; I             I                     
        FCB        $26                  ;3820 26 2F          DB 26h ; &             &                     
        FCB        $2F                  ;3821                DB 2Fh ; /             /                     
        FCB        $81                  ;3822 81             DB 81h ; ü            ü                     
        FCB        $2F                  ;3823 2F             DB 2Fh ; /             /                     
        FCB        $80                  ;3824 80             DB 80h ; Ç            Ç                     
        FCB        $45                  ;3825 45             DB 45h ; E             E                     
        FCB        $01                  ;3826 01 26 4D       DB 1                  
        FCB        $26                  ;3827                DB 26h ; &             &                     
        FCB        $4D                  ;3828                DB 4Dh ; M             M                     
        FCB        $41                  ;3829 41             DB 41h ; A             A                     
        FCB        $43                  ;382A 43             DB 43h ; C             C                     
        FCB        $4B                  ;382B 4B             DB 4Bh ; K             K                     
        FCB        $59                  ;382C 59             DB 59h ; Y             Y                     
        FCB        $26                  ;382D 26 2F          DB 26h ; &             &                     
        FCB        $2F                  ;382E                DB 2Fh ; /             /                     
        FCB        $81                  ;382F 81             DB 81h ; ü            ü                     
        FCB        $2F                  ;3830 2F             DB 2Fh ; /             /                     
        FCB        $80                  ;3831 80             DB 80h ; Ç            Ç                     
        FCB        $48                  ;3832 48             DB 48h ; H             H                     
        FCB        $01                  ;3833 01 26 50       DB 1                  
        FCB        $26                  ;3834                DB 26h ; &             &                     
        FCB        $50                  ;3835                DB 50h ; P             P                     
        FCB        $49                  ;3836 49             DB 49h ; I             I                     
        FCB        $4E                  ;3837 4E             DB 4Eh ; N             N                     
        FCB        $4B                  ;3838 4B             DB 4Bh ; K             K                     
        FCB        $59                  ;3839 59             DB 59h ; Y             Y                     
        FCB        $26                  ;383A 26 2F          DB 26h ; &             &                     
        FCB        $2F                  ;383B                DB 2Fh ; /             /                     
        FCB        $83                  ;383C 83             DB 83h ; â            â                     
        FCB        $2F                  ;383D 2F             DB 2Fh ; /             /                     
        FCB        $80                  ;383E 80             DB 80h ; Ç            Ç                     
        FCB        $48                  ;383F 48             DB 48h ; H             H                     
        FCB        $01                  ;3840 01 26 4D       DB 1                  
        FCB        $26                  ;3841                DB 26h ; &             &                     
        FCB        $4D                  ;3842                DB 4Dh ; M             M                     
        FCB        $49                  ;3843 49             DB 49h ; I             I                     
        FCB        $43                  ;3844 43             DB 43h ; C             C                     
        FCB        $4B                  ;3845 4B             DB 4Bh ; K             K                     
        FCB        $59                  ;3846 59             DB 59h ; Y             Y                     
        FCB        $26                  ;3847 26 2F          DB 26h ; &             &                     
        FCB        $2F                  ;3848                DB 2Fh ; /             /                     
        FCB        $83                  ;3849 83             DB 83h ; â            â                     
        FCB        $2F                  ;384A 2F             DB 2Fh ; /             /                     
        FCB        $80                  ;384B 80             DB 80h ; Ç            Ç                     
Message_17:
        FCB        $76                  ;384C 76             DB 76h ; v             v                     
        FCB        $02                  ;384D 02             DB 2                  
        FCB        $10                  ;384E 10 40          DB 10h                
        FCB        $40                  ;384F                DB 40h ; @             @                     
        FCB        $31                  ;3850 31 30 40       DB 31h ; 1             1                     
        FCB        $30                  ;3851                DB 30h ; 0             0                     
        FCB        $40                  ;3852                DB 40h ; @             @                     
        FCB        $5D                  ;3853 5D             DB 5Dh ; ]             ]                     
        FCB        $5E                  ;3854 5E             DB 5Eh ; ^             ^                     
        FCB        $5F                  ;3855 5F             DB 5Fh ; _             _                     
        FCB        $2F                  ;3856 2F             DB 2Fh ; /             /                     
        FCB        $9F                  ;3857 9F             DB 9Fh ; ƒ            ƒ                     
        FCB        $2F                  ;3858 2F             DB 2Fh ; /             /                     
        FCB        $80                  ;3859 80             DB 80h ; Ç            Ç                     
Message_18:
        FCB        $78                  ;385A 78             DB 78h ; x             x                     
        FCB        $02                  ;385B 02             DB 2                  
        FCB        $14                  ;385C 14             DB 14h                
        FCB        $40                  ;385D 40             DB 40h ; @             @                     
        FCB        $35                  ;385E 35             DB 35h ; 5             5                     
        FCB        $30                  ;385F 30 40          DB 30h ; 0             0                     
        FCB        $40                  ;3860                DB 40h ; @             @                     
        FCB        $5D                  ;3861 5D             DB 5Dh ; ]             ]                     
        FCB        $5E                  ;3862 5E             DB 5Eh ; ^             ^                     
        FCB        $5F                  ;3863 5F             DB 5Fh ; _             _                     
        FCB        $2F                  ;3864 2F             DB 2Fh ; /             /                     
        FCB        $9F                  ;3865 9F             DB 9Fh ; ƒ            ƒ                     
        FCB        $2F                  ;3866 2F             DB 2Fh ; /             /                     
        FCB        $80                  ;3867 80             DB 80h ; Ç            Ç                     
        FCB        $5D                  ;3868 5D             DB 5Dh ; ]             ]                     
        FCB        $02                  ;3869 02             DB 2                  
        FCB        $28                  ;386A 28 29          DB 28h ; (             (                     
        FCB        $29                  ;386B                DB 29h ; )             )                     
        FCB        $2A                  ;386C 2A 2B 2C       DB 2Ah ; *             *                     
        FCB        $2B                  ;386D                DB 2Bh ; +             +                     
        FCB        $2C                  ;386E                DB 2Ch ; ,             ,                     
        FCB        $2D                  ;386F 2D             DB 2Dh ; -             -                     
        FCB        $2E                  ;3870 2E 2F          DB 2Eh ; .             .                     
        FCB        $2F                  ;3871                DB 2Fh ; /             /                     
        FCB        $83                  ;3872 83             DB 83h ; â            â                     
        FCB        $2F                  ;3873 2F             DB 2Fh ; /             /                     
        FCB        $80                  ;3874 80             DB 80h ; Ç            Ç                     
        FCB        $C5                  ;3875 C5             DB 0C5h ; +            +                     
        FCB        $02                  ;3876 02             DB 2                  
        FCB        $40                  ;3877 40             DB 40h ; @             @                     
        FCB        $4F                  ;3878 4F             DB 4Fh ; O             O                     
        FCB        $49                  ;3879 49             DB 49h ; I             I                     
        FCB        $4B                  ;387A 4B             DB 4Bh ; K             K                     
        FCB        $41                  ;387B 41             DB 41h ; A             A                     
        FCB        $4B                  ;387C 4B             DB 4Bh ; K             K                     
        FCB        $45                  ;387D 45             DB 45h ; E             E                     
        FCB        $3B                  ;387E 3B             DB 3Bh ; ;                                 
        FCB        $3B                  ;387F 3B             DB 3Bh ; ;                                 
        FCB        $3B                  ;3880 3B             DB 3Bh ; ;                                 
        FCB        $3B                  ;3881 3B             DB 3Bh ; ;                                 
        FCB        $2F                  ;3882 2F             DB 2Fh ; /             /                     
        FCB        $81                  ;3883 81             DB 81h ; ü            ü                     
        FCB        $2F                  ;3884 2F             DB 2Fh ; /             /                     
        FCB        $80                  ;3885 80             DB 80h ; Ç            Ç                     
        FCB        $C5                  ;3886 C5             DB 0C5h ; +            +                     
        FCB        $02                  ;3887 02             DB 2                  
        FCB        $40                  ;3888 40             DB 40h ; @             @                     
        FCB        $55                  ;3889 55             DB 55h ; U             U                     
        FCB        $52                  ;388A 52             DB 52h ; R             R                     
        FCB        $43                  ;388B 43             DB 43h ; C             C                     
        FCB        $48                  ;388C 48             DB 48h ; H             H                     
        FCB        $49                  ;388D 49             DB 49h ; I             I                     
        FCB        $4E                  ;388E 4E             DB 4Eh ; N             N                     
        FCB        $3B                  ;388F 3B             DB 3Bh ; ;                                 
        FCB        $3B                  ;3890 3B             DB 3Bh ; ;                                 
        FCB        $3B                  ;3891 3B             DB 3Bh ; ;                                 
        FCB        $3B                  ;3892 3B             DB 3Bh ; ;                                 
        FCB        $3B                  ;3893 3B             DB 3Bh ; ;                                 
        FCB        $2F                  ;3894 2F             DB 2Fh ; /             /                     
        FCB        $81                  ;3895 81             DB 81h ; ü            ü                     
        FCB        $2F                  ;3896 2F             DB 2Fh ; /             /                     
        FCB        $80                  ;3897 80             DB 80h ; Ç            Ç                     
        FCB        $C8                  ;3898 C8             DB 0C8h ; +            +                     
        FCB        $02                  ;3899 02             DB 2                  
        FCB        $40                  ;389A 40             DB 40h ; @             @                     
        FCB        $4D                  ;389B 4D             DB 4Dh ; M             M                     
        FCB        $41                  ;389C 41             DB 41h ; A             A                     
        FCB        $43                  ;389D 43             DB 43h ; C             C                     
        FCB        $48                  ;389E 48             DB 48h ; H             H                     
        FCB        $49                  ;389F 49             DB 49h ; I             I                     
        FCB        $42                  ;38A0 42             DB 42h ; B             B                     
        FCB        $55                  ;38A1 55             DB 55h ; U             U                     
        FCB        $53                  ;38A2 53             DB 53h ; S             S                     
        FCB        $45                  ;38A3 45             DB 45h ; E             E                     
        FCB        $3B                  ;38A4 3B             DB 3Bh ; ;                                 
        FCB        $3B                  ;38A5 3B             DB 3Bh ; ;                                 
        FCB        $2F                  ;38A6 2F             DB 2Fh ; /             /                     
        FCB        $83                  ;38A7 83             DB 83h ; â            â                     
        FCB        $2F                  ;38A8 2F             DB 2Fh ; /             /                     
        FCB        $80                  ;38A9 80             DB 80h ; Ç            Ç                     
        FCB        $C8                  ;38AA C8             DB 0C8h ; +            +                     
        FCB        $02                  ;38AB 02             DB 2                  
        FCB        $40                  ;38AC 40             DB 40h ; @             @                     
        FCB        $52                  ;38AD 52             DB 52h ; R             R                     
        FCB        $4F                  ;38AE 4F             DB 4Fh ; O             O                     
        FCB        $4D                  ;38AF 4D             DB 4Dh ; M             M                     
        FCB        $50                  ;38B0 50             DB 50h ; P             P                     
        FCB        $3B                  ;38B1 3B             DB 3Bh ; ;                                 
        FCB        $3B                  ;38B2 3B             DB 3Bh ; ;                                 
        FCB        $3B                  ;38B3 3B             DB 3Bh ; ;                                 
        FCB        $3B                  ;38B4 3B             DB 3Bh ; ;                                 
        FCB        $3B                  ;38B5 3B             DB 3Bh ; ;                                 
        FCB        $3B                  ;38B6 3B             DB 3Bh ; ;                                 
        FCB        $3B                  ;38B7 3B             DB 3Bh ; ;                                 
        FCB        $2F                  ;38B8 2F             DB 2Fh ; /             /                     
        FCB        $83                  ;38B9 83             DB 83h ; â            â                     
        FCB        $2F                  ;38BA 2F             DB 2Fh ; /             /                     
        FCB        $80                  ;38BB 80             DB 80h ; Ç            Ç                     
Message_27:
        FCB        $12                  ;38BC 12             DB 12h                
        FCB        $02                  ;38BD 02             DB 2                  
        FCB        $81                  ;38BE 81             DB 81h ; ü            ü                     
        FCB        $85                  ;38BF 85             DB 85h ; à            à                     
        FCB        $2F                  ;38C0 2F             DB 2Fh ; /             /                     
        FCB        $83                  ;38C1 83             DB 83h ; â            â                     
        FCB        $2F                  ;38C2 2F             DB 2Fh ; /             /                     
        FCB        $90                  ;38C3 90             DB 90h ; É            É                     
Message_28:
        FCB        $32                  ;38C4 32 02          DB 32h ; 2             2                     
        FCB        $02                  ;38C5                DB 2                  
        FCB        $40                  ;38C6 40             DB 40h ; @             @                     
        FCB        $82                  ;38C7 82             DB 82h ; é            é                     
        FCB        $85                  ;38C8 85             DB 85h ; à            à                     
        FCB        $40                  ;38C9 40             DB 40h ; @             @                     
        FCB        $2F                  ;38CA 2F             DB 2Fh ; /             /                     
        FCB        $83                  ;38CB 83             DB 83h ; â            â                     
        FCB        $2F                  ;38CC 2F             DB 2Fh ; /             /                     
        FCB        $90                  ;38CD 90             DB 90h ; É            É                     
Message_29:
        FCB        $32                  ;38CE 32 02 		       DB 32h ; 2             2                     
        FCB        $02                  ;38CF                DB 2                  
        FCB        $40                  ;38D0 40             DB 40h ; @             @                     
        FCB        $83                  ;38D1 83             DB 83h ; â            â                     
        FCB        $85                  ;38D2 85             DB 85h ; à            à                     
        FCB        $40                  ;38D3 40             DB 40h ; @             @                     
        FCB        $2F                  ;38D4 2F             DB 2Fh ; /             /                     
        FCB        $83                  ;38D5 83             DB 83h ; â            â                     
        FCB        $2F                  ;38D6 2F             DB 2Fh ; /             /                     
        FCB        $90                  ;38D7 90             DB 90h ; É            É                     
Message_30:
        FCB        $32                  ;38D8 32 02 40       DB 32h ; 2             2                     
        FCB        $02                  ;38D9                DB 2                  
        FCB        $40                  ;38DA                DB 40h ; @             @                     
        FCB        $84                  ;38DB 84             DB 84h ; ä            ä                     
        FCB        $85                  ;38DC 85             DB 85h ; à            à                     
        FCB        $40                  ;38DD 40             DB 40h ; @             @                     
        FCB        $2F                  ;38DE 2F             DB 2Fh ; /             /                     
        FCB        $83                  ;38DF 83             DB 83h ; â            â                     
        FCB        $2F                  ;38E0 2F             DB 2Fh ; /             /                     
        FCB        $90                  ;38E1 90             DB 90h ; É            É                     
Message_31:
        FCB        $32                  ;38E2 32 02 40       DB 32h ; 2             2                     
        FCB        $02                  ;38E3                DB 2                  
        FCB        $40                  ;38E4                DB 40h ; @             @                     
        FCB        $86                  ;38E5 86             DB 86h ; å            å                     
        FCB        $8D                  ;38E6 8D             DB 8Dh ; ì            ì                     
        FCB        $8E                  ;38E7 8E             DB 8Eh ; Ä            Ä                     
        FCB        $2F                  ;38E8 2F             DB 2Fh ; /             /                     
        FCB        $83                  ;38E9 83             DB 83h ; â            â                     
        FCB        $2F                  ;38EA 2F             DB 2Fh ; /             /                     
        FCB        $90                  ;38EB 90             DB 90h ; É            É                     
Message_32:     
        FCB        $32                  ;38EC                DB 32h ; 2 2
        FCB        $02                  ;38ED                DB 2                  
        FCB        $87                  ;38EE                DB 87h ; ç            ç                     
        FCB        $88                  ;38EF 88             DB 88h ; ê            ê                     
        FCB        $8D                  ;38F0 8D             DB 8Dh ; ì            ì                     
        FCB        $8E                  ;38F1 8E             DB 8Eh ; Ä            Ä                     
        FCB        $2F                  ;38F2 2F             DB 2Fh ; /             /                     
        FCB        $83                  ;38F3 83             DB 83h ; â            â                     
        FCB        $2F                  ;38F4 2F             DB 2Fh ; /             /                     
        FCB        $90                  ;38F5 90             DB 90h ; É            É                     
Message_33:
        FCB        $32                  ;38F6 32 02 89       DB 32h ; 2             2                     
        FCB        $02                  ;38F7                DB 2                  
        FCB        $89                  ;38F8                DB 89h ; ë            ë                     
        FCB        $8A                  ;38F9 8A             DB 8Ah ; è            è                     
        FCB        $8D                  ;38FA 8D             DB 8Dh ; ì            ì                     
        FCB        $8E                  ;38FB 8E             DB 8Eh ; Ä            Ä                     
        FCB        $2F                  ;38FC 2F             DB 2Fh ; /             /                     
        FCB        $83                  ;38FD 83             DB 83h ; â            â                     
        FCB        $2F                  ;38FE 2F             DB 2Fh ; /             /                     
        FCB        $90                  ;38FF 90             DB 90h ; É            É                     
Message_34:
        FCB        $32                  ;3900 32 02 8B       DB 32h ; 2             2                     
        FCB        $02                  ;3901                DB 2                  
        FCB        $8B                  ;3902                DB 8Bh ; ï            ï                     
        FCB        $8C                  ;3903 8C             DB 8Ch ; î            î                     
        FCB        $8D                  ;3904 8D             DB 8Dh ; ì            ì                     
        FCB        $8E                  ;3905 8E             DB 8Eh ; Ä            Ä                     
        FCB        $2F                  ;3906 2F             DB 2Fh ; /             /                     
        FCB        $83                  ;3907 83             DB 83h ; â            â                     
        FCB        $2F                  ;3908 2F             DB 2Fh ; /             /                     
        FCB        $90                  ;3909 90             DB 90h ; É            É                     
Message_35:
        FCB        $04                  ;390A 04             DB 4                  
        FCB        $03                  ;390B 03             DB 3                  
        FCB        $4D                  ;390C 4D             DB 4Dh ; M             M                     
        FCB        $45                  ;390D 45             DB 45h ; E             E                     
        FCB        $4D                  ;390E 4D             DB 4Dh ; M             M                     
        FCB        $4F                  ;390F 4F             DB 4Fh ; O             O                     
        FCB        $52                  ;3910 52             DB 52h ; R             R                     
        FCB        $59                  ;3911 59             DB 59h ; Y             Y                     
        FCB        $40                  ;3912 40             DB 40h ; @             @                     
        FCB        $40                  ;3913 40             DB 40h ; @             @                     
        FCB        $4F                  ;3914 4F             DB 4Fh ; O             O                     
        FCB        $4B                  ;3915 4B             DB 4Bh ; K             K                     
        FCB        $2F                  ;3916 2F             DB 2Fh ; /             /                     
        FCB        $8F                  ;3917 8F             DB 8Fh ; Å            Å                     
        FCB        $2F                  ;3918 2F             DB 2Fh ; /             /                     
        FCB        $80                  ;3919 80             DB 80h ; Ç            Ç                     
Message_36:
        FCB        $04                  ;391A 04             DB 4                  
        FCB        $03                  ;391B 03             DB 3                  
        FCB        $42                  ;391C 42             DB 42h ; B             B                     
        FCB        $41                  ;391D 41             DB 41h ; A             A                     
        FCB        $44                  ;391E 44             DB 44h ; D             D                     
        FCB        $40                  ;391F 40             DB 40h ; @             @                     
        FCB        $40                  ;3920 40             DB 40h ; @             @                     
        FCB        $40                  ;3921 40             DB 40h ; @             @                     
        FCB        $40                  ;3922 40             DB 40h ; @             @                     
        FCB        $52                  ;3923 52             DB 52h ; R             R                     
        FCB        $40                  ;3924 40             DB 40h ; @             @                     
        FCB        $4D                  ;3925 4D             DB 4Dh ; M             M                     
        FCB        $2F                  ;3926 2F             DB 2Fh ; /             /                     
        FCB        $8F                  ;3927 8F             DB 8Fh ; Å            Å                     
        FCB        $2F                  ;3928 2F             DB 2Fh ; /             /                     
        FCB        $80                  ;3929 80             DB 80h ; Ç            Ç                     
Message_38:
        FCB        $08                  ;392A 08             DB 8                  
        FCB        $03                  ;392B 03             DB 3                  
        FCB        $31                  ;392C 31 40 43       DB 31h ; 1             1                     
        FCB        $40                  ;392D                DB 40h ; @             @                     
        FCB        $43                  ;392E                DB 43h ; C             C                     
        FCB        $4F                  ;392F 4F             DB 4Fh ; O             O                     
        FCB        $49                  ;3930 49             DB 49h ; I             I                     
        FCB        $4E                  ;3931 4E             DB 4Eh ; N             N                     
        FCB        $40                  ;3932 40             DB 40h ; @             @                     
        FCB        $40                  ;3933 40             DB 40h ; @             @                     
        FCB        $31                  ;3934 31 40 43       DB 31h ; 1             1                     
        FCB        $40                  ;3935                DB 40h ; @             @                     
        FCB        $43                  ;3936                DB 43h ; C             C                     
        FCB        $52                  ;3937 52             DB 52h ; R             R                     
        FCB        $45                  ;3938 45             DB 45h ; E             E                     
        FCB        $44                  ;3939 44             DB 44h ; D             D                     
        FCB        $49                  ;393A 49             DB 49h ; I             I                     
        FCB        $54                  ;393B 54             DB 54h ; T             T                     
        FCB        $40                  ;393C 40             DB 40h ; @             @                     
        FCB        $2F                  ;393D 2F             DB 2Fh ; /             /                     
        FCB        $8F                  ;393E 8F             DB 8Fh ; Å            Å                     
        FCB        $2F                  ;393F 2F             DB 2Fh ; /             /                     
        FCB        $80                  ;3940 80             DB 80h ; Ç            Ç                     
Message_40:
        FCB        $08                  ;3941 08             DB 8                  
        FCB        $03                  ;3942 03             DB 3                  
        FCB        $32                  ;3943 32 40 43       DB 32h ; 2             2                     
        FCB        $40                  ;3944                DB 40h ; @             @                     
        FCB        $43                  ;3945                DB 43h ; C             C                     
        FCB        $4F                  ;3946 4F             DB 4Fh ; O             O                     
        FCB        $49                  ;3947 49             DB 49h ; I             I                     
        FCB        $4E                  ;3948 4E             DB 4Eh ; N             N                     
        FCB        $53                  ;3949 53             DB 53h ; S             S                     
        FCB        $40                  ;394A 40             DB 40h ; @             @                     
        FCB        $31                  ;394B 31 40 43       DB 31h ; 1             1                     
        FCB        $40                  ;394C                DB 40h ; @             @                     
        FCB        $43                  ;394D                DB 43h ; C             C                     
        FCB        $52                  ;394E 52             DB 52h ; R             R                     
        FCB        $45                  ;394F 45             DB 45h ; E             E                     
        FCB        $44                  ;3950 44             DB 44h ; D             D                     
        FCB        $49                  ;3951 49             DB 49h ; I             I                     
        FCB        $54                  ;3952 54             DB 54h ; T             T                     
        FCB        $40                  ;3953 40             DB 40h ; @             @                     
        FCB        $2F                  ;3954 2F             DB 2Fh ; /             /                     
        FCB        $8F                  ;3955 8F             DB 8Fh ; Å            Å                     
        FCB        $2F                  ;3956 2F             DB 2Fh ; /             /                     
        FCB        $80                  ;3957 80             DB 80h ; Ç            Ç                     
Message_39:
        FCB        $08                  ;3958 08             DB 8                  
        FCB        $03                  ;3959 03             DB 3                  
        FCB        $31                  ;395A 31 40 43       DB 31h ; 1             1                     
        FCB        $40                  ;395B                DB 40h ; @             @                     
        FCB        $43                  ;395C                DB 43h ; C             C                     
        FCB        $4F                  ;395D 4F             DB 4Fh ; O             O                     
        FCB        $49                  ;395E 49             DB 49h ; I             I                     
        FCB        $4E                  ;395F 4E             DB 4Eh ; N             N                     
        FCB        $40                  ;3960 40             DB 40h ; @             @                     
        FCB        $40                  ;3961 40             DB 40h ; @             @                     
        FCB        $32                  ;3962 32 40 43       DB 32h ; 2             2                     
        FCB        $40                  ;3963                DB 40h ; @             @                     
        FCB        $43                  ;3964                DB 43h ; C             C                     
        FCB        $52                  ;3965 52             DB 52h ; R             R                     
        FCB        $45                  ;3966 45             DB 45h ; E             E                     
        FCB        $44                  ;3967 44             DB 44h ; D             D                     
        FCB        $49                  ;3968 49             DB 49h ; I             I                     
        FCB        $54                  ;3969 54             DB 54h ; T             T                     
        FCB        $53                  ;396A 53             DB 53h ; S             S                     
        FCB        $2F                  ;396B 2F             DB 2Fh ; /             /                     
        FCB        $8F                  ;396C 8F             DB 8Fh ; Å            Å                     
        FCB        $2F                  ;396D 2F             DB 2Fh ; /             /                     
        FCB        $80                  ;396E 80             DB 80h ; Ç            Ç                     
Message_37:
        FCB        $08                  ;396F 08             DB 8                  
        FCB        $03                  ;3970 03             DB 3                  
        FCB        $46                  ;3971 46             DB 46h ; F             F                     
        FCB        $52                  ;3972 52             DB 52h ; R             R                     
        FCB        $45                  ;3973 45             DB 45h ; E             E                     
        FCB        $45                  ;3974 45             DB 45h ; E             E                     
        FCB        $40                  ;3975 40             DB 40h ; @             @                     
        FCB        $40                  ;3976 40             DB 40h ; @             @                     
        FCB        $50                  ;3977 50             DB 50h ; P             P                     
        FCB        $4C                  ;3978 4C             DB 4Ch ; L             L                     
        FCB        $41                  ;3979 41             DB 41h ; A             A                     
        FCB        $59                  ;397A 59             DB 59h ; Y             Y                     
        FCB        $40                  ;397B 40             DB 40h ; @             @                     
        FCB        $40                  ;397C 40             DB 40h ; @             @                     
        FCB        $40                  ;397D 40             DB 40h ; @             @                     
        FCB        $40                  ;397E 40             DB 40h ; @             @                     
        FCB        $40                  ;397F 40             DB 40h ; @             @                     
        FCB        $40                  ;3980 40             DB 40h ; @             @                     
        FCB        $40                  ;3981 40             DB 40h ; @             @                     
        FCB        $2F                  ;3982 2F             DB 2Fh ; /             /                     
        FCB        $8F                  ;3983 8F             DB 8Fh ; Å            Å                     
        FCB        $2F                  ;3984 2F             DB 2Fh ; /             /                     
        FCB        $80                  ;3985 80             DB 80h ; Ç            Ç                     
Message_42:
        FCB        $0A                  ;3986 0A             DB 0Ah                
        FCB        $03                  ;3987 03             DB 3                  
        FCB        $42                  ;3988 42             DB 42h ; B             B                     
        FCB        $4F                  ;3989 4F             DB 4Fh ; O             O                     
        FCB        $4E                  ;398A 4E             DB 4Eh ; N             N                     
        FCB        $55                  ;398B 55             DB 55h ; U             U                     
        FCB        $53                  ;398C 53             DB 53h ; S             S                     
        FCB        $40                  ;398D 40             DB 40h ; @             @                     
        FCB        $40                  ;398E 40             DB 40h ; @             @                     
        FCB        $4E                  ;398F 4E             DB 4Eh ; N             N                     
        FCB        $4F                  ;3990 4F             DB 4Fh ; O             O                     
        FCB        $4E                  ;3991 4E             DB 4Eh ; N             N                     
        FCB        $45                  ;3992 45             DB 45h ; E             E                     
        FCB        $2F                  ;3993 2F             DB 2Fh ; /             /                     
        FCB        $8F                  ;3994 8F             DB 8Fh ; Å            Å                     
        FCB        $2F                  ;3995 2F             DB 2Fh ; /             /                     
        FCB        $80                  ;3996 80             DB 80h ; Ç            Ç                     
Message_43:
        FCB        $0A                  ;3997 0A             DB 0Ah                
        FCB        $03                  ;3998 03             DB 3                  
        FCB        $42                  ;3999 42             DB 42h ; B             B                     
        FCB        $4F                  ;399A 4F             DB 4Fh ; O             O                     
        FCB        $4E                  ;399B 4E             DB 4Eh ; N             N                     
        FCB        $55                  ;399C 55             DB 55h ; U             U                     
        FCB        $53                  ;399D 53             DB 53h ; S             S                     
        FCB        $40                  ;399E 40             DB 40h ; @             @                     
        FCB        $2F                  ;399F 2F             DB 2Fh ; /             /                     
        FCB        $8F                  ;39A0 8F             DB 8Fh ; Å            Å                     
        FCB        $2F                  ;39A1 2F             DB 2Fh ; /             /                     
        FCB        $80                  ;39A2 80             DB 80h ; Ç            Ç                     
        FCB        $0C                  ;39A3 0C             DB 0Ch                
        FCB        $03                  ;39A4 03             DB 3                  
        FCB        $50                  ;39A5 50             DB 50h ; P             P                     
        FCB        $55                  ;39A6 55             DB 55h ; U             U                     
        FCB        $43                  ;39A7 43             DB 43h ; C             C                     
        FCB        $4B                  ;39A8 4B             DB 4Bh ; K             K                     
        FCB        $4D                  ;39A9 4D             DB 4Dh ; M             M                     
        FCB        $41                  ;39AA 41             DB 41h ; A             A                     
        FCB        $4E                  ;39AB 4E             DB 4Eh ; N             N                     
        FCB        $2F                  ;39AC 2F             DB 2Fh ; /             /                     
        FCB        $8F                  ;39AD 8F             DB 8Fh ; Å            Å                     
        FCB        $2F                  ;39AE 2F             DB 2Fh ; /             /                     
        FCB        $80                  ;39AF 80             DB 80h ; Ç            Ç                     
Message_44:
        FCB        $0E                  ;39B0 0E 03          DB 0Eh                
        FCB        $03                  ;39B1                DB 3                  
        FCB        $54                  ;39B2 54             DB 54h ; T             T                     
        FCB        $41                  ;39B3 41             DB 41h ; A             A                     
        FCB        $42                  ;39B4 42             DB 42h ; B             B                     
        FCB        $4C                  ;39B5 4C             DB 4Ch ; L             L                     
        FCB        $45                  ;39B6 45             DB 45h ; E             E                     
        FCB        $40                  ;39B7 40             DB 40h ; @             @                     
        FCB        $40                  ;39B8 40             DB 40h ; @             @                     
        FCB        $2F                  ;39B9 2F             DB 2Fh ; /             /                     
        FCB        $8F                  ;39BA 8F             DB 8Fh ; Å            Å                     
        FCB        $2F                  ;39BB 2F             DB 2Fh ; /             /                     
        FCB        $80                  ;39BC 80             DB 80h ; Ç            Ç                     
Message_45:
        FCB        $0E                  ;39BD 0E 03          DB 0Eh                
        FCB        $03                  ;39BE                DB 3                  
        FCB        $55                  ;39BF 55             DB 55h ; U             U                     
        FCB        $50                  ;39C0 50             DB 50h ; P             P                     
        FCB        $52                  ;39C1 52             DB 52h ; R             R                     
        FCB        $49                  ;39C2 49             DB 49h ; I             I                     
        FCB        $47                  ;39C3 47             DB 47h ; G             G                     
        FCB        $48                  ;39C4 48             DB 48h ; H             H                     
        FCB        $54                  ;39C5 54             DB 54h ; T             T                     
        FCB        $2F                  ;39C6 2F             DB 2Fh ; /             /                     
        FCB        $8F                  ;39C7 8F             DB 8Fh ; Å            Å                     
        FCB        $2F                  ;39C8 2F             DB 2Fh ; /             /                     
        FCB        $80                  ;39C9 80             DB 80h ; Ç            Ç                     
Message_46:
        FCB        $0A                  ;39CA 0A             DB 0Ah                
        FCB        $02                  ;39CB 02             DB 2                  
        FCB        $30                  ;39CC 30 30          DB 30h ; 0             0                     
        FCB        $30                  ;39CD                DB 30h ; 0             0                     
        FCB        $30                  ;39CE 30 2F          DB 30h ; 0             0                     
        FCB        $2F                  ;39CF                DB 2Fh ; /             /                     
        FCB        $8F                  ;39D0 8F             DB 8Fh ; Å            Å                     
        FCB        $2F                  ;39D1 2F             DB 2Fh ; /             /                     
        FCB        $80                  ;39D2 80             DB 80h ; Ç            Ç                     
        FCB        $6B                  ;39D3 6B             DB 6Bh ; k             k                     
        FCB        $01                  ;39D4 01 26 41       DB 1                  
        FCB        $26                  ;39D5                DB 26h ; &             &                     
        FCB        $41                  ;39D6                DB 41h ; A             A                     
        FCB        $4F                  ;39D7 4F             DB 4Fh ; O             O                     
        FCB        $53                  ;39D8 53             DB 53h ; S             S                     
        FCB        $55                  ;39D9 55             DB 55h ; U             U                     
        FCB        $4B                  ;39DA 4B             DB 4Bh ; K             K                     
        FCB        $45                  ;39DB 45             DB 45h ; E             E                     
        FCB        $26                  ;39DC 26 2F          DB 26h ; &             &                     
        FCB        $2F                  ;39DD                DB 2Fh ; /             /                     
        FCB        $85                  ;39DE 85             DB 85h ; à            à                     
        FCB        $2F                  ;39DF 2F             DB 2Fh ; /             /                     
        FCB        $80                  ;39E0 80             DB 80h ; Ç            Ç                     
        FCB        $4B                  ;39E1 4B             DB 4Bh ; K             K                     
        FCB        $01                  ;39E2 01 26 4D       DB 1                  
        FCB        $26                  ;39E3                DB 26h ; &             &                     
        FCB        $4D                  ;39E4                DB 4Dh ; M             M                     
        FCB        $55                  ;39E5 55             DB 55h ; U             U                     
        FCB        $43                  ;39E6 43             DB 43h ; C             C                     
        FCB        $4B                  ;39E7 4B             DB 4Bh ; K             K                     
        FCB        $59                  ;39E8 59             DB 59h ; Y             Y                     
        FCB        $26                  ;39E9 26 2F          DB 26h ; &             &                     
        FCB        $2F                  ;39EA                DB 2Fh ; /             /                     
        FCB        $85                  ;39EB 85             DB 85h ; à            à                     
        FCB        $2F                  ;39EC 2F             DB 2Fh ; /             /                     
        FCB        $80                  ;39ED 80             DB 80h ; Ç            Ç                     
        FCB        $6E                  ;39EE 6E             DB 6Eh ; n             n                     
        FCB        $01                  ;39EF 01 26 47       DB 1                  
        FCB        $26                  ;39F0                DB 26h ; &             &                     
        FCB        $47                  ;39F1                DB 47h ; G             G                     
        FCB        $55                  ;39F2 55             DB 55h ; U             U                     
        FCB        $5A                  ;39F3 5A             DB 5Ah ; Z             Z                     
        FCB        $55                  ;39F4 55             DB 55h ; U             U                     
        FCB        $54                  ;39F5 54             DB 54h ; T             T                     
        FCB        $41                  ;39F6 41             DB 41h ; A             A                     
        FCB        $26                  ;39F7 26 2F          DB 26h ; &             &                     
        FCB        $2F                  ;39F8                DB 2Fh ; /             /                     
        FCB        $87                  ;39F9 87             DB 87h ; ç            ç                     
        FCB        $2F                  ;39FA 2F             DB 2Fh ; /             /                     
        FCB        $80                  ;39FB 80             DB 80h ; Ç            Ç                     
        FCB        $4E                  ;39FC 4E             DB 4Eh ; N             N                     
        FCB        $01                  ;39FD 01 26 4D       DB 1                  
        FCB        $26                  ;39FE                DB 26h ; &             &                     
        FCB        $4D                  ;39FF                DB 4Dh ; M             M                     
        FCB        $4F                  ;3A00 4F             DB 4Fh ; O             O                     
        FCB        $43                  ;3A01 43             DB 43h ; C             C                     
        FCB        $4B                  ;3A02 4B             DB 4Bh ; K             K                     
        FCB        $59                  ;3A03 59             DB 59h ; Y             Y                     
        FCB        $26                  ;3A04 26 2F          DB 26h ; &             &                     
        FCB        $2F                  ;3A05                DB 2Fh ; /             /                     
        FCB        $87                  ;3A06 87             DB 87h ; ç            ç                     
        FCB        $2F                  ;3A07 2F             DB 2Fh ; /             /                     
        FCB        $80                  ;3A08 80             DB 80h ; Ç            Ç                     
        FCB        $CB                  ;3A09 CB 02          DB 0CBh ; -            -                     
        FCB        $02                  ;3A0A                DB 2                  
        FCB        $40                  ;3A0B 40             DB 40h ; @             @                     
        FCB        $4B                  ;3A0C 4B             DB 4Bh ; K             K                     
        FCB        $49                  ;3A0D 49             DB 49h ; I             I                     
        FCB        $4D                  ;3A0E 4D             DB 4Dh ; M             M                     
        FCB        $41                  ;3A0F 41             DB 41h ; A             A                     
        FCB        $47                  ;3A10 47             DB 47h ; G             G                     
        FCB        $55                  ;3A11 55             DB 55h ; U             U                     
        FCB        $52                  ;3A12 52             DB 52h ; R             R                     
        FCB        $45                  ;3A13 45             DB 45h ; E             E                     
        FCB        $3B                  ;3A14 3B             DB 3Bh ; ;                                 
        FCB        $3B                  ;3A15 3B             DB 3Bh ; ;                                 
        FCB        $2F                  ;3A16 2F             DB 2Fh ; /             /                     
        FCB        $85                  ;3A17 85             DB 85h ; à            à                     
        FCB        $2F                  ;3A18 2F             DB 2Fh ; /             /                     
        FCB        $80                  ;3A19 80             DB 80h ; Ç            Ç                     
        FCB        $CB                  ;3A1A CB 02          DB 0CBh ; -            -                     
        FCB        $02                  ;3A1B                DB 2                  
        FCB        $40                  ;3A1C 40             DB 40h ; @             @                     
        FCB        $53                  ;3A1D 53             DB 53h ; S             S                     
        FCB        $54                  ;3A1E 54             DB 54h ; T             T                     
        FCB        $59                  ;3A1F 59             DB 59h ; Y             Y                     
        FCB        $4C                  ;3A20 4C             DB 4Ch ; L             L                     
        FCB        $49                  ;3A21 49             DB 49h ; I             I                     
        FCB        $53                  ;3A22 53             DB 53h ; S             S                     
        FCB        $54                  ;3A23 54             DB 54h ; T             T                     
        FCB        $3B                  ;3A24 3B             DB 3Bh ; ;                                 
        FCB        $3B                  ;3A25 3B             DB 3Bh ; ;                                 
        FCB        $3B                  ;3A26 3B             DB 3Bh ; ;                                 
        FCB        $3B                  ;3A27 3B             DB 3Bh ; ;                                 
        FCB        $2F                  ;3A28 2F             DB 2Fh ; /             /                     
        FCB        $85                  ;3A29 85             DB 85h ; à            à                     
        FCB        $2F                  ;3A2A 2F             DB 2Fh ; /             /                     
        FCB        $80                  ;3A2B 80             DB 80h ; Ç            Ç                     
        FCB        $CE                  ;3A2C CE 02          DB 0CEh ; +            +                     
        FCB        $02                  ;3A2D                DB 2                  
        FCB        $40                  ;3A2E 40             DB 40h ; @             @                     
        FCB        $4F                  ;3A2F 4F             DB 4Fh ; O             O                     
        FCB        $54                  ;3A30 54             DB 54h ; T             T                     
        FCB        $4F                  ;3A31 4F             DB 4Fh ; O             O                     
        FCB        $42                  ;3A32 42             DB 42h ; B             B                     
        FCB        $4F                  ;3A33 4F             DB 4Fh ; O             O                     
        FCB        $4B                  ;3A34 4B             DB 4Bh ; K             K                     
        FCB        $45                  ;3A35 45             DB 45h ; E             E                     
        FCB        $3B                  ;3A36 3B             DB 3Bh ; ;                                 
        FCB        $3B                  ;3A37 3B             DB 3Bh ; ;                                 
        FCB        $3B                  ;3A38 3B             DB 3Bh ; ;                                 
        FCB        $2F                  ;3A39 2F             DB 2Fh ; /             /                     
        FCB        $87                  ;3A3A 87             DB 87h ; ç            ç                     
        FCB        $2F                  ;3A3B 2F             DB 2Fh ; /             /                     
        FCB        $80                  ;3A3C 80             DB 80h ; Ç            Ç                     
        FCB        $CE                  ;3A3D CE 02          DB 0CEh ; +            +                     
        FCB        $02                  ;3A3E                DB 2                  
        FCB        $40                  ;3A3F 40             DB 40h ; @             @                     
        FCB        $43                  ;3A40 43             DB 43h ; C             C                     
        FCB        $52                  ;3A41 52             DB 52h ; R             R                     
        FCB        $59                  ;3A42 59             DB 59h ; Y             Y                     
        FCB        $42                  ;3A43 42             DB 42h ; B             B                     
        FCB        $41                  ;3A44 41             DB 41h ; A             A                     
        FCB        $42                  ;3A45 42             DB 42h ; B             B                     
        FCB        $59                  ;3A46 59             DB 59h ; Y             Y                     
        FCB        $B                  	;3A47 3B             DB 3Bh ; ;                                 
        FCB        $B                  	;3A48 3B             DB 3Bh ; ;                                 
        FCB        $B                  	;3A49 3B             DB 3Bh ; ;                                 
        FCB        $B                  	;3A4A 3B             DB 3Bh ; ;                                 
        FCB        $2F                  ;3A4B 2F             DB 2Fh ; /             /                     
        FCB        $87                  ;3A4C 87             DB 87h ; ç            ç                     
        FCB        $2F							  	;3A4D 2F             DB 2Fh ; /             /                     
        FCB        $80                            	;3A4E 80             DB 80h ; Ç            Ç  
; "Made By Namco" easter egg text
; This is stored the same way as the pellet information.
;  #3af4 routine:
;  1  retrieve the value
;  2  if (value == 0),Done.
;  3  draw a pellet (#14)
;  4  increment the position by the value retrieved
;  5  repeat at 1 above
;through 3AE1
NAMCOEgg:     
        FCB        $01,$01,$03,$01
        FCB        $01,$01,$03,$02
        FCB        $02,$02,$01,$01
        FCB        $01,$01,$02,$04
        FCB        $04,$04,$06,$02
        FCB        $02                  ;3A4F                DB 1,1,3,1,1,1,3,2,2,2
        FCB        $02,$02,$04,$02
        FCB        $04,$04,$04,$06
        FCB        $02,$02,$02,$02
        FCB        $01,$01,$01,$01
        FCB        $02,$04,$04,$04
        FCB        $06                  ;3A4F 01 01 03       DB 2,2,4,2,4,4,4,6,2,2
        FCB        $02,$02,$02,$02
        FCB        $06,$04,$05,$01
        FCB        $01,$03,$01,$01
        FCB        $01,$04,$01,$01
        FCB        $01,$03,$01,$01
        FCB        $04                  ;3A4F 01 01 03       DB 2,2,2,2,6,4,5,1,1,3
        FCB        $01,$01,$01,$6C
        FCB        $05,$01,$01,$01
        FCB        $18,$04,$04,$18
        FCB        $05,$01,$01,$01
        FCB        $17,$02         		;3A4F 01 01 03       DB 1,1,1,6Ch,5,1,1,1,1
        FCB        $03,$04,$16,$04
        FCB        $03,$01,$01,$01
        FCB        $76,$01,$01,$01
        FCB        $01,$03,$01,$01
        FCB        $01,$02,$04     		;3A4F 01 01 03       DB 3,4,16h,4,3,1,1,1,7
        FCB        $02,$04,$0E,$02
        FCB        $04,$02,$04,$02
        FCB        $04,$0B,$01,$01
        FCB        $01,$02,$04,$02
        FCB        $01,$01,$01      	;3A4F 01 01 03       DB 2,4,0Eh,2,4,2,4,2,4
        FCB        $01,$02,$02,$02
        FCB        $0E,$02,$04,$02
        FCB        $04,$02,$01,$02
        FCB        $01,$0A,$01,$01
        FCB        $01,$01,$03      	;3A4F 01 01 03       DB 1,2,2,2,0Eh,2,4,2,4
        FCB        $01,$01,$01,$03
        FCB        $01,$01,$03,$04
        FCB        $00                  ;3A4F 01 01 03       DB 1,1,1,3,1,1,3,4,0  
GridData:
        FDB        $4002,$3E01,$103D	;3AE2                DW 4002h,3E01h,103Dh   for grid self test
        FDB        $4040,$3D0E,$103E	;3AE2 02             DW 4040h,3D0Eh,103Eh  
        FDB        $43C2,$3E01,$103D	;3AE2 02             DW 43C2h,3E01h,103Dh
		; ---------------------------------------------------------------------------
;fruit code,then fruit color,repeat
FruitTable:     
        FCB        $90,$14                  ;3B08                DB 90h,14h             cherry
        FCB        $94,$0F                  ;3B08 90             DB 94h,0Fh             strawberry
        FCB        $98,$15                  ;3B08 90             DB 98h,15h             1st orange
        FCB        $98,$15                  ;3B08 90             DB 98h,15h             2nd orange
        FCB        $A0,$14                  ;3B08 90             DB 0A0h,14h            1st apple
        FCB        $A0,$14                  ;3B08 90             DB 0A0h,14h            2nd apple
        FCB        $A4,$17                  ;3B08 90             DB 0A4h,17h            1st pineapple
        FCB        $A4,$17                  ;3B08 90             DB 0A4h,17h            2nd pineapple
        FCB        $A8,$09                  ;3B08 90             DB 0A8h,9              1st galaxian
        FCB        $A8,$09                  ;3B08 90             DB 0A8h,9              2nd galaxian
        FCB        $9C,$16                  ;3B08 90             DB 9Ch,16h             1st bell
        FCB        $9C,$16                  ;3B08 90             DB 9Ch,16h             2nd bell
        FCB        $AC,$16                  ;3B08 90             DB 0ACh,16h            1st key
        FCB        $AC,$16                  ;3B08 90             DB 0ACh,16h            2nd key
        FCB        $AC,$16                  ;3B08 90             DB 0ACh,16h            3rd key
        FCB        $AC,$16                  ;3B08 90             DB 0ACh,16h            4th key
        FCB        $AC,$16                  ;3B08 90             DB 0ACh,16h            5th key
        FCB        $AC,$16                  ;3B08 90             DB 0ACh,16h            6th key
        FCB        $AC,$16                  ;3B08 90             DB 0ACh,16h            7th key
        FCB        $AC,$16                  ;3B08 90             DB 0ACh,16h            8th key
;channel 1 effects
;     Sound Tables
Channel1Effects:     
        FCB        $73,$20,$00,$0C
        FCB        $00,$0A,$1F,$00
        FCB        $72,$20,$FB,$87
        FCB        $00,$02       		;3B30                DB 73h,20h,0,0Ch,0,0Ah
        FCB        $0F,$00      		;3B30                DB 0Fh,0              
Channel2Effects:     
        FCB        $36,$20,$04,$8C
        FCB        $00,$00,$06,$00
        FCB        $36,$28,$05,$8B
        FCB        $00,$00,$06,$00
        FCB        $36                  ;3B40                DB 36h,20h,4,8Ch,0,0,6
        FCB        $30,$06,$8A,$00
        FCB        $00,$06,$00,$36
        FCB        $3C,$07,$89,$00
        FCB        $00,$06,$00,$36
        FCB        $48                  ;3B40 36 20          DB 30h,6,8Ah,0,0,6,0,3
        FCB        $08,$88,$00,$00
        FCB        $06,$00,$24,$00
        FCB        $06,$08,$00,$00
        FCB        $0A,$00,$40,$70
        FCB        $FA                  ;3B40 36 20          DB 8,88h,0,0,6,0,24h,0
        FCB        $10,$00,$00,$0A
        FCB        $00,$70,$04,$00
        FCB        $00,$00,$00,$08
        FCB        $00                  ;3B40 36 20          DB 10h,0,0,0Ah,0,70h,4
Channel3Effects:     
        FCB        $42,$18,$FD,$06
        FCB        $00,$01,$0C,$00
        FCB        $42,$04,$03,$06
        FCB        $00,$01,$0C,$00 		;3B80                DB 42h,18h,0FDh,6,0,1,
        FCB        $56,$0C,$FF,$8C
        FCB        $00,$02,$0F,$00
        FCB        $05,$00,$02,$20
        FCB        $00,$01,$0C,$00  	;3B80 42             DB 56h,0Ch,0FFh,8Ch,0,
        FCB        $41,$20,$FF,$86
        FCB        $FE,$1C,$0F,$FF
        FCB        $70,$00,$01,$0C
        FCB        $00                  ;3B80 42             DB 41h,20h,0FFh,86h,0F
        FCB        $01,$08,$00  		;3B80 42             DB 1,8,0              
; sound lookup tables
LookupTables:     
        FCB        $01                  ;3BB0                DB 1
        FCB        $02                  ;3BB1                DB 2                  
        FCB        $04                  ;3BB2                DB 4                  
        FCB        $08                  ;3BB3 08             DB 8                  
        FCB        $10                  ;3BB4 10 20          DB 10h                
        FCB        $20                  ;3BB5                DB 20h                
        FCB        $40                  ;3BB6 40             DB 40h ; @             @                     
        FCB        $80                  ;3BB7 80             DB 80h ; Ç            Ç                     
        FCB        $00                  ;3BB8 00             DB 0                  
        FCB        $57                  ;3BB9 57             DB 57h ; W             W                     
        FCB        $5C                  ;3BBA 5C             DB 5Ch ; \             \                     
        FCB        $61                  ;3BBB 61             DB 61h ; a             a                     
        FCB        $67                  ;3BBC 67             DB 67h ; g             g                     
        FCB        $6D                  ;3BBD 6D             DB 6Dh ; m             m                     
        FCB        $74                  ;3BBE 74             DB 74h ; t             t                     
        FCB        $7B                  ;3BBF 7B             DB 7Bh ; {             {                     
        FCB        $82                  ;3BC0 82             DB 82h ; é            é                     
        FCB        $8A                  ;3BC1 8A             DB 8Ah ; è            è                     
        FCB        $92                  ;3BC2 92             DB 92h ; Æ            Æ                     
        FCB        $9A                  ;3BC3 9A             DB 9Ah ; Ü            Ü                     
        FCB        $A3                  ;3BC4 A3             DB 0A3h ; ú           ú                     
        FCB        $AD                  ;3BC5 AD             DB 0ADh ; ¡           ¡                     
        FCB        $B8                  ;3BC6 B8             DB 0B8h ; +            +                     
        FCB        $C3                  ;3BC7 C3 D4 3B       DB 0C3h ; +            +                     
;channel 1 jump to song table
        FCB        $D4                  ;3BC8                DB 0D4h ; +            +                     
        FCB        $3B                  ;3BC9                DB 3Bh ; ;                                 
        FCB        $F3                  ;3BCA F3             DB 0F3h ; =            =                     
        FCB        $3B                  ;3BCB 3B             DB 3Bh ; ;                                 
;channel 2 jump to song table
        FCB        $58                  ;3BCC 58             DB 58h ; X             X                     
        FCB        $3C                  ;3BCD 3C             DB 3Ch ; <             <                     
        FCB        $95                  ;3BCE 95             DB 95h ; ò            ò                     
        FCB        $3C                  ;3BCF 3C             DB 3Ch ; <             <                     
;channel 3 jump to song table
        FCB        $DE                  ;3BD0 DE 3C          DB 0DEh ; ¦           ¦                     
        FCB        $3C                  ;3BD1                DB 3Ch ; <             <                     
        FCB        $DF                  ;3BD2 DF             DB 0DFh ; ¯           ¯                     
        FCB        $3C                  ;3BD3 3C             DB 3Ch ; <             <                     
SongData:     
        FCB        $F1,$02,$F2,$03
        FCB        $F3,$0F,$F4,$01
        FCB        $82,$70,$69,$82
        FCB        $70                  ;3BD4                DB 0F1h,2,0F2h,3,0F3h,
        FCB        $69,$83,$70,$6A
        FCB        $83,$70,$6A,$82
        FCB        $70,$69,$82,$70
        FCB        $69                  ;3BD4 F1             DB 69h,83h,70h,6Ah,83h
        FCB        $89,$8B,$8D,$8E
        FCB        $FF,$F1,$02,$F2
        FCB        $03,$F3,$0F,$F4		;3BD4 F1             DB 89h,8Bh,8Dh,8Eh,0FF
        FCB        $01,$67,$50,$30
        FCB        $47,$30,$67,$50
        FCB        $30,$47,$30,$67
        FCB        $50                  ;3BD4 F1             DB 1,67h,50h,30h,47h,3
        FCB        $30,$47,$30,$4B
        FCB        $10,$4C,$10,$4D
        FCB        $10,$4E,$10,$67
        FCB        $50                  ;3BD4 F1             DB 30h,47h,30h,4Bh,10h
        FCB        $30,$47,$30,$67
        FCB        $50,$30,$47,$30
        FCB        $67,$50,$30,$47
        FCB        $30                  ;3BD4 F1             DB 30h,47h,30h,67h,50h
        FCB        $4B,$10,$4C,$10
        FCB        $4D,$10,$4E,$10
        FCB        $67,$50,$30,$47
        FCB        $30                  ;3BD4 F1             DB 4Bh,10h,4Ch,10h,4Dh
        FCB        $67,$50,$30,$47
        FCB        $30,$67,$50,$30
        FCB        $47,$30,$4B,$10
        FCB        $4C                  ;3BD4 F1             DB 67h,50h,30h,47h,30h
        FCB        $10,$4D,$10,$4E
        FCB        $10,$77,$20,$4E
        FCB        $10,$4D,$10,$4C
        FCB        $10                  ;3BD4 F1             DB 10h,4Dh,10h,4Eh,10h
        FCB        $4A,$10,$47,$10
        FCB        $46,$10,$65,$30
        FCB        $66,$30,$67,$40
        FCB        $70                  ;3BD4 F1             DB 4Ah,10h,47h,10h,46h
        FCB        $F0,$FB,$3B,$F1
        FCB        $00,$F2,$02,$F3
        FCB        $0F,$F4,$00,$42
        FCB        $50                  ;3BD4 F1             DB 0F0h,0FBh,3Bh,0F1h,
        FCB        $4E,$50,$49,$50
        FCB        $46,$50,$4E,$49
        FCB        $70,$66,$70,$43
        FCB        $50                  ;3BD4 F1             DB 4Eh,50h,49h,50h,46h
        FCB        $4F,$50,$4A,$50
        FCB        $47,$50,$4F,$4A
        FCB        $70,$67,$70,$42
        FCB        $50                  ;3BD4 F1             DB 4Fh,50h,4Ah,50h,47h
        FCB        $4E,$50,$49,$50
        FCB        $46,$50,$4E,$49
        FCB        $70,$66,$70,$45
        FCB        $46                  ;3BD4 F1             DB 4Eh,50h,49h,50h,46h
        FCB        $47,$50,$47,$48
        FCB        $49,$50,$49,$4A
        FCB        $4B,$50,$6E,$FF		;3BD4 F1             DB 47h,50h,47h,48h,49h
        FCB        $F1,$01,$F2,$01
        FCB        $F3,$0F,$F4,$00
        FCB        $26,$67,$26,$67
        FCB        $26                  ;3BD4 F1             DB 0F1h,1,0F2h,1,0F3h,
        FCB        $67,$23,$44,$42
        FCB        $47,$30,$67,$2A
        FCB        $8B,$70,$26,$67
        FCB        $26                  ;3BD4 F1             DB 67h,23h,44h,42h,47h
        FCB        $67,$26,$67,$23
        FCB        $44,$42,$47,$30
        FCB        $67,$23,$84,$70
        FCB        $26                  ;3BD4 F1             DB 67h,26h,67h,23h,44h
        FCB        $67,$26,$67,$26
        FCB        $67,$23,$44,$42
        FCB        $47,$30,$67,$29
        FCB        $6A                  ;3BD4 F1             DB 67h,26h,67h,26h,67h
        FCB        $2B,$6C,$30,$2C
        FCB        $6D,$40,$2B,$6C
        FCB        $29,$6A,$67,$20
        FCB        $29                  ;3BD4 F1             DB 2Bh,6Ch,30h,2Ch,6Dh
        FCB        $6A,$40,$26,$87
        FCB        $70,$F0,$9D,$3C 		;3BD4 F1             DB 6Ah,40h,26h,87h,70h
BlankSpace4:     
        FDB        $0000				;3CDE                DW [ 11h ],0
        FDB        $0000
        FDB        $0000
        FDB        $0000
        FDB        $0000
        FDB        $0000
        FDB        $0000
        FDB        $0000
        FDB        $0000
        FDB        $0000
        FDB        $0000
        FDB        $0000
        FDB        $0000
        FDB        $0000
        FDB        $0000
        FDB        $0000
        FDB        $0000		
Message_10:     
        FCB        $96                  ;3D00                DB 96h ; û            "BONUS PAC-MAN FOR   000"
        FCB        $03                  ;3D01 03             DB 3                  
        FCB        $42                  ;3D02 42             DB 42h ; B             B                     
        FCB        $4F                  ;3D03 4F             DB 4Fh ; O             O                     
        FCB        $4E                  ;3D04 4E             DB 4Eh ; N             N                     
        FCB        $55                  ;3D05 55             DB 55h ; U             U                     
        FCB        $53                  ;3D06 53             DB 53h ; S             S                     
        FCB        $40                  ;3D07 40             DB 40h ; @             @                     
        FCB        $50                  ;3D08 50             DB 50h ; P             P                     
        FCB        $41                  ;3D09 41             DB 41h ; A             A                     
        FCB        $43                  ;3D0A 43             DB 43h ; C             C                     
        FCB        $3B                  ;3D0B 3B             DB 3Bh ; ;                                 
        FCB        $4D                  ;3D0C 4D             DB 4Dh ; M             M                     
        FCB        $41                  ;3D0D 41             DB 41h ; A             A
        FCB        $4E                  ;3D0E 4E             DB 4Eh ; N             N
        FCB        $40                  ;3D0F 40             DB 40h ; @             @
        FCB        $46                  ;3D10 46             DB 46h ; F             F
        FCB        $4F                  ;3D11 4F             DB 4Fh ; O             O
        FCB        $52                  ;3D12 52             DB 52h ; R             R
        FCB        $40                  ;3D13 40             DB 40h ; @             @
;        FCB        $30                  ;3D14 40             DB 40h ; @             @
;        FCB        $40                  ;3D15 40             DB 40h ; @             @
;        FCB        $30                  ;3D16 30 30          DB 30h ; 0             0
;        FCB        $30                  ;3D17                DB 30h ; 0             0
;        FCB        $30                  ;3D18 30 40          DB 30h ; 0             0
;        FCB        $40                  ;3D19                DB 40h ; @             @
;        FCB        $5D                  ;3D1A 5D             DB 5Dh ; ]             ]
;        FCB        $5E                  ;3D1B 5E             DB 5Eh ; ^             ^
;        FCB        $5F                  ;3D1C 5F             DB 5Fh ; _             _
;Original is above, change to default score of 10000, will be over written if the dip switch settings are different in the routine called ShowBonusScore
;The routine will be run at the beginning of the PreRendMessages routine.
ChangeExtraManScore:
        FCB        $31                  * 1
        FCB        $30                  * 0
        FCB        $30                  * 0
        FCB        $30                  * 0
        FCB        $30                  * 0
        FCB        $40                  ;3D19                DB 40h ; @             @
        FCB        $5D                  ;3D1A 5D             DB 5Dh ; ]             ]
        FCB        $5E                  ;3D1B 5E             DB 5Eh ; ^             ^
        FCB        $5F                  ;3D1C 5F             DB 5Fh ; _             _

        FCB        $2F                  ;3D1D 2F             DB 2Fh ; /             /
        FCB        $8E                  ;3D1E 8E             DB 8Eh ; Ä            Ä                     
        FCB        $2F                  ;3D1F 2F             DB 2Fh ; /             /                     
        FCB        $80                  ;3D20 80             DB 80h ; Ç            Ç                     
Message_11:
        FCB        $3A                  ;3D21 3A 03 5C       DB 3Ah ; :             :
        FCB        $03                  ;3D22                DB 3                  
        FCB        $5C                  ;3D23                DB 5Ch ; \             \                     
        FCB        $40                  ;3D24 40             DB 40h ; @             @                     
        FCB        $31                  ;3D25 31 39 38       DB 31h ; 1             "1980 MIDWAY MFG CO"
        FCB        $39                  ;3D26                DB 39h ; 9             9                     
        FCB        $38                  ;3D27                DB 38h ; 8             8                     
        FCB        $30                  ;3D28 30 40          DB 30h ; 0             0                     
        FCB        $40                  ;3D29                DB 40h ; @             @                     
        FCB        $4D                  ;3D2A 4D             DB 4Dh ; M             M                     
        FCB        $49                  ;3D2B 49             DB 49h ; I             I                     
        FCB        $44                  ;3D2C 44             DB 44h ; D             D                     
        FCB        $57                  ;3D2D 57             DB 57h ; W             W                     
        FCB        $41                  ;3D2E 41             DB 41h ; A             A                     
        FCB        $59                  ;3D2F 59             DB 59h ; Y             Y                     
        FCB        $40                  ;3D30 40             DB 40h ; @             @                     
        FCB        $4D                  ;3D31 4D             DB 4Dh ; M             M                     
        FCB        $46                  ;3D32 46             DB 46h ; F             F                     
        FCB        $47                  ;3D33 47             DB 47h ; G             G                     
        FCB        $25                  ;3D34 25             DB 25h ; %             %                     
        FCB        $43                  ;3D35 43             DB 43h ; C             C                     
        FCB        $4F                  ;3D36 4F             DB 4Fh ; O             O                     
        FCB        $25                  ;3D37 25             DB 25h ; %             %                     
        FCB        $2F                  ;3D38 2F             DB 2Fh ; /             /                     
        FCB        $83                  ;3D39 83             DB 83h ; â            â                     
        FCB        $2F                  ;3D3A 2F             DB 2Fh ; /             /                     
        FCB        $80                  ;3D3B 80             DB 80h ; Ç            Ç                     
Message_19:
        FCB        $3D                  ;3D3C 3D             DB 3Dh ; =             =       
        FCB        $03                  ;3D3D 03             DB 3               
		FCB        $5C                  ;3D3E 5C             DB 5Ch ; \             \                     
        FCB        $40                  ;3D3F 40             DB 40h ; @             @                     
        FCB        $31                  ;3D40 31 39 38       DB 31h ; 1             "1980 MIDWAY MFG CO"
        FCB        $39                  ;3D41                DB 39h ; 9             9                     
        FCB        $38                  ;3D42                DB 38h ; 8             8                     
        FCB        $30                  ;3D43 30 40          DB 30h ; 0             0                     
        FCB        $40                  ;3D44                DB 40h ; @             @                     
        FCB        $4D                  ;3D45 4D             DB 4Dh ; M             M                     
        FCB        $49                  ;3D46 49             DB 49h ; I             I                     
        FCB        $44                  ;3D47 44             DB 44h ; D             D                     
        FCB        $57                  ;3D48 57             DB 57h ; W             W                     
        FCB        $41                  ;3D49 41             DB 41h ; A             A                     
        FCB        $59                  ;3D4A 59             DB 59h ; Y             Y                     
        FCB        $40                  ;3D4B 40             DB 40h ; @             @                     
        FCB        $4D                  ;3D4C 4D             DB 4Dh ; M             M                     
        FCB        $46                  ;3D4D 46             DB 46h ; F             F                     
        FCB        $47                  ;3D4E 47             DB 47h ; G             G                     
        FCB        $25                  ;3D4F 25             DB 25h ; %             %                     
        FCB        $43                  ;3D50 43             DB 43h ; C             C                     
        FCB        $4F                  ;3D51 4F             DB 4Fh ; O             O                     
        FCB        $25                  ;3D52 25             DB 25h ; %             %                     
        FCB        $2F                  ;3D53 2F             DB 2Fh ; /             /                     
        FCB        $83                  ;3D54 83             DB 83h ; â            â                     
        FCB        $2F                  ;3D55 2F             DB 2Fh ; /             /                     
        FCB        $80                  ;3D56 80             DB 80h ; Ç            Ç                     
Message_20:
        FCB        $C5                  ;3D57 C5             DB 0C5h ; +            +                     
        FCB        $02                  ;3D58 02             DB 2                  
        FCB        $3B                  ;3D59 3B             DB 3Bh ; ;                                 
        FCB        $53                  ;3D5A 53             DB 53h ; S             "SHADOW"
        FCB        $48                  ;3D5B 48             DB 48h ; H             H                     
        FCB        $41                  ;3D5C 41             DB 41h ; A             A                     
        FCB        $44                  ;3D5D 44             DB 44h ; D             D                     
        FCB        $4F                  ;3D5E 4F             DB 4Fh ; O             O                     
        FCB        $57                  ;3D5F 57             DB 57h ; W             W                     
        FCB        $40                  ;3D60 40             DB 40h ; @             @                     
        FCB        $40                  ;3D61 40             DB 40h ; @             @                     
        FCB        $40                  ;3D62 40             DB 40h ; @             @                     
        FCB        $2F                  ;3D63 2F             DB 2Fh ; /             /                     
        FCB        $81                  ;3D64 81             DB 81h ; ü            ü                     
        FCB        $2F                  ;3D65 2F             DB 2Fh ; /             /                     
        FCB        $80                  ;3D66 80             DB 80h ; Ç            Ç                     
Message_13:
        FCB        $65                  ;3D67 65             DB 65h ; e             e                     
        FCB        $01                  ;3D68 01 26 42       DB 1                  
        FCB        $26                  ;3D69                DB 26h ; &             &                     
        FCB        $42                  ;3D6A                DB 42h ; B             "BLINKY"
        FCB        $4C                  ;3D6B 4C             DB 4Ch ; L             L                     
        FCB        $49                  ;3D6C 49             DB 49h ; I             I                     
        FCB        $4E                  ;3D6D 4E             DB 4Eh ; N             N                     
        FCB        $4B                  ;3D6E 4B             DB 4Bh ; K             K                     
        FCB        $59                  ;3D6F 59             DB 59h ; Y             Y                     
        FCB        $26                  ;3D70 26 40          DB 26h ; &             &                     
        FCB        $40                  ;3D71                DB 40h ; @             @                     
        FCB        $2F                  ;3D72 2F             DB 2Fh ; /             /                     
        FCB        $81                  ;3D73 81             DB 81h ; ü            ü                     
        FCB        $2F                  ;3D74 2F             DB 2Fh ; /             /                     
        FCB        $80                  ;3D75 80             DB 80h ; Ç            Ç                     
Message_22:
        FCB        $C8                  ;3D76 C8             DB 0C8h ; +            +                     
        FCB        $02                  ;3D77 02             DB 2                  
        FCB        $3B                  ;3D78 3B             DB 3Bh ; ;                                 
        FCB        $53                  ;3D79 53             DB 53h ; S             "SPEEDY"
        FCB        $50                  ;3D7A 50             DB 50h ; P             P                     
        FCB        $45                  ;3D7B 45             DB 45h ; E             E                     
        FCB        $45                  ;3D7C 45             DB 45h ; E             E                     
        FCB        $44                  ;3D7D 44             DB 44h ; D             D                     
        FCB        $59                  ;3D7E 59             DB 59h ; Y             Y                     
        FCB        $40                  ;3D7F 40             DB 40h ; @             @                     
        FCB        $40                  ;3D80 40             DB 40h ; @             @                     
        FCB        $40                  ;3D81 40             DB 40h ; @             @                     
        FCB        $2F                  ;3D82 2F             DB 2Fh ; /             /                     
        FCB        $83                  ;3D83 83             DB 83h ; â            â                     
        FCB        $2F                  ;3D84 2F             DB 2Fh ; /             /                     
        FCB        $80                  ;3D85 80             DB 80h ; Ç            Ç                     
Message_15:
        FCB        $68                  ;3D86 68             DB 68h ; h             h                     
        FCB        $01                  ;3D87 01 26 50       DB 1                  
        FCB        $26                  ;3D88                DB 26h ; &             &                     
        FCB        $50                  ;3D89                DB 50h ; P             "PINKY"
        FCB        $49                  ;3D8A 49             DB 49h ; I             I                     
        FCB        $4E                  ;3D8B 4E             DB 4Eh ; N             N                     
        FCB        $4B                  ;3D8C 4B             DB 4Bh ; K             K                     
        FCB        $59                  ;3D8D 59             DB 59h ; Y             Y                     
        FCB        $26                  ;3D8E 26 40          DB 26h ; &             &                     
        FCB        $40                  ;3D8F                DB 40h ; @             @                     
        FCB        $40                  ;3D90 40             DB 40h ; @             @                     
        FCB        $2F                  ;3D91 2F             DB 2Fh ; /             /                     
        FCB        $83                  ;3D92 83             DB 83h ; â            â                     
        FCB        $2F                  ;3D93 2F             DB 2Fh ; /             /                     
        FCB        $80                  ;3D94 80             DB 80h ; Ç            Ç                     
Message_51:
        FCB        $CB                  ;3D95 CB 02          DB 0CBh ; -            -                     
        FCB        $02                  ;3D96                DB 2                  
        FCB        $3B                  ;3D97 3B             DB 3Bh ; ;             "BASHFUL"
        FCB        $42                  ;3D98 42             DB 42h ; B             B                     
        FCB        $41                  ;3D99 41             DB 41h ; A             A                     
        FCB        $53                  ;3D9A 53             DB 53h ; S             S                     
        FCB        $48                  ;3D9B 48             DB 48h ; H             H                     
        FCB        $46                  ;3D9C 46             DB 46h ; F             F                     
        FCB        $55                  ;3D9D 55             DB 55h ; U             U                     
        FCB        $4C                  ;3D9E 4C             DB 4Ch ; L             L                     
        FCB        $40                  ;3D9F 40             DB 40h ; @             @                     
        FCB        $40                  ;3DA0 40             DB 40h ; @             @                     
        FCB        $2F                  ;3DA1 2F             DB 2Fh ; /             /                     
        FCB        $85                  ;3DA2 85             DB 85h ; à            à                     
        FCB        $2F                  ;3DA3 2F             DB 2Fh ; /             /                     
        FCB        $80                  ;3DA4 80             DB 80h ; Ç            Ç                     
Message_47:
        FCB        $6B                  ;3DA5 6B             DB 6Bh ; k             k                     
        FCB        $01                  ;3DA6 01 26 49       DB 1                  
        FCB        $26                  ;3DA7                DB 26h ; &             "INKY"
        FCB        $49                  ;3DA8                DB 49h ; I             I                     
        FCB        $4E                  ;3DA9 4E             DB 4Eh ; N             N                     
        FCB        $4B                  ;3DAA 4B             DB 4Bh ; K             K                     
        FCB        $59                  ;3DAB 59             DB 59h ; Y             Y                     
        FCB        $26                  ;3DAC 26 40          DB 26h ; &             &                     
        FCB        $40                  ;3DAD                DB 40h ; @             @                     
        FCB        $40                  ;3DAE 40             DB 40h ; @             @                     
        FCB        $40                  ;3DAF 40             DB 40h ; @             @                     
        FCB        $2F                  ;3DB0 2F             DB 2Fh ; /             /                     
        FCB        $85                  ;3DB1 85             DB 85h ; à            à                     
        FCB        $2F                  ;3DB2 2F             DB 2Fh ; /             /                     
        FCB        $80                  ;3DB3 80             DB 80h ; Ç            Ç                     
Message_53:
        FCB        $CE                  ;3DB4 CE 02          DB 0CEh ; +            +                     
        FCB        $02                  ;3DB5                DB 2                  
        FCB        $3B                  ;3DB6 3B             DB 3Bh ; ;                                 
        FCB        $50                  ;3DB7 50             DB 50h ; P             "POKEY"
        FCB        $4F                  ;3DB8 4F             DB 4Fh ; O             O                     
        FCB        $4B                  ;3DB9 4B             DB 4Bh ; K             K                     
        FCB        $45                  ;3DBA 45             DB 45h ; E             E                     
        FCB        $59                  ;3DBB 59             DB 59h ; Y             Y                     
        FCB        $40                  ;3DBC 40             DB 40h ; @             @                     
        FCB        $40                  ;3DBD 40             DB 40h ; @             @                     
        FCB        $40                  ;3DBE 40             DB 40h ; @             @                     
        FCB        $40                  ;3DBF 40             DB 40h ; @             @                     
        FCB        $2F                  ;3DC0 2F             DB 2Fh ; /             /                     
        FCB        $87                  ;3DC1 87             DB 87h ; ç            ç                     
        FCB        $2F                  ;3DC2 2F             DB 2Fh ; /             /                     
        FCB        $80                  ;3DC3 80             DB 80h ; Ç            Ç                     
Message_49:
        FCB        $6E                  ;3DC4 6E             DB 6Eh ; n             n                     
        FCB        $01                  ;3DC5 01 26 43       DB 1                  
        FCB        $26                  ;3DC6                DB 26h ; &             "CLYDE"
        FCB        $43                  ;3DC7                DB 43h ; C             C                     
        FCB        $4C                  ;3DC8 4C             DB 4Ch ; L             L                     
        FCB        $59                  ;3DC9 59             DB 59h ; Y             Y                     
        FCB        $44                  ;3DCA 44             DB 44h ; D             D                     
        FCB        $45                  ;3DCB 45             DB 45h ; E             E                     
        FCB        $26                  ;3DCC 26 40          DB 26h ; &             &                     
        FCB        $40                  ;3DCD                DB 40h ; @             @                     
        FCB        $40                  ;3DCE 40             DB 40h ; @             @                     
        FCB        $2F                  ;3DCF 2F             DB 2Fh ; /             /                     
        FCB        $87                  ;3DD0 87             DB 87h ; ç            ç                     
        FCB        $2F                  ;3DD1 2F             DB 2Fh ; /             /                     
        FCB        $80                  ;3DD2 80             DB 80h ; Ç            Ç                     
Message_21:
        FCB        $C5                  ;3DD3 C5             DB 0C5h ; +            +                     
        FCB        $02                  ;3DD4 02             DB 2                  
        FCB        $3B                  ;3DD5 3B             DB 3Bh ; ;                                 
        FCB        $41                  ;3DD6 41             DB 41h ; A             "AAAAAAAA"
        FCB        $41                  ;3DD7 41             DB 41h ; A             A                     
        FCB        $41                  ;3DD8 41             DB 41h ; A             A                     
        FCB        $41                  ;3DD9 41             DB 41h ; A             A                     
        FCB        $41                  ;3DDA 41             DB 41h ; A             A                     
        FCB        $41                  ;3DDB 41             DB 41h ; A             A                     
        FCB        $41                  ;3DDC 41             DB 41h ; A             A                     
        FCB        $41                  ;3DDD 41             DB 41h ; A             A                     
        FCB        $3B                  ;3DDE 3B             DB 3Bh ; ;                                 
        FCB        $2F                  ;3DDF 2F             DB 2Fh ; /             /                     
        FCB        $81                  ;3DE0 81             DB 81h ; ü            ü                     
        FCB        $2F                  ;3DE1 2F             DB 2Fh ; /             /                     
        FCB        $80                  ;3DE2 80             DB 80h ; Ç            Ç                     
Message_14:
        FCB        $65                  ;3DE3 65             DB 65h ; e             e                     
        FCB        $01                  ;3DE4 01 26 42       DB 1                  
        FCB        $26                  ;3DE5                DB 26h ; &             &                     
        FCB        $42                  ;3DE6                DB 42h ; B             "BBBBBBBB"
        FCB        $42                  ;3DE7 42             DB 42h ; B             B                     
        FCB        $42                  ;3DE8 42             DB 42h ; B             B                     
        FCB        $42                  ;3DE9 42             DB 42h ; B             B                     
        FCB        $42                  ;3DEA 42             DB 42h ; B             B                     
        FCB        $42                  ;3DEB 42             DB 42h ; B             B                     
        FCB        $42                  ;3DEC 42             DB 42h ; B             B                     
        FCB        $26                  ;3DED 26 2F          DB 26h ; &             &                     
        FCB        $2F                  ;3DEE                DB 2Fh ; /             /                     
        FCB        $81                  ;3DEF 81             DB 81h ; ü            ü                     
        FCB        $2F                  ;3DF0 2F             DB 2Fh ; /             /                     
        FCB        $80                  ;3DF1 80             DB 80h ; Ç            Ç                     
Message_23:
        FCB        $C8                  ;3DF2 C8             DB 0C8h ; +            +                     
        FCB        $02                  ;3DF3 02             DB 2                  
        FCB        $3B                  ;3DF4 3B             DB 3Bh ; ;                                 
        FCB        $43                  ;3DF5 43             DB 43h ; C             "CCCCCCCC"
        FCB        $43                  ;3DF6 43             DB 43h ; C             C                     
        FCB        $43                  ;3DF7 43             DB 43h ; C             C                     
        FCB        $43                  ;3DF8 43             DB 43h ; C             C                     
        FCB        $43                  ;3DF9 43             DB 43h ; C             C                     
        FCB        $43                  ;3DFA 43             DB 43h ; C             C                     
        FCB        $43                  ;3DFB 43             DB 43h ; C             C                     
        FCB        $43                  ;3DFC 43             DB 43h ; C             C                     
        FCB        $3B                  ;3DFD 3B             DB 3Bh ; ;                                 
        FCB        $2F                  ;3DFE 2F             DB 2Fh ; /             /                     
        FCB        $83                  ;3DFF 83             DB 83h ; â            â                     
        FCB        $2F                  ;3E00 2F             DB 2Fh ; /             /                     
        FCB        $80                  ;3E01 80             DB 80h ; Ç            Ç                     
Message_16:
        FCB        $68                  ;3E02 68             DB 68h ; h             h                     
        FCB        $01                  ;3E03 01 26 44       DB 1                  
        FCB        $26                  ;3E04                DB 26h ; &             &                     
        FCB        $44                  ;3E05                DB 44h ; D             "DDDDDDDD"
        FCB        $44                  ;3E06 44             DB 44h ; D             D                     
        FCB        $44                  ;3E07 44             DB 44h ; D             D                     
        FCB        $44                  ;3E08 44             DB 44h ; D             D                     
        FCB        $44                  ;3E09 44             DB 44h ; D             D                     
        FCB        $44                  ;3E0A 44             DB 44h ; D             D                     
        FCB        $44                  ;3E0B 44             DB 44h ; D             D                     
        FCB        $26                  ;3E0C 26 2F          DB 26h ; &             &                     
        FCB        $2F                  ;3E0D                DB 2Fh ; /             /                     
        FCB        $83                  ;3E0E 83             DB 83h ; â            â                     
        FCB        $2F                  ;3E0F 2F             DB 2Fh ; /             /                     
        FCB        $80                  ;3E10 80             DB 80h ; Ç            Ç                     
Message_52:
        FCB        $CB                  ;3E11 CB 02          DB 0CBh ; -            -                     
        FCB        $02                  ;3E12                DB 2                  
        FCB        $3B                  ;3E13 3B             DB 3Bh ; ;                                 
        FCB        $45                  ;3E14 45             DB 45h ; E             "EEEEEEEE"
        FCB        $45                  ;3E15 45             DB 45h ; E             E                     
        FCB        $45                  ;3E16 45             DB 45h ; E             E                     
        FCB        $45                  ;3E17 45             DB 45h ; E             E                     
        FCB        $45                  ;3E18 45             DB 45h ; E             E                     
        FCB        $45                  ;3E19 45             DB 45h ; E             E                     
        FCB        $45                  ;3E1A 45             DB 45h ; E             E                     
        FCB        $45                  ;3E1B 45             DB 45h ; E             E                     
        FCB        $3B                  ;3E1C 3B             DB 3Bh ; ;                                 
        FCB        $2F                  ;3E1D 2F             DB 2Fh ; /             /                     
        FCB        $85                  ;3E1E 85             DB 85h ; à            à                     
        FCB        $2F                  ;3E1F 2F             DB 2Fh ; /             /                     
        FCB        $80                  ;3E20 80             DB 80h ; Ç            Ç                     
Message_48:
        FCB        $6B                  ;3E21 6B             DB 6Bh ; k             k                     
        FCB        $01                  ;3E22 01 26 46       DB 1                  
        FCB        $26                  ;3E23                DB 26h ; &             &                     
        FCB        $46                  ;3E24                DB 46h ; F             "FFFFFFFF"
        FCB        $46                  ;3E25 46             DB 46h ; F             F                     
        FCB        $46                  ;3E26 46             DB 46h ; F             F                     
        FCB        $46                  ;3E27 46             DB 46h ; F             F                     
        FCB        $46                  ;3E28 46             DB 46h ; F             F                     
        FCB        $46                  ;3E29 46             DB 46h ; F             F                     
        FCB        $46                  ;3E2A 46             DB 46h ; F             F                     
        FCB        $26                  ;3E2B 26 2F          DB 26h ; &             &                     
        FCB        $2F                  ;3E2C                DB 2Fh ; /             /                     
        FCB        $85                  ;3E2D 85             DB 85h ; à            à                     
        FCB        $2F                  ;3E2E 2F             DB 2Fh ; /             /                     
        FCB        $80                  ;3E2F 80             DB 80h ; Ç            Ç                     
Message_54:
        FCB        $CE                  ;3E30 CE 02          DB 0CEh ; +            +                     
        FCB        $02                  ;3E31                DB 2                  
        FCB        $3B                  ;3E32 3B             DB 3Bh ; ;                                 
        FCB        $47                  ;3E33 47             DB 47h ; G             "GGGGGGGG"
        FCB        $47                  ;3E34 47             DB 47h ; G             G                     
        FCB        $47                  ;3E35 47             DB 47h ; G             G                     
        FCB        $47                  ;3E36 47             DB 47h ; G             G                     
        FCB        $47                  ;3E37 47             DB 47h ; G             G                     
        FCB        $47                  ;3E38 47             DB 47h ; G             G                     
        FCB        $47                  ;3E39 47             DB 47h ; G             G                     
        FCB        $47                  ;3E3A 47             DB 47h ; G             G                     
        FCB        $3B                  ;3E3B 3B             DB 3Bh ; ;                                 
        FCB        $2F                  ;3E3C 2F             DB 2Fh ; /             /                     
        FCB        $87                  ;3E3D 87             DB 87h ; ç            ç                     
        FCB        $2F                  ;3E3E 2F             DB 2Fh ; /             /                     
        FCB        $80                  ;3E3F 80             DB 80h ; Ç            Ç                     
Message_50:
        FCB        $6E                  ;3E40 6E             DB 6Eh ; n             n                     
        FCB        $01                  ;3E41 01 26 48       DB 1                  
        FCB        $26                  ;3E42                DB 26h ; &             &                     
        FCB        $48                  ;3E43                DB 48h ; H             "HHHHHHHH"
        FCB        $48                  ;3E44 48             DB 48h ; H             H                     
        FCB        $48                  ;3E45 48             DB 48h ; H             H                     
        FCB        $48                  ;3E46 48             DB 48h ; H             H                     
        FCB        $48                  ;3E47 48             DB 48h ; H             H                     
        FCB        $48                  ;3E48 48             DB 48h ; H             H                     
        FCB        $48                  ;3E49 48             DB 48h ; H             H                     
        FCB        $26                  ;3E4A 26 2F          DB 26h ; &             &                     
        FCB        $2F                  ;3E4B                DB 2Fh ; /             /                     
        FCB        $87                  ;3E4C 87             DB 87h ; ç            ç                     
        FCB        $2F                  ;3E4D 2F             DB 2Fh ; /             /                     
        FCB        $80                  ;3E4E 80             DB 80h ; Ç            Ç                     
Message_41:
        FCB        $0C                  ;3E4F 0C             DB 0Ch                
        FCB        $03                  ;3E50 03             DB 3                  
        FCB        $50                  ;3E51 50             DB 50h ; P             "PAC MAN"
        FCB        $41                  ;3E52 41             DB 41h ; A             A                     
        FCB        $43                  ;3E53 43             DB 43h ; C             C                     
        FCB        $3B                  ;3E54 3B             DB 3Bh ; ;                                 
        FCB        $4D                  ;3E55 4D             DB 4Dh ; M             M                     
        FCB        $41                  ;3E56 41             DB 41h ; A             A                     
        FCB        $4E                  ;3E57 4E             DB 4Eh ; N             N                     
        FCB        $2F                  ;3E58 2F             DB 2Fh ; /             /                     
        FCB        $8F                  ;3E59 8F             DB 8Fh ; Å            Å                     
        FCB        $2F                  ;3E5A 2F             DB 2Fh ; /             /                     
        FCB        $80                  ;3E5B 80             DB 80h ; Ç            Ç                     
BlankSpace5:     
        FDB        $0000                ;3E5C                DW [ 0CFh ],0
IntVect2:     
        FDB        $0030                ;3FFA                DW 3000h               interrupt vector 3000h
IntVect3:     
        FDB        $8D00                ;3FFC                DW 8Dh                 interrupt vector 008dh
Checksum4:     
        FDB        $7573                ;3FFE                DW 7375h               Checksum data

********************************
* Moved TileRAM (screen memory location) in the middle of the code so it really is at $4000-43ff and PaletteRAM is right after it
;        ORG     $4000

;TileRAM:
;        ZMB		   $400				;4000                DB [ 400h ],0			Still need this space to record which pills have been eaten...
;===========================
; PaletteRAM
; Each byte applies a palette to
; the corresponding tile in TileRAM
;===========================
;PaletteRAM:
;        FCB        $0],$00 			;4400                DB [ 400h ],0			We don't need to reserve this space, but we need the pointer
;=========================
; TODO - is this RAM 4800-4BFF unused?
; Seems unlikely
;=========================
UnusedRAM:     
;        FCB        $0],$00  			;4800                DB [ 400h ],0
;===========================
;      Game RAM - all game state RAM
; items follow
;===========================
SpriteNumberPointer:
        FDB        $0000                ;4C00                DW 0                   TODO - figure out if used?
;==============================
; Sprite Variables
;==============================
*
* When power pill is eaten all ghosts sprites alternate between $1C & $1D (maybe ghost sprites animation) and palette $11 and when they are about to change back the palette changes to $12
*
RedGhostNum:     
        FCB        $00                  ;4C02                DB 0 22 - All ghosts are the same these change depending on the direction the ghost is going (maybe related to the eyes and animation)
RedGhostColor:     
        FCB        $00                  ;4C03                DB 0 01
PinkGhostNum:     
        FCB        $00                  ;4C04                DB 0 24
PinkGhostColor:     
        FCB        $00                  ;4C05                DB 0 03
BlueGhostNum:     
        FCB        $00                  ;4C06                DB 0 22
BlueGhostColor:     
        FCB        $00                  ;4C07                DB 0 05
OrangeGhostNum:     
        FCB        $00                  ;4C08                DB 0 22
OrangeGhostColor:     
        FCB        $00                  ;4C09                DB 0 07
PacmanSpriteNum:     
        FCB        $00                  ;4C0A                DB 0 AE - Pac man Sprite number changes as Pacman mouth opens and closes and changes directions
PacmanSpriteColor:     
        FCB        $00                  ;4C0B                DB 0 09
FruitSpriteNum:     
        FCB        $00                  ;4C0C                DB 0 00 - Cherry
FruitSpriteColor:     
        FCB        $00                  ;4C0D                DB 0 14 - will change to actual palette with colour when fruit comes on screen
        FCB        $00                  ;4C0E                DB 0                  
        FCB        $00                  ;4C0F                DB 0                  
        FCB        $00                  ;4C10                DB 0                  
        FCB        $00                  ;4C11                DB 0
Sprite_Coordinates:
        FCB        $00                  ;4C12                DB 0    Copied RedXPos  here after adding 6 to it's value               
        FCB    	   $00                  ;4C13             	 DB 0    Copied RedYPos  here after adding 9 to is's value              
        FCB    	   $00                  ;4C14            	 DB 0    Copied PinkXPos  here after adding 6 to it's value                      
        FCB    	   $00                  ;4C15            	 DB 0    Copied PinkYPos  here after adding 9 to is's value 
        FCB        $00                  ;4C16                DB 0    Copied BlueXPos  here after adding 7 to it's value                  
        FCB        $00                  ;4C17                DB 0    Copied BlueYPos  here after adding 9 to is's value                  
        FCB        $00                  ;4C18                DB 0    Copied OrangeXPos  here after adding 7 to it's value                  
        FCB        $00                  ;4C19                DB 0    Copied OrangeYPos  here after adding 9 to is's value              
        FCB        $00                  ;4C1A                DB 0    Copied PacmanXPos  here after adding 7 to it's value                  
        FCB        $00                  ;4C1B                DB 0    Copied PacmanYPos  here after adding 9 to is's value                  
        FCB        $00                  ;4C1C                DB 0    Copied FruitXPos  here after adding 7 to it's value                  
        FCB        $00                  ;4C1D                DB 0    Copied FruitYPos  here after adding 9 to is's value                  
        FCB        $00                  ;4C1E                DB 0                  
        FCB        $00                  ;4C1F                DB 0                  
SpriteDataCopy:     
        FDB        $0000                ;4C20                DW 0    this and lower are copied to hardware each interrupt
SpriteBuffer:
;Red Ghost Sprite data
        FDB        $0000                ;4C22                DW 0    Copy of sprite data from last frame,used to buffer before sending to HW
word_4C24:
;Pink Ghost Sprite data
        FDB        $0000                ;4C24                DW 0
;Blue Ghost Sprite Data
        FCB        $00                  ;4C26                DB 0
        FCB        $00                  ;4C27                DB 0                  
;Orange Ghost Sprite data
        FCB        $00                  ;4C28                DB 0
        FCB        $00                  ;4C29                DB 0                  
word_4C2A:
;Pacman Sprite Data
        FDB        $0000                ;4C2A                DW 0
;Fruite Sprite Data
        FCB        $00                  ;4C2C                DB 0                  
        FCB        $00                  ;4C2D                DB 0                  
        FCB        $00                  ;4C2E                DB 0                  
        FCB        $00                  ;4C2F                DB 0                  
        FCB        $00                  ;4C30                DB 0                  
        FCB        $00                  ;4C31                DB 0                  
word_4C32:
;Red Ghost X,Y
        FDB        $0000                ;4C32                DW 0     * Sprite X,Y location info copied to sprite hardware 5062 to 506E (12 bytes)
word_4C34:
;Pink ghost X,Y
        FDB        $0000                ;4C34                DW 0
;Blue ghost X,Y
        FCB        $00                  ;4C36                DB 0                  
        FCB        $00                  ;4C37                DB 0
;Orange ghost X,Y
        FCB        $00                  ;4C38                DB 0                  
        FCB        $00                  ;4C39                DB 0                  
word_4C3A:
;Pacman X,Y
        FDB        $0000                ;4C3A                DW 0
;Fruit X,Y
        FCB        $00                  ;4C3C                DB 0                  
        FCB        $00                  ;4C3D                DB 0                  
        FCB        $00                  ;4C3E                DB 0                  
        FCB        $00                  ;4C3F                DB 0                  
        FCB        $00                  ;4C40                DB 0                  
        FCB        $00                  ;4C41                DB 0                  
        FCB        $00                  ;4C42                DB 0                  
        FCB        $00                  ;4C43                DB 0                  
        FCB        $00                  ;4C44                DB 0                  
        FCB        $00                  ;4C45                DB 0                  
        FCB        $00                  ;4C46                DB 0                  
        FCB        $00                  ;4C47                DB 0                  
        FCB        $00                  ;4C48                DB 0                  
        FCB        $00                  ;4C49                DB 0                  
        FCB        $00                  ;4C4A                DB 0                  
        FCB        $00                  ;4C4B                DB 0                  
        FCB        $00                  ;4C4C                DB 0                  
        FCB        $00                  ;4C4D                DB 0                  
        FCB        $00                  ;4C4E                DB 0                  
        FCB        $00                  ;4C4F                DB 0                  
        FCB        $00                  ;4C50                DB 0                  
        FCB        $00                  ;4C51                DB 0                  
        FCB        $00                  ;4C52                DB 0                  
        FCB        $00                  ;4C53                DB 0                  
        FCB        $00                  ;4C54                DB 0                  
        FCB        $00                  ;4C55                DB 0                  
        FCB        $00                  ;4C56                DB 0                  
        FCB        $00                  ;4C57                DB 0                  
        FCB        $00                  ;4C58                DB 0                  
        FCB        $00                  ;4C59                DB 0                  
        FCB        $00                  ;4C5A                DB 0                  
        FCB        $00                  ;4C5B                DB 0                  
        FCB        $00                  ;4C5C                DB 0                  
        FCB        $00                  ;4C5D                DB 0                  
        FCB        $00                  ;4C5E                DB 0                  
        FCB        $00                  ;4C5F                DB 0                  
        FCB        $00                  ;4C60                DB 0                  
        FCB        $00                  ;4C61                DB 0                  
        FCB        $00                  ;4C62                DB 0                  
        FCB        $00                  ;4C63                DB 0                  
        FCB        $00                  ;4C64                DB 0                  
        FCB        $00                  ;4C65                DB 0                  
        FCB        $00                  ;4C66                DB 0                  
        FCB        $00                  ;4C67                DB 0                  
        FCB        $00                  ;4C68                DB 0                  
        FCB        $00                  ;4C69                DB 0                  
        FCB        $00                  ;4C6A                DB 0                  
        FCB        $00                  ;4C6B                DB 0                  
        FCB        $00                  ;4C6C                DB 0                  
        FCB        $00                  ;4C6D                DB 0                  
        FCB        $00                  ;4C6E                DB 0                  
        FCB        $00                  ;4C6F                DB 0                  
        FCB        $00                  ;4C70                DB 0                  
        FCB        $00                  ;4C71                DB 0                  
        FCB        $00                  ;4C72                DB 0                  
        FCB        $00                  ;4C73                DB 0                  
        FCB        $00                  ;4C74                DB 0                  
        FCB        $00                  ;4C75                DB 0                  
        FCB        $00                  ;4C76                DB 0                  
        FCB        $00                  ;4C77                DB 0                  
        FCB        $00                  ;4C78                DB 0                  
        FCB        $00                  ;4C79                DB 0                  
        FCB        $00                  ;4C7A                DB 0                  
        FCB        $00                  ;4C7B                DB 0                  
        FCB        $00                  ;4C7C                DB 0                  
        FCB        $00                  ;4C7D                DB 0                  
        FCB        $00                  ;4C7E                DB 0                  
        FCB        $00                  ;4C7F                DB 0                  
;==============================
;Tasks and timers
;==============================
TaskListEndPtr:     
        FDB        $0000                ;4C80                DW 0                   Pointer to the end of the task list
TaskListStrtPtr:     
        FDB        $0000                ;4C82                DW 0                   Pointer  to the start of the task list
Count8BitsUp:     
        FCB        $00                  ;4C84                DB 0                   8 bit counter (00 to FF) used by sound
Count8BitsDown:
        FCB        $00                  ;4C85                DB 0                 ; 8 but unused counter - TODO? FF to 00
Timer60:     
        FCB        $00                  ;4C86                DB 0                 ; 60ths of a second ticks - top nibble counts 10ths
;                                        of a second,Bottom counts 60ths 0,1,2,3,4,5,rollover...
TimerSec:     
        FCB        $00                  ;4C87                DB 0                 ; seconds timer
TimerMin:     
        FCB        $00                  ;4C88                DB 0                 ; minute timer
TimerHours:     
        FCB        $00                  ;4C89                DB 0                 ; hour timer
; number of counter limit changes this frame
; values are
;  0x01 = 1 hundreth
;  0x02 = 10 hundreths
;  0x03 = 1 second
;  0x04 = 10 seconds
;  0x05 = 1 minute
;  0x06 = 10 minutes
;  0x07 = 1 hour
;  0x08 = 10 hours
;  0x09 = 100 hours
TimerLimits:     
        FCB        $00                  ;4C8A                DB 0                   counts how many nibbles overflowd on last timer update
RandUnused1:     
        FCB        $00                  ;4C8B                DB 0                   TODO - unused random number spot?
;                                         Each timer tick this byte gets replaced with 5*byte+1
RandUnused2:     
        FCB        $00                  ;4C8C                DB 0                 ; Each timer tick this bytes gets 13*byte+1
        FCB        $00                  ;4C8D                DB 0                  
        FCB        $00                  ;4C8E                DB 0                  
        FCB        $00                  ;4C8F                DB 0                  
;============================
; Tasks list 4C90-4CBF (runs in IRQ)
; 16 entries,3 bytes each
; byte 0 - scheduled time
; byte 1 - index for jump table
; byte 2 - parameter passed in B
;============================
TaskListIRQ:     
        FCB        $00                  ;4C90                DB 0                 ; List of tasks that run in IRQ
        FCB        $00                  ;4C91                DB 0                 ; 16 tasks,3 bytes per entry
        FCB        $00                  ;4C92                DB 0                 ; byte 0: scheduled time,
        FCB        $00                  ;4C93                DB 0                 ; byte 1 index for jump table
        FCB        $00                  ;4C94                DB 0                 ; byte 2 parameter for B
        FCB        $00                  ;4C95                DB 0                  
        FCB        $00                  ;4C96                DB 0                  
        FCB        $00                  ;4C97                DB 0                  
        FCB        $00                  ;4C98                DB 0                  
        FCB        $00                  ;4C99                DB 0                  
        FCB        $00                  ;4C9A                DB 0                  
        FCB        $00                  ;4C9B                DB 0                  
        FCB        $00                  ;4C9C                DB 0                  
        FCB        $00                  ;4C9D                DB 0                  
        FCB        $00                  ;4C9E                DB 0                  
        FCB        $00                  ;4C9F                DB 0                  
        FCB        $00                  ;4CA0                DB 0                  
        FCB        $00                  ;4CA1                DB 0                  
        FCB        $00                  ;4CA2                DB 0                  
        FCB        $00                  ;4CA3                DB 0                  
        FCB        $00                  ;4CA4                DB 0                  
        FCB        $00                  ;4CA5                DB 0                  
        FCB        $00                  ;4CA6                DB 0                  
        FCB        $00                  ;4CA7                DB 0                  
        FCB        $00                  ;4CA8                DB 0                  
        FCB        $00                  ;4CA9                DB 0                  
        FCB        $00                  ;4CAA                DB 0                  
        FCB        $00                  ;4CAB                DB 0                  
        FCB        $00                  ;4CAC                DB 0                  
        FCB        $00                  ;4CAD                DB 0                  
        FCB        $00                  ;4CAE                DB 0                  
        FCB        $00                  ;4CAF                DB 0                  
        FCB        $00                  ;4CB0                DB 0                  
        FCB        $00                  ;4CB1                DB 0                  
        FCB        $00                  ;4CB2                DB 0                  
        FCB        $00                  ;4CB3                DB 0                  
        FCB        $00                  ;4CB4                DB 0                  
        FCB        $00                  ;4CB5                DB 0                  
        FCB        $00                  ;4CB6                DB 0                  
        FCB        $00                  ;4CB7                DB 0                  
        FCB        $00                  ;4CB8                DB 0                  
        FCB        $00                  ;4CB9                DB 0                  
        FCB        $00                  ;4CBA                DB 0                  
        FCB        $00                  ;4CBB                DB 0                  
        FCB        $00                  ;4CBC                DB 0                  
        FCB        $00                  ;4CBD                DB 0                  
        FCB        $00                  ;4CBE                DB 0                  
        FCB        $00                  ;4CBF                DB 0                  
;============================
; Task list 4CC0-4CCF,runs in normal game
; 32 entries,2 bytes each TODO
;   byte 0 = routine number
;   byte 1 = parameter
; Store FFh to denote no task
;============================
TaskListNorm:
        FDB        $0000                ;4CC0                DW [ 20h ],0
        FDB        $0000
        FDB        $0000
        FDB        $0000
        FDB        $0000
        FDB        $0000
        FDB        $0000
        FDB        $0000
        FDB        $0000
        FDB        $0000
        FDB        $0000
        FDB        $0000
        FDB        $0000
        FDB        $0000
        FDB        $0000
        FDB        $0000
        FDB        $0000
        FDB        $0000
        FDB        $0000
        FDB        $0000
        FDB        $0000
        FDB        $0000
        FDB        $0000
        FDB        $0000
        FDB        $0000
        FDB        $0000
        FDB        $0000
        FDB        $0000
        FDB        $0000
        FDB        $0000
        FDB        $0000
        FDB        $0000
;============================
; Game Variables
;============================
RedXPos:     
        FCB        $00                  ;4D00                DB 0                   Red ghost X position (decreases left to right)
RedYPos:     
        FCB        $00                  ;4D01                DB 0                   Red ghost Y position, (decreases bottom to top)
PinkXPos:     
        FCB        $00                  ;4D02                DB 0
PinkYPos:     
        FCB        $00                  ;4D03                DB 0
BlueXPos:
        FCB        $00                  ;4D04                DB 0
BlueYPos:     
        FCB        $00                  ;4D05                DB 0
OrangeXPos:     
        FCB        $00                  ;4D06                DB 0
OrangeYPos:     
        FCB        $00                  ;4D07                DB 0
PacManXPos:     
        FCB        $00                  ;4D08                DB 0
PacManYPos:
        FCB        $00                  ;4D09                DB 0
RedTileX:     
        FCB        $00                  ;4D0A                DB 0
RedTileY:     
        FCB        $00                  ;4D0B                DB 0
PinkTileX:     
        FCB        $00                  ;4D0C                DB 0
PinkTileY:     
        FCB        $00                  ;4D0D                DB 0
BlueTileX:     
        FCB        $00                  ;4D0E                DB 0
BlueTileY:     
        FCB        $00                  ;4D0F                DB 0
OrangeTileX:     
        FCB        $00                  ;4D10                DB 0
OrangeTileY:     
        FCB        $00                  ;4D11                DB 0
PacManTileX:     
        FCB        $00                  ;4D12                DB 0
PacManTileY:     
        FCB        $00                  ;4D13                DB 0
RedOffset:
        FDB        $0000                ;4D14                DW 0   ;Red Ghost Direction Iterator??? ( 0x00FF = right, 0x0100 = down, 0x0001 = left, 0xFF00 = up )
PinkOffset:
        FDB        $0000                ;4D16                DW 0   ;Pink Ghost Direction Iterator??? ( 0x00FF = right, 0x0100 = down, 0x0001 = left, 0xFF00 = up )
BlueOffset:
        FDB        $0000                ;4D18                DW 0   ;Blue Ghost Direction Iterator??? ( 0x00FF = right, 0x0100 = down, 0x0001 = left, 0xFF00 = up )
OrangeOffset:
        FDB        $0000                ;4D1A                DW 0   ;Orange Ghost Direction Iterator??? ( 0x00FF = right, 0x0100 = down, 0x0001 = left, 0xFF00 = up )
PacOffset:     
        FDB        $0000                ;4D1C                DW 0   ;Pacman Ghost Direction Iterator??? ( 0x00FF = right, 0x0100 = down, 0x0001 = left, 0xFF00 = up )
RedPosPredict:
        FDB        $0000                ;4D1E                DW 0   ;Red Position Predictor ( 0x00FF = right, 0x0100 = down, 0x0001 = left, 0xFF00 = up )
PinkPosPredict:
        FDB        $0000                ;4D20                DW 0   ;Pink Position Predictor ( 0x00FF = right, 0x0100 = down, 0x0001 = left, 0xFF00 = up )
BluePosPredict:
        FDB        $0000                ;4D22                DW 0   ;Blue Position Predictor ( 0x00FF = right, 0x0100 = down, 0x0001 = left, 0xFF00 = up )
OrangePosPredict:
        FDB        $0000                ;4D24                DW 0   ;Orange Position Predictor ( 0x00FF = right, 0x0100 = down, 0x0001 = left, 0xFF00 = up )
PacmanPosPredict:
        FDB        $0000                ;4D26                DW 0   ;Pacman Position Predictor ( 0x00FF = right, 0x0100 = down, 0x0001 = left, 0xFF00 = up )
RedDirection:
        FCB        $00                  ;4D28                DB 0   ;Red Ghost Direction ( 0=right, 1=down, 2=left, 3=up )
PinkDirection:
        FCB        $00                  ;4D29                DB 0   ;Pink Ghost Direction ( 0=right, 1=down, 2=left, 3=up )
BlueDirection:
        FCB        $00                  ;4D2A                DB 0   ;Blue Ghost Direction ( 0=right, 1=down, 2=left, 3=up )
OrangeDirection:
        FCB        $00                  ;4D2B                DB 0   ;Orange Ghost Direction ( 0=right, 1=down, 2=left, 3=up )
RedEyeDir:
        FCB        $00                  ;4D2C                DB 0   ;Red Ghost Eye Direction ( 0=right, 1=down, 2=left, 3=up )
PinkEyeDir:
        FCB        $00                  ;4D2D                DB 0   ;Pink Ghost Eye Direction ( 0=right, 1=down, 2=left, 3=up )
BlueEyeDir:
        FCB        $00                  ;4D2E                DB 0   ;Blue Ghost Eye Direction ( 0=right, 1=down, 2=left, 3=up )
OrangeEyeDir:
        FCB        $00                  ;4D2F                DB 0   ;Orange Ghost Eye Direction ( 0=right, 1=down, 2=left, 3=up )
byte_4D30:
        FCB        $00                  ;4D30                DB 0   ;Pacman Direction (0=right, 1=down, 2=left, 3=up) Mouth pointer?
word_4D31:
        FDB        $0000                ;4D31                DW 0   Red Ghost compare X & Y with Pacman X & Y for collision
word_4D33:     
        FDB        $0000                ;4D33                DW 0   Pink Ghost compare X & Y with Pacman X & Y for collision
word_4D35:     
        FDB        $0000                ;4D35                DW 0   Blue Ghost compare X & Y with Pacman X & Y for collision
word_4D37:     
        FDB        $0000                ;4D37                DW 0   Orange Ghost compare X & Y with Pacman X & Y for collision
PacXPos:
        FCB        $00                  ;4D39                DB 0   ;Pacman X (21-3A)
PacYPos:
        FCB        $00                  ;4D3A                DB 0   ;Pacman Y (22-3E)
GhostEyesDir:
        FCB        $00                  ;4D3B                DB 0   ;Ghost (eyes?) direction [TEMP] ( 0=right, 1=down, 2=left, 3=up )
PacDirection:
        FCB        $00                  ;4D3C                DB 0   ;Pacman direction ( 0=right, 1=down, 2=left, 3=up )
byte_4D3D:
        FCB        $00                  ;4D3D                DB 0
GhostXYPos:
        FDB        $0000                ;4D3E                DW 0   ;Ghost X (21-3A), Ghost Y (22-3E),
GhostsThinkPacX:
        FCB        $00                  ;4D40                DB 0   ;Ghost's perceived Pacman X (21-3A)/22 when Ghosts ignoring
GhostsThinkPacY:
        FCB        $00                  ;4D41                DB 0   ;Ghost's perceived Pacman Y (22-3E)/1D when Ghosts ignoring,
                                                                    ;Red - Red sees exactly where pacman was a split second before
GhostXWarped:
        FCB        $00                  ;4D42                DW 0   ;Ghost X (21-3A), Ghost Y (22-3E) - but warped somehow
GhostYWarped:
        FCB        $00                  ;4D43                DW 0   ;
word_4D44:
        FDB        $0000                ;4D44                DW 0
word_4D46:     
        FDB        $0000                ;4D46                DW 0
word_4D48:     
        FDB        $0000                ;4D48                DW 0
word_4D4A:     
        FDB        $0000                ;4D4A                DW 0
word_4D4C:     
        FDB        $0000                ;4D4C                DW 0
word_4D4E:     
        FDB        $0000                ;4D4E                DW 0
word_4D50:     
        FDB        $0000                ;4D50                DW 0
word_4D52:     
        FDB        $0000                ;4D52                DW 0
word_4D54:     
        FDB        $0000                ;4D54                DW 0
word_4D56:     
        FDB        $0000                ;4D56                DW 0
word_4D58:     
        FDB        $0000                ;4D58                DW 0
word_4D5A:     
        FDB        $0000                ;4D5A                DW 0
word_4D5C:     
        FDB        $0000                ;4D5C                DW 0
word_4D5E:     
        FDB        $0000                ;4D5E                DW 0
word_4D60:     
        FDB        $0000                ;4D60                DW 0
word_4D62:     
        FDB        $0000                ;4D62                DW 0
word_4D64:     
        FDB        $0000                ;4D64                DW 0
word_4D66:     
        FDB        $0000                ;4D66                DW 0
word_4D68:     
        FDB        $0000                ;4D68                DW 0
word_4D6A:     
        FDB        $0000                ;4D6A                DW 0
word_4D6C:     
        FDB        $0000                ;4D6C                DW 0
word_4D6E:     
        FDB        $0000                ;4D6E                DW 0
word_4D70:     
        FDB        $0000                ;4D70                DW 0
word_4D72:     
        FDB        $0000                ;4D72                DW 0
word_4D74:     
        FDB        $0000                ;4D74                DW 0
word_4D76:     
        FDB        $0000                ;4D76                DW 0
word_4D78:     
        FDB        $0000                ;4D78                DW 0
word_4D7A:     
        FDB        $0000                ;4D7A                DW 0
word_4D7C:     
        FDB        $0000                ;4D7C                DW 0
word_4D7E:     
        FDB        $0000                ;4D7E                DW 0
word_4D80:     
        FDB        $0000                ;4D80                DW 0
word_4D82:     
        FDB        $0000                ;4D82                DW 0
word_4D84:     
        FDB        $0000                ;4D84                DW 0
byte_4D86:
        FCB        $00                  ;4D86                DB 0                  
        FCB        $00                  ;4D87                DB 0                  
        FCB        $00                  ;4D88                DB 0                  
        FCB        $00                  ;4D89                DB 0                  
        FCB        $00                  ;4D8A                DB 0                  
        FCB        $00                  ;4D8B                DB 0                  
        FCB        $00                  ;4D8C                DB 0                  
        FCB        $00                  ;4D8D                DB 0                  
        FCB        $00                  ;4D8E                DB 0                  
        FCB        $00                  ;4D8F                DB 0                  
        FCB        $00                  ;4D90                DB 0                  
        FCB        $00                  ;4D91                DB 0                  
        FCB        $00                  ;4D92                DB 0                  
        FCB        $00                  ;4D93                DB 0                  
byte_4D94:     
        FCB        $00                  ;4D94                DB 0
word_4D95:     
        FDB        $0000                ;4D95                DW 0
word_4D97:     
        FDB        $0000                ;4D97                DW 0
byte_4D99:     
        FCB        $00                  ;4D99                DB 0
byte_4D9A:     
        FCB        $00                  ;4D9A                DB 0
byte_4D9B:     
        FCB        $00                  ;4D9B                DB 0
byte_4D9C:     
        FCB        $00                  ;4D9C                DB 0
byte_4D9D:     
        FCB        $00                  ;4D9D                DB 0    Status byte if = 6 then make all ghosts Dark Blue and running away mode
byte_4D9E:     
        FCB        $00                  ;4D9E                DB 0    Stored number of pellets eaten after being read from 4E0E PelletsEaten
byte_4D9F:
        FCB        $00                  ;4D9F                DB 0
;==================
; ghost substates
; 0=home,1=going for pac-man
; 2=crossing the door
; 3=going to the door
;==================
RedSubstate:     
        FCB        $00                  ;4DA0                DB 0
PinkSubstate:     
        FCB        $00                  ;4DA1                DB 0
BlueSubstate:     
        FCB        $00                  ;4DA2                DB 0
OrangeSubstate:     
        FCB        $00                  ;4DA3                DB 0
DeadGhostIndex:     
        FCB        $00                  ;4DA4                DB 0                   # of ghost killed but no collision for yet [0..4]
PacManDeathAnim:     
        FCB        $00                  ;4DA5                DB 0                   anim state,0 if not dead
PillEffect:     
        FCB        $00                  ;4DA6                DB 0                   0 = no effect,1=active or 0 = normal, 1 = ghosts blue, running away
RedGhostFlag:     
        FCB        $00                  ;4DA7                DB 0                   Red Ghost Flag 0 = Normal 1= Dark Blue
PinkGhostFlag:     
        FCB        $00                  ;4DA8                DB 0                   Pink Ghost Flag 0 = Normal 1= Dark Blue
BlueGhostFlag:     
        FCB        $00                  ;4DA9                DB 0                   Blue Ghost Flag 0 = Normal 1= Dark Blue
OrangeGhostFlag:     
        FCB        $00                  ;4DAA                DB 0                   Orange Ghost Flag 0 = Normal 1= Dark Blue
KillingGhostState:     
        FCB        $00                  ;4DAB                DB 0
RedState:     
        FCB        $00                  ;4DAC                DB 0                   Red chomp status ( 0=chase/flee, 1=run back to base, 2=enter base)
PinkState:     
        FCB        $00                  ;4DAD                DB 0                   Pink chomp status ( 0=chase/flee, 1=run back to base, 2=enter base)
BlueState:     
        FCB        $00                  ;4DAE                DB 0                   Blue chomp status ( 0=chase/flee, 1=run back to base, 2=enter base)
OrangeState:     
        FCB        $00                  ;4DAF                DB 0                   Orange chomp status ( 0=chase/flee, 1=run back to base, 2=enter base)
byte_4DB0:     
        FCB        $00                  ;4DB0                DB 0
RedReversalFlag:
        FCB        $00                  ;4DB1                DB 0                   Red reversal (?) (set by frame_counter() and set to 1 when power pill is eaten)
PinkReversalFlag:
        FCB        $00                  ;4DB2                DB 0                   Pink reversal (?) (set by frame_counter() and set to 1 when power pill is eaten)
BlueReversalFlag:
        FCB        $00                  ;4DB3                DB 0                   Blue reversal (?) (?) (set by frame_counter() and set to 1 when power pill is eaten)
OrangeReversalFlag:
        FCB        $00                  ;4DB4                DB 0                   Orange reversal (?) (?) (set by frame_counter() and set to 1 when power pill is eaten)
byte_4DB5:
        FCB        $00                  ;4DB5                DB 0                   ??Set to 1 when power pill is eaten
;======================
;Difficulty settings
;======================
byte_4DB6:     
        FCB        $00                  ;4DB6                DB 0                   1 if 224 dots have been eaten and all 4 ghosts are free, 0 otherwise
byte_4DB7:     
        FCB        $00                  ;4DB7                DB 0
PinkCountLimit:     
        FCB        $00                  ;4DB8                DB 0                 ; when ghost counter reaches this it leaves home
BlueCountLimit:     
        FCB        $00                  ;4DB9                DB 0
OrangeCountLimit:     
        FCB        $00                  ;4DBA                DB 0
PillLimit1:     
        FCB        $00                  ;4DBB                DB 0                   when this reached first difficulty flag set
PillLimit2:     
        FCB        $00                  ;4DBC                DB 0                 ; when this reached 2nd difficulty flag set
GhostTime2:     
        FDB        $0000                ;4DBD                DW 0                   time the ghosts stay when Pac-Man eats energizer
PacManTunnel:     
        FCB        $00                  ;4DBF                DB 0                   1 = Pac-Man entering tunnel,Else 0
;=====================
; Counters
;=====================
AnimFrame:     
        FCB        $00                  ;4DC0                DB 0                   changes every 8 ticks,used for animations
GhostRevStat:
        FCB        $00                  ;4DC1                DB 0                   ghost reversal status (altered by timer at $4DC2/3
FramesFromStart:
        FDB        $0000                ;4DC2                DW 0                   chase frames since board/pac start (paused during powerpill)
Counter8:     
        FCB        $00                  ;4DC4                DB 0                   Counts 0...7 for things killed every 8 ticks?
word_4DC5:     
        FDB        $0000                ;4DC5                DW 0
byte_4DC7:     
        FCB        $00                  ;4DC7                DB 0
byte_4DC8:     
        FCB        $00                  ;4DC8                DB 0                   ??Set to 0 when power pill eaten
RandSeed:
        FDB        $0000                ;4DC9                DW 0
word_4DCB:     
        FDB        $0000                ;4DCB                DW 0                   ; Probably countdown timer for how long ghosts stay Dark Blue
        FCB        $00                  ;4DCD                DB 0
FrameCount_0to255:
        FCB        $00                  ;4DCE                DB 0                   0-255 repeating frame counter?
FrameCount_0to9:
        FCB        $00                  ;4DCF                DB 0                   0-9 repeating frame counter?
GhostsEaten:
        FCB        $00                  ;4DD0                DB 0                   how many ghosts eaten this powerpill?
byte_4DD1:     
        FCB        $00                  ;4DD1                DB 0                   Pointer to a CallFunction point
FruitXPos:
        FCB        $00                  ;4DD2                DW 0
FruitYPos:
        FCB        $00
FruitPointer:     
        FDB        $0000                ;4DD4                DW 0                   or 0 if no fruit
LEDState:     
        FCB        $00                  ;4DD6                DB 0
        FCB        $00                  ;4DD7                DB 0                  
        FCB        $00                  ;4DD8                DB 0                  
        FCB        $00                  ;4DD9                DB 0                  
        FCB        $00                  ;4DDA                DB 0                  
        FCB        $00                  ;4DDB                DB 0                  
        FCB        $00                  ;4DDC                DB 0                  
        FCB        $00                  ;4DDD                DB 0                  
        FCB        $00                  ;4DDE                DB 0                  
        FCB        $00                  ;4DDF                DB 0                  
        FCB        $00                  ;4DE0                DB 0                  
        FCB        $00                  ;4DE1                DB 0                  
        FCB        $00                  ;4DE2                DB 0                  
        FCB        $00                  ;4DE3                DB 0                  
        FCB        $00                  ;4DE4                DB 0                  
        FCB        $00                  ;4DE5                DB 0                  
        FCB        $00                  ;4DE6                DB 0                  
        FCB        $00                  ;4DE7                DB 0                  
        FCB        $00                  ;4DE8                DB 0                  
        FCB        $00                  ;4DE9                DB 0                  
        FCB        $00                  ;4DEA                DB 0                  
        FCB        $00                  ;4DEB                DB 0                  
        FCB        $00                  ;4DEC                DB 0                  
        FCB        $00                  ;4DED                DB 0                  
        FCB        $00                  ;4DEE                DB 0                  
        FCB        $00                  ;4DEF                DB 0                  
        FCB        $00                  ;4DF0                DB 0                  
        FCB        $00                  ;4DF1                DB 0                  
        FCB        $00                  ;4DF2                DB 0                  
        FCB        $00                  ;4DF3                DB 0                  
        FCB        $00                  ;4DF4                DB 0                  
        FCB        $00                  ;4DF5                DB 0                  
        FCB        $00                  ;4DF6                DB 0                  
        FCB        $00                  ;4DF7                DB 0                  
        FCB        $00                  ;4DF8                DB 0                  
        FCB        $00                  ;4DF9                DB 0                  
        FCB        $00                  ;4DFA                DB 0                  
        FCB        $00                  ;4DFB                DB 0                  
        FCB        $00                  ;4DFC                DB 0                  
        FCB        $00                  ;4DFD                DB 0                  
        FCB        $00                  ;4DFE                DB 0                  
        FCB        $00                  ;4DFF                DB 0
* Moved to Direct Page inside Main Program source code
MainMode:
        FCB        $00                  ;4E00                DB 0   ;     $4E00 - Sound Bank switcher
                                                                    ;             00 - Post-boot blanking
                                                                    ;             01 - Attract Screen
                                                                    ;             02 - Push Start / Get Ready
                                                                    ;             03 - Gameplay
                                                                    ;             0=init,1=demo,2=coin inserted,3 = playing
                                                                    ;             Also number of players? TODO
MainSub0:
        FCB        $00                  ;4E01                DB 0                   main routine 0,subroutine #
MainSub1:
        FCB        $00                  ;4E02                DB 0   ;     $4E02 - Attract screen 'frames'
                                                                    ;             01 - Character / Nickname
                                                                    ;             03 - Red Ghost
                                                                    ;             05 - Shadow
                                                                    ;             07 - "Blinky"
                                                                    ;             09 - Pink Ghost
                                                                    ;             0B - Speedy
                                                                    ;             0D - "Pinky"
                                                                    ;             0F - Aqua Ghost
                                                                    ;             11 - Bashful
                                                                    ;             13 - "Inky"
                                                                    ;             15 - Yellow Ghost
                                                                    ;             17 - Pokey
                                                                    ;             19 - "Clyde"
                                                                    ;             1B - 10pts dot, 50pts dot
                                                                    ;             1D - &copy; 1980 MIDWAY MFG.CO.
                                                                    ;             1E-22 - Pacman Entrance, Ghost 1-4 Entrance
                                                                    ;             23 - demo game
MainSub2:
        FCB        $00                  ;4E03                DB 0   ;     $4E03 - Mode
                                                                    ;             00 - Attract Screen + Gameplay
                                                                    ;             01 - Push Start Button
                                                                    ;             03 - Game Start (Ready!)

CurrentTaskNumber:
        FCB        $00                  ;4E04                DB 0   ;   $4E04 - Game 'frames'
                                                                    ;             00 - ?
                                                                    ;             02 - Maze, Ghosts, Pacman, Ready!
                                                                    ;             03 - Running game
                                                                    ;             09 - player change?
                                                                    ;             07 - Game Over
                                                                    ;             0D-1F - Level Clear Maze Flash
                                                                    ;             20 - Act 1/2/3
                                                                    ;             21-24 - Clear Level  3=ghost move,2=ghost wait for start (set to 2 to pause game)
        FCB        $00                  ;4E05                DB 0
CutSceneState1:
        FCB        $00                  ;4E06                DB 0           ;     $4E06 - Act I Scenes
                                                                    ;             00 - Clear Screen
                                                                    ;             01 - Ghost and Pac across Screen
                                                                    ;             02-03 - Ghost and Pac offscreen
                                                                    ;             04 - Ghost going right
                                                                    ;             05 - Bigpac chasing
                                                                    ;             06 - Ghost offscreen
                                                                    ;             00 - Clear Screen
CutSceneState2:
        FCB        $00                  ;4E07                DB 0   ;     $4E07 - Act II Scenes
                                                                    ;             00 - Clear Screen
                                                                    ;             01 - Pac Appears
                                                                    ;             02 - Ghost Appears
                                                                    ;             03 - Pac passes peg
                                                                    ;             04-08 - Ghost Ripping sheet
                                                                    ;             0A - Ghost Looks up
                                                                    ;             0C - Ghost Looks at peg
CutSceneState3:
        FCB        $00                  ;4E08                DB 0   ;     $4E08 - Act III Scenes
                                                                    ;             00 - Clear screen
                                                                    ;             01 - Pac and Ghost
                                                                    ;             02 - Pac and Ghost offscreen
                                                                    ;             03-04 - unrobed ghost moving rightPlayerNumber:
CurPlayerNumber:
        FCB        $00                  ;4E09                DB 0                 0=P1,1=P2 - current player ( 0=Player1, !0= Player2 )
DifficultyPtr:
        FDB        $0000                ;4E0A                DW 0
FruitFlag1:
        FCB        $00                  ;4E0C                DB 0                   if first fruit has appeared - 0 if num_dots_eaten < 0x40, 1 otherwise
FruitFlag2:
        FCB        $00                  ;4E0D                DB 0                   if second fruit has appeared - 0 if num_dots_eaten < 0xB0, 1 otherwise
PelletsEaten:
        FCB        $00                  ;4E0E                DB 0                   pellets eaten this level
PinkExitCounter:
        FCB        $00                  ;4E0F                DB 0                   counter used to make ghost leave home
BlueExitCounter:
        FCB        $00                  ;4E10                DB 0                   counter used to make ghost leave home
OrangeExitCounter:
        FCB        $00                  ;4E11                DB 0                   counter used to make ghost leave home
byte_4E12:     
        FCB        $00                  ;4E12                DB 0
LevelNumber:     
        FCB        $00                  ;4E13                DB 0
LivesNumber:
        FCB        $00                  ;4E14                DB 0
LivesDisplay:     
        FCB        $00                  ;4E15                DB 0
;======================
; 4e16-4e33 0x13 pill data entries. each bit means if a pill is there
;    not (1=yes 0=no)
;    the pills start at upper right corner,go down,then left.
;    first pill is bit 7 of 4e16
;======================
PelletBits:     
        FCB        $00,$00,$00,$00		;4E16                DL 0   ;bit mask of what dots have/have not been eaten yet
        FCB        $00,$00,$00,$00		;4E1A                DL 0
        FCB        $00,$00,$00,$00		;4E1E                DL 0                  
        FCB        $00,$00,$00,$00		;4E22                DL 0                  
        FCB        $00,$00,$00,$00		;4E26                DL 0                  
        FCB        $00,$00,$00,$00		;4E2A                DL 0                  
        FCB        $00,$00,$00,$00		;4E2E                DL 0                  
        FDB        $0000        		;4E32                DW 0                  
EnergizerPos:     
        FCB        $00                  ;4E34                DB 0           ;Power Pill Status -  0x14 = not eaten, 0x40 - eaten (really, the indexes of the Pill characters)
        FCB        $00                  ;4E35                DB 0
        FCB        $00                  ;4E36                DB 0                  
        FCB        $00                  ;4E37                DB 0                  
DataCopy:     
        FCB        $00                  ;4E38                DB 0                 ; copy of level data 4E38-4E65
;                                         copy from 4e0a-4e37
        FCB        $00                  ;4E39                DB 0                  
        FCB        $00                  ;4E3A                DB 0                  
        FCB        $00                  ;4E3B                DB 0                  
        FCB        $00                  ;4E3C                DB 0                  
        FCB        $00                  ;4E3D                DB 0                  
        FCB        $00                  ;4E3E                DB 0                  
        FCB        $00                  ;4E3F                DB 0                  
        FCB        $00                  ;4E40                DB 0                  
        FCB        $00                  ;4E41                DB 0                  
byte_4E42:     
        FCB        $00                  ;4E42                DB 0
        FCB        $00                  ;4E43                DB 0                  
        FCB        $00                  ;4E44                DB 0                  
        FCB        $00                  ;4E45                DB 0                  
        FCB        $00                  ;4E46                DB 0                  
        FCB        $00                  ;4E47                DB 0                  
        FCB        $00                  ;4E48                DB 0                  
        FCB        $00                  ;4E49                DB 0                  
        FCB        $00                  ;4E4A                DB 0                  
        FCB        $00                  ;4E4B                DB 0                  
        FCB        $00                  ;4E4C                DB 0                  
        FCB        $00                  ;4E4D                DB 0                  
        FCB        $00                  ;4E4E                DB 0                  
        FCB        $00                  ;4E4F                DB 0                  
        FCB        $00                  ;4E50                DB 0                  
        FCB        $00                  ;4E51                DB 0                  
        FCB        $00                  ;4E52                DB 0                  
        FCB        $00                  ;4E53                DB 0                  
        FCB        $00                  ;4E54                DB 0                  
        FCB        $00                  ;4E55                DB 0                  
        FCB        $00                  ;4E56                DB 0                  
        FCB        $00                  ;4E57                DB 0                  
        FCB        $00                  ;4E58                DB 0                  
        FCB        $00                  ;4E59                DB 0                  
        FCB        $00                  ;4E5A                DB 0                  
        FCB        $00                  ;4E5B                DB 0                  
        FCB        $00                  ;4E5C                DB 0                  
        FCB        $00                  ;4E5D                DB 0                  
        FCB        $00                  ;4E5E                DB 0                  
        FCB        $00                  ;4E5F                DB 0                  
        FCB        $00                  ;4E60                DB 0                  
        FCB        $00                  ;4E61                DB 0                  
        FCB        $00                  ;4E62                DB 0                  
        FCB        $00                  ;4E63                DB 0                  
        FCB        $00                  ;4E64                DB 0                  
        FCB        $00                  ;4E65                DB 0                  
CoinState:     
        FCB        $00                  ;4E66                DB 0                   Coin state shifted left 1
byte_4E67:     
        FCB        $00                  ;4E67                DB 0                   Count up from 0x00..0x0F  Sound for coin2?  Debounce?
byte_4E68:     
        FCB        $00                  ;4E68                DB 0                   Count up from 0x00..0x0F  Sound for coin2?  Debounce?
NumCoinsPlaySnd:
        FCB        $00                  ;4E69                DB 0                   Number of coins to announce via sound
byte_4E6A:     
        FCB        $00                  ;4E6A                DB 0
CoinPerCredit:     
        FCB        $00                  ;4E6B                DB 0                   coins needed per credit
LeftOverCoins:     
        FCB        $00                  ;4E6C                DB 0                 ; partial credits
CreditsPerCoin:     
        FCB        $00                  ;4E6D                DB 0                   Credits ( per coin )
Credits:     
        FCB        $00                  ;4E6E                DB 0                   Credits
LivesPerGame:     
        FCB        $00                  ;4E6F                DB 0                   Lives per game
byte_4E70:     
        FCB        $00                  ;4E70                DB 0					; Also has to do with lives (maybe lives left)
BonusLifeVal:     
        FCB        $00                  ;4E71                DB 0                   0x10 = 10000, Kilopoints for bonus pac in BCD. FF = no bonus
;                                                                                   0x15 = 15000
;                                                                                   0x20 = 20000
;                                                                                   0xff = none
;
CocktailMode:     
        FCB        $00                  ;4E72                DB 0                   Upright ( 0 ) vs Cocktail ( 1 )
DifficultyMode:
        FDB        $0000                ;4E73                DW 0                   Difficulty ( Normal=0x6800, Hard=0x7D00 )
GhostNames:     
        FCB        $00                  ;4E75                DB 0                   0=normal,1 = alternate
        FCB        $00                  ;4E76                DB 0                  
        FCB        $00                  ;4E77                DB 0                  
        FCB        $00                  ;4E78                DB 0                  
        FCB        $00                  ;4E79                DB 0                  
        FCB        $00                  ;4E7A                DB 0                  
        FCB        $00                  ;4E7B                DB 0                  
        FCB        $00                  ;4E7C                DB 0                  
        FCB        $00                  ;4E7D                DB 0                  
        FCB        $00                  ;4E7E                DB 0                  
        FCB        $00                  ;4E7F                DB 0
;==================
; Score AABBCC
;==================
P1Score:     
        FCB        $00                  ;4E80                DB 0                   80=AA,81=BB,82=CC,Player 1 score in BCD
        FCB        $00                  ;4E81                DB 0                  
        FCB        $00                  ;4E82                DB 0
BonusLife1:
        FCB        $00                  ;4E83                DB 0                   player 1 got a bonus life? 1 = yes
P2Score:     
        FCB        $00                  ;4E84                DB 0                   84=AA,85=BB,86=CC,Player 2 score in BCD
        FCB        $00                  ;4E85                DB 0                  
        FCB        $00                  ;4E86                DB 0
BonusLife2:     
        FCB        $00                  ;4E87                DB 0                   player 2 got a bonus life? 1 = yes
HighScore:     
        FCB        $00                  ;4E88                DB 0                 ; 88=AA,89=BB,8A=CC,High Score in BCD
        FCB        $00                  ;4E89                DB 0                  
        FDB        $0000                ;4E8A                DW 0                  
CH1_FREQ0:     
        FCB        $00                  ;4E8C                DB 0
        FCB        $00                  ;4E8D                DB 0                  
CH1_FREQ2:     
        FCB        $00                  ;4E8E                DB 0
CH1_FREQ3:     
        FCB        $00                  ;4E8F                DB 0
CH1_FREQ4:     
        FCB        $00                  ;4E90                DB 0
CH1_VOL:     
        FCB        $00                  ;4E91                DB 0
CH2_FREQ1:     
        FCB        $00                  ;4E92                DB 0
CH2_FREQ2:     
        FCB        $00                  ;4E93                DB 0
CH2_FREQ3:     
        FCB        $00                  ;4E94                DB 0
CH2_FREQ4:     
        FCB        $00                  ;4E95                DB 0
CH2_VOL:     
        FCB        $00                  ;4E96                DB 0
CH3_FREQ1:     
        FCB        $00                  ;4E97                DB 0
CH3_FREQ2:     
        FCB        $00                  ;4E98                DB 0
CH3_FREQ3:     
        FCB        $00                  ;4E99                DB 0
CH3_FREQ4:     
        FCB        $00                  ;4E9A                DB 0
CH3_VOL:     
        FCB        $00                  ;4E9B                DB 0
CH1_E_NUM:     
        FCB        $00                  ;4E9C                DB 0               Sound 1 Waveform A? ( 0=gameplay, 2=coin drop)
CH1_E_1:     
        FCB        $00                  ;4E9D                DB 0
CH1_E_CUR_BIT:     
        FCB        $00                  ;4E9E                DB 0
CH1_E_TABLE0:     
        FCB        $00                  ;4E9F                DB 0
CH1_E_TABLE1:     
        FCB        $00                  ;4EA0                DB 0
CH1_E_TABLE2:     
        FCB        $00                  ;4EA1                DB 0
CH1_E_TABLE3:     
        FCB        $00                  ;4EA2                DB 0
CH1_E_TABLE4:     
        FCB        $00                  ;4EA3                DB 0
CH1_E_TABLE5:     
        FCB        $00                  ;4EA4                DB 0
CH1_E_TABLE6:     
        FCB        $00                  ;4EA5                DB 0
CH1_E_TABLE7:     
        FCB        $00                  ;4EA6                DB 0
CH1_E_TYPE:     
        FCB        $00                  ;4EA7                DB 0
CH1_E_DURATION:     
        FCB        $00                  ;4EA8                DB 0
CH1_E_DIR:     
        FCB        $00                  ;4EA9                DB 0
CH1_E_BASE_FREQ:     
        FCB        $00                  ;4EAA                DB 0
CH1_E_VOL:     
        FCB        $00                  ;4EAB                DB 0
;this block repeats channel 1 data for channel 2
CH2_DATA:     
        FCB        $00                  ;4EAC                DB 0               Sound 2 Waveform A?
        FCB        $00                  ;4EAD                DB 0                  
        FCB        $00                  ;4EAE                DB 0                  
byte_4EAF:     
        FCB        $00                  ;4EAF                DB 0
        FCB        $00                  ;4EB0                DB 0                  
        FCB        $00                  ;4EB1                DB 0                  
        FCB        $00                  ;4EB2                DB 0                  
        FCB        $00                  ;4EB3                DB 0                  
        FCB        $00                  ;4EB4                DB 0                  
        FCB        $00                  ;4EB5                DB 0                  
        FCB        $00                  ;4EB6                DB 0                  
        FCB        $00                  ;4EB7                DB 0                  
        FCB        $00                  ;4EB8                DB 0                  
        FCB        $00                  ;4EB9                DB 0                  
        FCB        $00                  ;4EBA                DB 0                  
        FCB        $00                  ;4EBB                DB 0                  
;this block repeats channel 1 data for channel 3
CH3_DATA:     
        FCB        $00                  ;4EBC                DB 0               Sound 3 Waveform A?
        FCB        $00                  ;4EBD                DB 0                  
        FCB        $00                  ;4EBE                DB 0                  
byte_4EBF:     
        FCB        $00                  ;4EBF                DB 0
        FCB        $00                  ;4EC0                DB 0                  
        FCB        $00                  ;4EC1                DB 0                  
        FCB        $00                  ;4EC2                DB 0                  
        FCB        $00                  ;4EC3                DB 0                  
        FCB        $00                  ;4EC4                DB 0                  
        FCB        $00                  ;4EC5                DB 0                  
        FCB        $00                  ;4EC6                DB 0                  
        FCB        $00                  ;4EC7                DB 0                  
        FCB        $00                  ;4EC8                DB 0                  
        FCB        $00                  ;4EC9                DB 0                  
        FCB        $00                  ;4ECA                DB 0                  
        FCB        $00                  ;4ECB                DB 0                  
CH1_W_NUM:     
        FCB        $00                  ;4ECC                DB 0               Sound 1 Waveform Selector (0=Gameplay, 1=Intro Music, 2=Intermission Music)
CH1_W_1:     
        FCB        $00                  ;4ECD                DB 0
CH1_W_CUR_BIT:     
        FCB        $00                  ;4ECE                DB 0
CH1_W_SEL:     
        FCB        $00                  ;4ECF                DB 0               Sound 1 Waveform B
CH1_W_4:     
        FCB        $00                  ;4ED0                DB 0
CH1_W_5:     
        FCB        $00                  ;4ED1                DB 0
CH1_W_OFFSET1:     
        FCB        $00                  ;4ED2                DB 0
CH1_W_OFFSET2:     
        FCB        $00                  ;4ED3                DB 0
CH1_W_8:     
        FCB        $00                  ;4ED4                DB 0
CH1_W_9:     
        FCB        $00                  ;4ED5                DB 0
CH1_W_A:     
        FCB        $00                  ;4ED6                DB 0
CH1_W_TYPE:     
        FCB        $00                  ;4ED7                DB 0
CH1_W_DURATION:     
        FCB        $00                  ;4ED8                DB 0
CH1_W_DIR:     
        FCB        $00                  ;4ED9                DB 0
CH1_W_BASE_FREQ:     
        FCB        $00                  ;4EDA                DB 0
CH1_W_VOL:     
        FCB        $00                  ;4EDB                DB 0
CH2_W_NUM:     
        FCB        $00                  ;4EDC                DB 0                   Sound 2 Waveform Selector (0=Gameplay, 1=Intro Music, 2=Intermission Music)
        FCB        $00                  ;4EDD                DB 0                  
        FCB        $00                  ;4EDE                DB 0                  
byte_4EDF:     
        FCB        $00                  ;4EDF                DB 0                   Sound 2 Waveform B
        FCB        $00                  ;4EE0                DB 0                  
        FCB        $00                  ;4EE1                DB 0                  
        FCB        $00                  ;4EE2                DB 0                  
        FCB        $00                  ;4EE3                DB 0                  
        FCB        $00                  ;4EE4                DB 0                  
        FCB        $00                  ;4EE5                DB 0                  
        FCB        $00                  ;4EE6                DB 0                  
        FCB        $00                  ;4EE7                DB 0                  
        FCB        $00                  ;4EE8                DB 0                  
        FCB        $00                  ;4EE9                DB 0                  
        FCB        $00                  ;4EEA                DB 0                  
        FCB        $00                  ;4EEB                DB 0                  
CH3_W_NUM:     
        FCB        $00                  ;4EEC                DB 0                   Sound 3 Waveform Selector (0=Gameplay, 1=Intro Music, 2=Intermission Music)
        FCB        $00                  ;4EED                DB 0                  
        FCB        $00                  ;4EEE                DB 0                  
byte_4EEF:     
        FCB        $00                  ;4EEF                DB 0                   Sound 3 Waveform B
        FCB        $00                  ;4EF0                DB 0                  
        FCB        $00                  ;4EF1                DB 0                  
        FCB        $00                  ;4EF2                DB 0                  
        FCB        $00                  ;4EF3                DB 0                  
        FCB        $00                  ;4EF4                DB 0                  
        FCB        $00                  ;4EF5                DB 0                  
        FCB        $00                  ;4EF6                DB 0                  
        FCB        $00                  ;4EF7                DB 0                  
        FCB        $00                  ;4EF8                DB 0                  
        FCB        $00                  ;4EF9                DB 0                  
        FCB        $00                  ;4EFA                DB 0                  
        FCB        $00                  ;4EFB                DB 0                  
        FCB        $00                  ;4EFC                DB 0                  
        FCB        $00                  ;4EFD                DB 0                  
        FCB        $00                  ;4EFE                DB 0                  
        FCB        $00                  ;4EFF                DB 0                  
;Stack:     
;        FCB        $0],$00                  ;4F00                DB [ 0C0h ],0          4F00-4FBF stack space
Unused:     
;        FCB        $0],$00                  ;4FC0                DB [ 30h ],0           4FC0-4FEF unused
; end of 'RAM'
;======================
; Sprite RAM -
; 8 entries,Each two bytes
; first byte:
;    sprite number 0-63 in bits 7-2
;    x-flip in bit 1
;    y-slip in bit 0
; 2nd byte
;    palette
;=======================
; ===========================================================================
; Segment type: Regular
;                segment HW
;                ORG 4FF0h
Sprite1:     
        FDB        $0000                ;4FF0                DW 0
Sprite2:     
        FDB        $0000                ;4FF2                DW 0
Sprite3:     
        FDB        $0000                ;4FF4                DW 0
Sprite4:     
        FDB        $0000                ;4FF6                DW 0
Sprite5:     
        FDB        $0000                ;4FF8                DW 0
Sprite6:     
        FDB        $0000                ;4FFA                DW 0
Sprite7:     
        FDB        $0000                ;4FFC                DW 0
Sprite8:     
        FDB        $0000                ;4FFE                DW 0
;=========================================
; reading any byte 5000h-503F gives IN0 and coin slot info
; Bit0 - joystick up    if 0
; Bit1 - joystick left  if 0
; Bit2 - joystick right if 0
; Bit3 - joystick down  if 0
; Bit4 - rack advance if 0 (go to next level)
; Bit5 - Coin slot 1 trigger by going from 0 to 1
; Bit6 - Coin slot 2 trigger by going from 0 to 1
; Bit7 - Credit button (0=pressed)
;=========================================
* Moved to Direct Page inside Main Program source code
;IN0_5000:
;        FCB        $00                  ;5000                DB 0                   write 1 enable,0 disable
SoundEnable:     
        FCB        $00                  ;5001                DB 0                   1 enable,0 disable
AuxBoardEnable:     
        FCB        $00                  ;5002                DB 0                   unused
FlipScreen:     
        FCB        $00                  ;5003                DB 0                   0 normal,1 flipped for cocktail
Player1Lamp:     
        FCB        $00                  ;5004                DB 0
Player2Lamp:     
        FCB        $00                  ;5005                DB 0
CoinLockout:     
        FCB        $00                  ;5006                DB 0
CoinCounter:     
        FCB        $00                  ;5007                DB 0
Unused2:         
        FDB        $0000
        FDB        $0000
        FDB        $0000
        FDB        $0000
        FDB        $0000
        FDB        $0000
        FDB        $0000
        FDB        $0000 
;        FCB        $8],$00                  ;5008                DB [ 38h ],0
;=======================
; Reading bytes 5040h-507Fh return IN1
; 2nd player joystick and start buttons
; Bit0 - joystick up    if 0
; Bit1 - joystick left  if 0
; Bit2 - joystick right if 0
; Bit3 - joystick down  if 0
; Bit4 - board test 0 = on
; Bit5 - player 1 start,0 = on
; Bit6 - player 2 start,0 = on
; Bit7 - cocktail mode (0=table,1 = upright)
;=========================================
;=======================
;=======================
; Writing 5040h-507Fh modifies 3
; voice sound programming
; Note voice 1 is 5 nibbles of data,
; other two voices are 4 nibbles
;=======================
* Moved to Direct Page inside Main Program source code
;IN1_5040:
;        FCB        $FF                  ;5040
Voice1Acc:
        FCB        $FF                  ;5040                DB [ 5 ],0             hardware accumulator to advance waveform sample
        FCB        $00
        FCB        $00
        FCB        $00
        FCB        $00
Voice1Waveform:     
        FCB        $00                  ;5045                DB 0                   waveform to play
Voice2Acc:     
        FCB        $00                  ;5046                DB [ 4 ],0
        FCB        $00
        FCB        $00
        FCB        $00
Voice2Waveform:     
        FCB        $00                  ;504A                DB 0
Voice3Acc:     
        FCB        $00                  ;504B                DB [ 4 ],0
        FCB        $00
        FCB        $00
        FCB        $00
Voice3Waveform:     
        FCB        $00                  ;504F                DB 0
Voice1Freq:     
        FCB        $00                  ;5050                DB [ 5 ],0
        FCB        $00
        FCB        $00
        FCB        $00
        FCB        $00
Voice1Volume:     
        FCB        $00                  ;5055                DB 0
Voice2Freq:     
        FCB        $00                  ;5056                DB [ 4 ],0
        FCB        $00
        FCB        $00
        FCB        $00
Voice2Volume:     
        FCB        $00                  ;505A                DB 0
Voice3Freq:     
        FCB        $00                  ;505B                DB [ 4 ],0
        FCB        $00
        FCB        $00
        FCB        $00
Voice3Volume:     
        FCB        $00                  ;505F                DB 0
;=======================
; Sprite x,y locations as bytes
;=======================
Sprite1XPos:     
        FCB        $00                  ;5060                DB 0
Sprite1YPos:     
        FCB        $00                  ;5061                DB 0
Sprite2XPos:     
        FCB        $00                  ;5062                DB 0
Sprite2YPos:     
        FCB        $00                  ;5063                DB 0
Sprite3XPos:     
        FCB        $00                  ;5064                DB 0
Sprite3YPos:     
        FCB        $00                  ;5065                DB 0
Sprite4XPos:     
        FCB        $00                  ;5066                DB 0
Sprite4YPos:     
        FCB        $00                  ;5067                DB 0
Sprite5XPos:     
        FCB        $00                  ;5068                DB 0
Sprite5YPos:     
        FCB        $00                  ;5069                DB 0
Sprite6XPos:     
        FCB        $00                  ;506A                DB 0
Sprite6YPos:     
        FCB        $00                  ;506B                DB 0
Sprite7XPos:     
        FCB        $00                  ;506C                DB 0
Sprite7YPos:     
        FCB        $00                  ;506D                DB 0
Sprite8XPos:     
        FCB        $00                  ;506E                DB 0
Sprite8YPos:     
        FCB        $00                  ;506F                DB 0
Unused3:     
        FCB        $00                  ;5070                DB [ 10h ],0           Is this really unused?
        FCB        $00
        FCB        $00
        FCB        $00
        FCB        $00
        FCB        $00
        FCB        $00
        FCB        $00
        FCB        $00
        FCB        $00
        FCB        $00
        FCB        $00
        FCB        $00
        FCB        $00
        FCB        $00
        FCB        $00
        FCB        $00
;=======================
; Each byte 5080h-50BFh return same value
;=======================
;Bit
;0,1:   Coins per game:
;       0=free play
;       1=1 coin 1 Credit
;       2=1 coin 2 Credits
;       3=2 coins 1 Credit
;2,3    # lives per game:
;       0=1 life
;       1=2 lives
;       2=3 lives
;       3=5 lives
;4,5    Bonus score for extra life:
;       0=10000 points
;       1=15000 points
;       2=20000 points
;       3=none
;6      Difficulty (jumper pad):
;       0 = hard
;       1 = normal
;7      Ghost names(jumper pad):
;       0=alternate
;       1 = normal
;         bits 76543210
; Set as $C9 = 11001001
;----------------------------------------
DipSwitch:
;              bits 76543210
* Original
*        FCB        %11001001        ;5080                DB [ 40h ],0

* testing...
;              bits 76543210
        FCB        %11001001        ;5080                DB [ 40h ],0

        FCB        $00
        FCB        $00
        FCB        $00
        FCB        $00
        FCB        $00
        FCB        $00
        FCB        $00
        FCB        $00
        FCB        $00
        FCB        $00
        FCB        $00
        FCB        $00
        FCB        $00
        FCB        $00
        FCB        $00
        FCB        $00
;=======================
; Each byte 50C0h-50FFh return same value
;=======================
WatchdogReset:     
        FCB        $00                  ;50C0                DB [ 40h ],0
        FCB        $00
        FCB        $00
        FCB        $00
        FCB        $00
        FCB        $00
        FCB        $00
        FCB        $00
        FCB        $00
        FCB        $00
        FCB        $00
        FCB        $00
        FCB        $00
        FCB        $00
        FCB        $00
        FCB        $00
        FCB        $00

; ----
; sound packet IX:
; 0   1   2   3   4   5   6   7   8   9  10  11  12  13  14  15
; M       PS  S   S   S   S   S   S   S  S   VS1         T1  VS2
; 
; SQ = Sound Queue
; PS = Process Sound Data
; [M==PS==0 -> blindly return without processing sound data]
; S = copied from HL+((B-1)*8) [b=leftmost bit of $IX)
; VS1 = Volume Strategy (which RST20 @ 12033 to use?)
; VS2 = Parameter for vol strategy
; [note: if VS1&8==0, vol=VS2=9]
; T1 = Frequency scratch (for nybble-shifting)
